/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.bean;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.tapestry.IBeanProvider;
import org.apache.tapestry.IComponent;
import org.apache.tapestry.services.ExpressionEvaluator;

/**
 * Initializes a helper bean property from an OGNL expression (relative to the bean's
 * {@link IComponent}).
 * 
 * @author Howard Lewis Ship
 * @since 2.2
 */

public class ExpressionBeanInitializer extends AbstractBeanInitializer
{public static com.cortexeb.tools.clover.d __CLOVER_46_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1097439627296L);
    protected String _expression;

    private final ExpressionEvaluator _evaluator;

    public ExpressionBeanInitializer(ExpressionEvaluator evaluator)
    {try { __CLOVER_46_0.M[2950]++;
        __CLOVER_46_0.S[12131]++;_evaluator = evaluator;
    } finally { }}

    public void setBeanProperty(IBeanProvider provider, Object bean)
    {try { __CLOVER_46_0.M[2951]++;
        __CLOVER_46_0.S[12132]++;IComponent component = provider.getComponent();

        __CLOVER_46_0.S[12133]++;try
        {
            __CLOVER_46_0.S[12134]++;Object value = _evaluator.read(component, _expression);

            __CLOVER_46_0.S[12135]++;setBeanProperty(bean, value);
        }
        catch (Exception ex)
        {
            __CLOVER_46_0.S[12136]++;throw new ApplicationRuntimeException(ex.getMessage(), getLocation(), ex);
        }
    } finally { }}

    /** @since 3.0 * */

    public String getExpression()
    {try { __CLOVER_46_0.M[2952]++;
        __CLOVER_46_0.S[12137]++;return _expression;
    } finally { }}

    /** @since 3.0 * */

    public void setExpression(String expression)
    {try { __CLOVER_46_0.M[2953]++;
        __CLOVER_46_0.S[12138]++;_expression = expression;
    } finally { }}

}