/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.engine;

import java.io.IOException;

import javax.servlet.ServletException;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.tapestry.IComponent;
import org.apache.tapestry.IPage;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.Tapestry;
import org.apache.tapestry.request.RequestContext;
import org.apache.tapestry.request.ResponseOutputStream;
import org.apache.tapestry.services.ResponseRenderer;

/**
 * Basic server for creating a link to another page in the application.
 * 
 * @author Howard Lewis Ship
 * @since 1.0.9
 */

public class PageService extends AbstractService
{public static com.cortexeb.tools.clover.d __CLOVER_100_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1097439627296L);
    /** @since 3.1 */
    private ResponseRenderer _responseRenderer;

    public ILink getLink(IRequestCycle cycle, IComponent component, Object[] parameters)
    {try { __CLOVER_100_0.M[3043]++;
        __CLOVER_100_0.S[12546]++;if ((((Tapestry.size(parameters) != 1) && (++__CLOVER_100_0.CT[2148] != 0)) || (++__CLOVER_100_0.CF[2148] == 0))){
            __CLOVER_100_0.S[12547]++;throw new IllegalArgumentException(Tapestry.format(
                    "service-single-parameter",
                    Tapestry.PAGE_SERVICE));}

        __CLOVER_100_0.S[12548]++;return constructLink(cycle, Tapestry.PAGE_SERVICE, new String[]
        { (String) parameters[0] }, null, true);

    } finally { }}

    public void service(IEngineServiceView engine, IRequestCycle cycle, ResponseOutputStream output)
            throws ServletException, IOException
    {try { __CLOVER_100_0.M[3044]++;
        __CLOVER_100_0.S[12549]++;RequestContext context = cycle.getRequestContext();
        __CLOVER_100_0.S[12550]++;String[] serviceContext = getServiceContext(context);

        __CLOVER_100_0.S[12551]++;if ((((Tapestry.size(serviceContext) != 1) && (++__CLOVER_100_0.CT[2149] != 0)) || (++__CLOVER_100_0.CF[2149] == 0))){
            __CLOVER_100_0.S[12552]++;throw new ApplicationRuntimeException(Tapestry.format(
                    "service-single-parameter",
                    Tapestry.PAGE_SERVICE));}

        __CLOVER_100_0.S[12553]++;String pageName = serviceContext[0];

        // At one time, the page service required a session, but that is no longer necessary.
        // Users can now bookmark pages within a Tapestry application. Pages
        // can implement validate() and throw a PageRedirectException if they don't
        // want to be accessed this way. For example, most applications have a concept
        // of a "login" and have a few pages that don't require the user to be logged in,
        // and other pages that do. The protected pages should redirect to a login page.

        __CLOVER_100_0.S[12554]++;IPage page = cycle.getPage(pageName);

        __CLOVER_100_0.S[12555]++;cycle.activate(page);

        __CLOVER_100_0.S[12556]++;_responseRenderer.renderResponse(cycle, output);
    } finally { }}

    public String getName()
    {try { __CLOVER_100_0.M[3045]++;
        __CLOVER_100_0.S[12557]++;return Tapestry.PAGE_SERVICE;
    } finally { }}

    /** @since 3.1 */
    public void setResponseRenderer(ResponseRenderer responseRenderer)
    {try { __CLOVER_100_0.M[3046]++;
        __CLOVER_100_0.S[12558]++;_responseRenderer = responseRenderer;
    } finally { }}
}