/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.engine;

import java.io.IOException;

import javax.servlet.ServletException;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.tapestry.IComponent;
import org.apache.tapestry.IPage;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.Tapestry;
import org.apache.tapestry.request.ResponseOutputStream;
import org.apache.tapestry.services.ResetEventCoordinator;
import org.apache.tapestry.services.ResponseRenderer;

/**
 * ServiceLink used to discard all cached data (templates, specifications, et cetera). This is
 * primarily used during development. It could be a weakness of a Tapestry application, making it
 * susceptible to denial of service attacks, which is why it is disabled by default. The link
 * generated by the ResetService redisplays the current page after discarding all data.
 * 
 * @author Howard Lewis Ship
 * @since 1.0.9
 * @see org.apache.tapestry.IEngine#isResetServiceEnabled()
 */

public class ResetService extends AbstractService
{public static com.cortexeb.tools.clover.d __CLOVER_103_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1097439627296L);
    /** @since 3.1 */

    private ResponseRenderer _responseRenderer;
    
    /** @since 3.1 */
    
    private ResetEventCoordinator _resetEventCoordinator;

    public ILink getLink(IRequestCycle cycle, IComponent component, Object[] parameters)
    {try { __CLOVER_103_0.M[3047]++;
        __CLOVER_103_0.S[12559]++;if ((((Tapestry.size(parameters) != 0) && (++__CLOVER_103_0.CT[2150] != 0)) || (++__CLOVER_103_0.CF[2150] == 0))){
            __CLOVER_103_0.S[12560]++;throw new IllegalArgumentException(Tapestry.format(
                    "service-no-parameters",
                    Tapestry.RESET_SERVICE));}

        __CLOVER_103_0.S[12561]++;String[] context = new String[1];
        __CLOVER_103_0.S[12562]++;context[0] = component.getPage().getPageName();

        __CLOVER_103_0.S[12563]++;return constructLink(cycle, Tapestry.RESET_SERVICE, context, null, true);
    } finally { }}

    public String getName()
    {try { __CLOVER_103_0.M[3048]++;
        __CLOVER_103_0.S[12564]++;return Tapestry.RESET_SERVICE;
    } finally { }}

    public void service(IEngineServiceView engine, IRequestCycle cycle, ResponseOutputStream output)
            throws ServletException, IOException
    {try { __CLOVER_103_0.M[3049]++;
        __CLOVER_103_0.S[12565]++;String[] context = getServiceContext(cycle.getRequestContext());

        __CLOVER_103_0.S[12566]++;if ((((Tapestry.size(context) != 1) && (++__CLOVER_103_0.CT[2151] != 0)) || (++__CLOVER_103_0.CF[2151] == 0))){
            __CLOVER_103_0.S[12567]++;throw new ApplicationRuntimeException(Tapestry.format(
                    "service-single-parameter",
                    Tapestry.RESET_SERVICE));}

        __CLOVER_103_0.S[12568]++;String pageName = context[0];

        __CLOVER_103_0.S[12569]++;if ((((engine.isResetServiceEnabled()) && (++__CLOVER_103_0.CT[2152] != 0)) || (++__CLOVER_103_0.CF[2152] == 0))){
            __CLOVER_103_0.S[12570]++;_resetEventCoordinator.fireResetEvent();}
        
        __CLOVER_103_0.S[12571]++;IPage page = cycle.getPage(pageName);

        __CLOVER_103_0.S[12572]++;cycle.activate(page);

        // Render the same page (that contained the reset link).

        __CLOVER_103_0.S[12573]++;_responseRenderer.renderResponse(cycle, output);
    } finally { }}

    /** @since 3.1 */
    public void setResponseRenderer(ResponseRenderer responseRenderer)
    {try { __CLOVER_103_0.M[3050]++;
        __CLOVER_103_0.S[12574]++;_responseRenderer = responseRenderer;
    } finally { }}
    
    /** @since 3.1 */
    
    public void setResetEventCoordinator(ResetEventCoordinator resetEventCoordinator)
    {try { __CLOVER_103_0.M[3051]++;
        __CLOVER_103_0.S[12575]++;_resetEventCoordinator = resetEventCoordinator;
    } finally { }}
}