/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.engine;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.logging.Log;
import org.apache.tapestry.IComponent;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.Tapestry;
import org.apache.tapestry.request.RequestContext;
import org.apache.tapestry.request.ResponseOutputStream;
import org.apache.tapestry.services.AbsoluteURLBuilder;

/**
 * Restarts the Tapestry application. This is normally reserved for dealing with catastrophic
 * failures of the application. Discards the {@link javax.servlet.http.HttpSession}, if any, and
 * redirects to the Tapestry application servlet URL (invoking the {@link HomeService}).
 * 
 * @author Howard Lewis Ship
 * @since 1.0.9
 */

public class RestartService extends AbstractService
{public static com.cortexeb.tools.clover.d __CLOVER_104_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1097439627296L);
    /** @since 3.1 */
    private Log _log;

    /** @since 3.1 */
    private HttpServletRequest _request;

    /** @since 3.1 */
    private HttpServletResponse _response;

    /** @since 3.1 */
    private AbsoluteURLBuilder _builder;

    public ILink getLink(IRequestCycle cycle, IComponent component, Object[] parameters)
    {try { __CLOVER_104_0.M[3052]++;
        __CLOVER_104_0.S[12576]++;if ((((Tapestry.size(parameters) != 0) && (++__CLOVER_104_0.CT[2153] != 0)) || (++__CLOVER_104_0.CF[2153] == 0))){
            __CLOVER_104_0.S[12577]++;throw new IllegalArgumentException(Tapestry.format(
                    "service-no-parameters",
                    Tapestry.RESTART_SERVICE));}

        __CLOVER_104_0.S[12578]++;return constructLink(cycle, Tapestry.RESTART_SERVICE, null, null, true);
    } finally { }}

    public void service(IEngineServiceView engine, IRequestCycle cycle, ResponseOutputStream output)
            throws ServletException, IOException
    {try { __CLOVER_104_0.M[3053]++;
        __CLOVER_104_0.S[12579]++;HttpSession session = _request.getSession();

        __CLOVER_104_0.S[12580]++;if ((((session != null) && (++__CLOVER_104_0.CT[2154] != 0)) || (++__CLOVER_104_0.CF[2154] == 0))){
        {
            __CLOVER_104_0.S[12581]++;try
            {
                __CLOVER_104_0.S[12582]++;session.invalidate();
            }
            catch (IllegalStateException ex)
            {
                __CLOVER_104_0.S[12583]++;_log.warn("Exception thrown invalidating HttpSession.", ex);

                // Otherwise, ignore it.
            }
        }}

        // Make isStateful() return false, so that the servlet doesn't
        // try to store the engine back into the (now invalid) session.
        // TODO: How to get the EngineManager to *not* try and
        // store the engine back in the (now invalid) session.

        __CLOVER_104_0.S[12584]++;String url = _builder.constructURL(_request.getServletPath());

        __CLOVER_104_0.S[12585]++;_response.sendRedirect(url);
    } finally { }}

    public String getName()
    {try { __CLOVER_104_0.M[3054]++;
        __CLOVER_104_0.S[12586]++;return Tapestry.RESTART_SERVICE;
    } finally { }}

    /** @since 3.1 */
    public void setLog(Log log)
    {try { __CLOVER_104_0.M[3055]++;
        __CLOVER_104_0.S[12587]++;_log = log;
    } finally { }}

    /** @since 3.1 */
    public void setRequest(HttpServletRequest request)
    {try { __CLOVER_104_0.M[3056]++;
        __CLOVER_104_0.S[12588]++;_request = request;
    } finally { }}

    /** @since 3.1 */
    public void setBuilder(AbsoluteURLBuilder builder)
    {try { __CLOVER_104_0.M[3057]++;
        __CLOVER_104_0.S[12589]++;_builder = builder;
    } finally { }}

    /** @since 3.1 */
    public void setResponse(HttpServletResponse response)
    {try { __CLOVER_104_0.M[3058]++;
        __CLOVER_104_0.S[12590]++;_response = response;
    } finally { }}
}