/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.pageload;

import java.util.Iterator;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.tapestry.IBinding;
import org.apache.tapestry.IComponent;
import org.apache.tapestry.services.BindingFactory;
import org.apache.tapestry.spec.IComponentSpecification;
import org.apache.tapestry.spec.IParameterSpecification;

/**
 * For all parameters in the examined component that have default values, but are not bound,
 * automatically add an ExpressionBinding with the default value.
 * 
 * @author mindbridge
 * @since 3.0
 */
public class EstablishDefaultParameterValuesVisitor implements IComponentVisitor
{public static com.cortexeb.tools.clover.d __CLOVER_191_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1097439627296L);
    private BindingFactory _bindingFactory;

    public void setBindingFactory(BindingFactory bindingFactory)
    {try { __CLOVER_191_0.M[3068]++;
        __CLOVER_191_0.S[12650]++;_bindingFactory = bindingFactory;
    } finally { }}

    /**
     * @see org.apache.tapestry.pageload.IComponentVisitor#visitComponent(org.apache.tapestry.IComponent)
     */
    public void visitComponent(IComponent component)
    {try { __CLOVER_191_0.M[3069]++;
        __CLOVER_191_0.S[12651]++;IComponentSpecification spec = component.getSpecification();

        __CLOVER_191_0.S[12652]++;Iterator i = spec.getParameterNames().iterator();

        __CLOVER_191_0.S[12653]++;while ((((i.hasNext()) && (++__CLOVER_191_0.CT[2159] != 0)) || (++__CLOVER_191_0.CF[2159] == 0))){
        {
            __CLOVER_191_0.S[12654]++;String name = (String) i.next();
            __CLOVER_191_0.S[12655]++;IParameterSpecification parameterSpec = spec.getParameter(name);

            __CLOVER_191_0.S[12656]++;String defaultValue = parameterSpec.getDefaultValue();
            __CLOVER_191_0.S[12657]++;if ((((defaultValue == null) && (++__CLOVER_191_0.CT[2160] != 0)) || (++__CLOVER_191_0.CF[2160] == 0))){
                __CLOVER_191_0.S[12658]++;continue;}

            // the parameter has a default value, so it must not be required
            __CLOVER_191_0.S[12659]++;if ((((parameterSpec.isRequired()) && (++__CLOVER_191_0.CT[2161] != 0)) || (++__CLOVER_191_0.CF[2161] == 0))){
                __CLOVER_191_0.S[12660]++;throw new ApplicationRuntimeException(PageloadMessages
                        .parameterMustHaveNoDefaultValue(component, name), component, parameterSpec
                        .getLocation(), null);}

            // if there is no binding for this parameter, bind it to the default value
            __CLOVER_191_0.S[12661]++;if ((((component.getBinding(name) == null) && (++__CLOVER_191_0.CT[2162] != 0)) || (++__CLOVER_191_0.CF[2162] == 0))){
            {
                __CLOVER_191_0.S[12662]++;IBinding binding = _bindingFactory.createBinding(
                        component,
                        defaultValue,
                        parameterSpec.getLocation());

                __CLOVER_191_0.S[12663]++;component.setBinding(name, binding);
            }}

        }}
    } finally { }}
}