/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.script;

import java.util.Map;

import org.apache.hivemind.Location;
import org.apache.hivemind.Resource;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.IScript;
import org.apache.tapestry.IScriptProcessor;
import org.apache.tapestry.services.ExpressionEvaluator;

/**
 * A top level container for a number of {@link IScriptToken script tokens}.
 * 
 * @author Howard Lewis Ship
 * @since 0.2.9
 */

public class ParsedScript extends AbstractToken implements IScript
{public static com.cortexeb.tools.clover.d __CLOVER_270_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1097439627296L);
    private Resource _scriptResource;

    private ExpressionEvaluator _evaluator;

    public ParsedScript(ExpressionEvaluator evaluator, Location location)
    {
        super(location);__CLOVER_270_0.S[13887]++;try { __CLOVER_270_0.M[3254]++;

        __CLOVER_270_0.S[13888]++;_evaluator = evaluator;
        __CLOVER_270_0.S[13889]++;_scriptResource = location.getResource();
    } finally { }}

    public Resource getScriptResource()
    {try { __CLOVER_270_0.M[3255]++;
        __CLOVER_270_0.S[13890]++;return _scriptResource;
    } finally { }}

    /**
     * Creates the {@link ScriptSessionImpl}and invokes
     * {@link org.apache.tapestry.script.AbstractToken#writeChildren(java.lang.StringBuffer, org.apache.tapestry.script.ScriptSession)}.
     */
    public void execute(IRequestCycle cycle, IScriptProcessor processor, Map symbols)
    {try { __CLOVER_270_0.M[3256]++;
        __CLOVER_270_0.S[13891]++;ScriptSession session = new ScriptSessionImpl(_scriptResource, cycle, processor, _evaluator,
                symbols);

        __CLOVER_270_0.S[13892]++;writeChildren(null, session);
    } finally { }}

    /**
     * Does nothing; never invoked.
     */
    public void write(StringBuffer buffer, ScriptSession session)
    {try { __CLOVER_270_0.M[3257]++;

    } finally { }}

}