/* $$ Clover has instrumented this file $$ */package org.apache.tapestry.script;

import java.util.Map;

import org.apache.hivemind.Resource;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.IScriptProcessor;

/**
 * Process object used when executing a {@link org.apache.tapestry.IScript script template}. This
 * ScriptSession provides support
 * 
 * @author Howard M. Lewis Ship
 * @since 3.1
 */
public interface ScriptSession extends IScriptProcessor
{
    /**
     * Evaluates an OGNL expression, where the root object for the expression is the
     * {@link #getSymbols() symbols map}.
     */
    public Object evaluate(String expression);

    /**
     * Returns the resource for the script template.
     */

    public Resource getScriptTemplateResource();

    /**
     * Returns the symbols (which may be created or updated during the execution of the script
     * template).
     */

    public Map getSymbols();

    /**
     * Returns the current request cycle.
     */
    public IRequestCycle getRequestCycle();
}