/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.script;

import java.util.Map;

import org.apache.hivemind.Resource;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.IScriptProcessor;
import org.apache.tapestry.services.ExpressionEvaluator;

/**
 * The result of executing a script, the session is used during the parsing process as well.
 * Following
 * {@link org.apache.tapestry.IScript#execute(org.apache.tapestry.IRequestCycle, org.apache.tapestry.IScriptProcessor, java.util.Map)},
 * the session provides access to output symbols as well as the body and initialization blocks
 * created by the script tokens.
 * 
 * @author Howard Lewis Ship
 * @since 0.2.9
 */

public class ScriptSessionImpl implements ScriptSession
{public static com.cortexeb.tools.clover.d __CLOVER_487_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1097439627296L);
    private IRequestCycle _cycle;

    private IScriptProcessor _processor;

    private Resource _scriptTemplateResource;

    private Map _symbols;

    /** @since 3.1 */
    private ExpressionEvaluator _evaluator;

    public ScriptSessionImpl(Resource scriptTemplateResource, IRequestCycle cycle,
            IScriptProcessor processor, ExpressionEvaluator evaluator, Map symbols)
    {try { __CLOVER_487_0.M[3263]++;
        __CLOVER_487_0.S[13915]++;_scriptTemplateResource = scriptTemplateResource;
        __CLOVER_487_0.S[13916]++;_cycle = cycle;
        __CLOVER_487_0.S[13917]++;_processor = processor;
        __CLOVER_487_0.S[13918]++;_symbols = symbols;
        __CLOVER_487_0.S[13919]++;_evaluator = evaluator;
    } finally { }}

    public Object evaluate(String expression)
    {try { __CLOVER_487_0.M[3264]++;
        __CLOVER_487_0.S[13920]++;return _evaluator.read(_symbols, expression);
    } finally { }}

    public Resource getScriptTemplateResource()
    {try { __CLOVER_487_0.M[3265]++;
        __CLOVER_487_0.S[13921]++;return _scriptTemplateResource;
    } finally { }}

    public Map getSymbols()
    {try { __CLOVER_487_0.M[3266]++;
        __CLOVER_487_0.S[13922]++;return _symbols;
    } finally { }}

    public IRequestCycle getRequestCycle()
    {try { __CLOVER_487_0.M[3267]++;
        __CLOVER_487_0.S[13923]++;return _cycle;
    } finally { }}

    public void addBodyScript(String script)
    {try { __CLOVER_487_0.M[3268]++;
        __CLOVER_487_0.S[13924]++;_processor.addBodyScript(script);
    } finally { }}

    public void addExternalScript(Resource resource)
    {try { __CLOVER_487_0.M[3269]++;
        __CLOVER_487_0.S[13925]++;_processor.addExternalScript(resource);
    } finally { }}

    public void addInitializationScript(String script)
    {try { __CLOVER_487_0.M[3270]++;
        __CLOVER_487_0.S[13926]++;_processor.addInitializationScript(script);
    } finally { }}

    public String getUniqueString(String baseValue)
    {try { __CLOVER_487_0.M[3271]++;
        __CLOVER_487_0.S[13927]++;return _processor.getUniqueString(baseValue);
    } finally { }}

    public String toString()
    {try { __CLOVER_487_0.M[3272]++;
        __CLOVER_487_0.S[13928]++;StringBuffer buffer = new StringBuffer();

        __CLOVER_487_0.S[13929]++;buffer.append("ScriptSession[");
        __CLOVER_487_0.S[13930]++;buffer.append(_scriptTemplateResource);
        __CLOVER_487_0.S[13931]++;buffer.append(']');

        __CLOVER_487_0.S[13932]++;return buffer.toString();
    } finally { }}
}