/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.services.impl;

import java.util.Locale;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.apache.tapestry.IEngine;
import org.apache.tapestry.services.EngineFactory;
import org.apache.tapestry.services.EngineManager;
import org.apache.tapestry.services.RequestLocaleManager;
import org.apache.tapestry.services.ObjectPool;

/**
 * Implementation of service {@link org.apache.tapestry.services.EngineManager}.
 *
 * @author Howard Lewis Ship
 * @since 3.1
 */
public class EngineManagerImpl implements EngineManager
{public static com.cortexeb.tools.clover.d __CLOVER_311_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1097439627296L);
    private ObjectPool _enginePool;
    private HttpServletRequest _request;
    private String _servletName;
    private String _engineKey;
    private EngineFactory _engineFactory;
    private RequestLocaleManager _localeManager;

    static final String ENGINE_KEY_PREFIX = "org.apache.tapestry.engine:";

    public void initializeService()
    {try { __CLOVER_311_0.M[3295]++;
        __CLOVER_311_0.S[14067]++;_engineKey = ENGINE_KEY_PREFIX + _servletName;
    } finally { }}

    public IEngine getEngineInstance()
    {try { __CLOVER_311_0.M[3296]++;
        __CLOVER_311_0.S[14068]++;HttpSession session = getSession();
        __CLOVER_311_0.S[14069]++;IEngine result = null;

        __CLOVER_311_0.S[14070]++;if ((((session != null) && (++__CLOVER_311_0.CT[2355] != 0)) || (++__CLOVER_311_0.CF[2355] == 0))){
        {
            __CLOVER_311_0.S[14071]++;result = (IEngine) session.getAttribute(_engineKey);

            __CLOVER_311_0.S[14072]++;if ((((result != null) && (++__CLOVER_311_0.CT[2356] != 0)) || (++__CLOVER_311_0.CF[2356] == 0))){
                __CLOVER_311_0.S[14073]++;return result;}
        }}

        __CLOVER_311_0.S[14074]++;Locale locale = _localeManager.extractLocaleForCurrentRequest();

        __CLOVER_311_0.S[14075]++;result = (IEngine) _enginePool.get(locale);

        // This happens when either the pool is empty, or when a session exists
        // but the engine has not been stored into it (which should never happen, and
        // probably indicates an error in the framework or the application).

        __CLOVER_311_0.S[14076]++;if ((((result == null) && (++__CLOVER_311_0.CT[2357] != 0)) || (++__CLOVER_311_0.CF[2357] == 0))){
            __CLOVER_311_0.S[14077]++;result = _engineFactory.constructNewEngineInstance(locale);}

        __CLOVER_311_0.S[14078]++;return result;
    } finally { }}

    private HttpSession getSession()
    {try { __CLOVER_311_0.M[3297]++;
        __CLOVER_311_0.S[14079]++;return _request.getSession(false);
    } finally { }}

    public void storeEngineInstance(IEngine engine)
    {try { __CLOVER_311_0.M[3298]++;
        __CLOVER_311_0.S[14080]++;HttpSession session = getSession();

        __CLOVER_311_0.S[14081]++;if ((((session == null) && (++__CLOVER_311_0.CT[2358] != 0)) || (++__CLOVER_311_0.CF[2358] == 0))){
        {
            __CLOVER_311_0.S[14082]++;_enginePool.store(engine.getLocale(), engine);
            __CLOVER_311_0.S[14083]++;return;
        }}

        // TODO: We've lost the optimizations for only storing the engine when dirty.
        // However, since (I believe) in 3.1, the engine will no longer be session persistent,
        // this is OK.

        __CLOVER_311_0.S[14084]++;session.setAttribute(_engineKey, engine);
    } finally { }}

    public void setEngineFactory(EngineFactory factory)
    {try { __CLOVER_311_0.M[3299]++;
        __CLOVER_311_0.S[14085]++;_engineFactory = factory;
    } finally { }}

    public void setEnginePool(ObjectPool pool)
    {try { __CLOVER_311_0.M[3300]++;
        __CLOVER_311_0.S[14086]++;_enginePool = pool;
    } finally { }}

    public void setLocaleManager(RequestLocaleManager manager)
    {try { __CLOVER_311_0.M[3301]++;
        __CLOVER_311_0.S[14087]++;_localeManager = manager;
    } finally { }}

    public void setRequest(HttpServletRequest request)
    {try { __CLOVER_311_0.M[3302]++;
        __CLOVER_311_0.S[14088]++;_request = request;
    } finally { }}

    public void setServletName(String string)
    {try { __CLOVER_311_0.M[3303]++;
        __CLOVER_311_0.S[14089]++;_servletName = string;
    } finally { }}
}
