/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.tapestry.engine.IPageLoader;
import org.apache.tapestry.spec.IComponentSpecification;

/**
 * Base implementation for most components that use an HTML template.
 * 
 * @author Howard Lewis Ship
 */

public class BaseComponent extends AbstractComponent implements ITemplateComponent
{public static com.cortexeb.tools.clover.d __CLOVER_4_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private static final Log LOG = LogFactory.getLog(BaseComponent.class);

    private static final int OUTER_INIT_SIZE = 5;

    private IRender[] _outer;

    private int _outerCount = 0;

    /**
     * Adds an element as an outer element for the receiver. Outer elements are elements that should
     * be directly rendered by the receiver's <code>render()</code> method. That is, they are
     * top-level elements on the HTML template.
     */

    public void addOuter(IRender element)
    {try { __CLOVER_4_0.M[143]++;
        __CLOVER_4_0.S[510]++;if ((((_outer == null) && (++__CLOVER_4_0.CT[108] != 0)) || (++__CLOVER_4_0.CF[108] == 0))){
        {
            __CLOVER_4_0.S[511]++;_outer = new IRender[OUTER_INIT_SIZE];
            __CLOVER_4_0.S[512]++;_outer[0] = element;

            __CLOVER_4_0.S[513]++;_outerCount = 1;
            __CLOVER_4_0.S[514]++;return;
        }}

        // No more room? Make the array bigger.

        __CLOVER_4_0.S[515]++;if ((((_outerCount == _outer.length) && (++__CLOVER_4_0.CT[109] != 0)) || (++__CLOVER_4_0.CF[109] == 0))){
        {
            __CLOVER_4_0.S[516]++;IRender[] newOuter;

            __CLOVER_4_0.S[517]++;newOuter = new IRender[_outer.length * 2];

            __CLOVER_4_0.S[518]++;System.arraycopy(_outer, 0, newOuter, 0, _outerCount);

            __CLOVER_4_0.S[519]++;_outer = newOuter;
        }}

        __CLOVER_4_0.S[520]++;_outer[_outerCount++] = element;
    } finally { }}

    /**
     * Reads the receiver's template and figures out which elements wrap which other elements.
     */

    private void readTemplate(IRequestCycle cycle, IPageLoader loader)
    {try { __CLOVER_4_0.M[144]++;
        __CLOVER_4_0.S[521]++;loader.loadTemplateForComponent(cycle, this);
    } finally { }}

    /**
     * Renders the top level components contained by the receiver.
     * 
     * @since 2.0.3
     */

    protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_4_0.M[145]++;
        __CLOVER_4_0.S[522]++;if ((((LOG.isDebugEnabled()) && (++__CLOVER_4_0.CT[110] != 0)) || (++__CLOVER_4_0.CF[110] == 0))){
            __CLOVER_4_0.S[523]++;LOG.debug("Begin render " + getExtendedId());}

        __CLOVER_4_0.S[524]++;for (int i = 0; (((i < _outerCount) && (++__CLOVER_4_0.CT[111] != 0)) || (++__CLOVER_4_0.CF[111] == 0)); i++){
            __CLOVER_4_0.S[525]++;_outer[i].render(writer, cycle);}

        __CLOVER_4_0.S[526]++;if ((((LOG.isDebugEnabled()) && (++__CLOVER_4_0.CT[112] != 0)) || (++__CLOVER_4_0.CF[112] == 0))){
            __CLOVER_4_0.S[527]++;LOG.debug("End render " + getExtendedId());}
    } finally { }}

    /**
     * Loads the template for the component, then invokes
     * {@link AbstractComponent#finishLoad(IRequestCycle, IPageLoader, IComponentSpecification)}.
     * Subclasses must invoke this method first, before adding any additional behavior, though its
     * usually simpler to override {@link #finishLoad()}instead.
     */

    public void finishLoad(IRequestCycle cycle, IPageLoader loader, IComponentSpecification specification)
    {try { __CLOVER_4_0.M[146]++;
        __CLOVER_4_0.S[528]++;readTemplate(cycle, loader);

        __CLOVER_4_0.S[529]++;super.finishLoad(cycle, loader, specification);
    } finally { }}
}