/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.asset;

import java.io.InputStream;
import java.net.URL;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.hivemind.Location;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.Tapestry;

/**
 *  A reference to an external URL.  {@link ExternalAsset}s are not
 *  localizable.
 *
 *  @author Howard Lewis Ship
 * 
 **/

public class ExternalAsset extends AbstractAsset
{public static com.cortexeb.tools.clover.d __CLOVER_39_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private String _URL;

    public ExternalAsset(String URL, Location location)
    {
    	super(null, location);__CLOVER_39_0.S[981]++;try { __CLOVER_39_0.M[248]++;
    	
        __CLOVER_39_0.S[982]++;_URL = URL;
    } finally { }}

    /**
     *  Simply returns the URL of the external asset.
     *
     **/

    public String buildURL(IRequestCycle cycle)
    {try { __CLOVER_39_0.M[249]++;
        __CLOVER_39_0.S[983]++;return _URL;
    } finally { }}

    public InputStream getResourceAsStream(IRequestCycle cycle)
    {try { __CLOVER_39_0.M[250]++;
        __CLOVER_39_0.S[984]++;URL url;

        __CLOVER_39_0.S[985]++;try
        {
            __CLOVER_39_0.S[986]++;url = new URL(_URL);

            __CLOVER_39_0.S[987]++;return url.openStream();
        }
        catch (Exception ex)
        {
            // MalrformedURLException or IOException

            __CLOVER_39_0.S[988]++;throw new ApplicationRuntimeException(Tapestry.format("ExternalAsset.resource-missing", _URL), ex);
        }

    } finally { }}

    public String toString()
    {try { __CLOVER_39_0.M[251]++;
        __CLOVER_39_0.S[989]++;return "ExternalAsset[" + _URL + "]";
    } finally { }}
}