/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.asset;

import java.io.InputStream;
import java.net.URL;

import org.apache.hivemind.util.ClasspathResource;
import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.hivemind.Location;
import org.apache.hivemind.Resource;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.Tapestry;
import org.apache.tapestry.engine.IEngineService;
import org.apache.tapestry.engine.ILink;

/**
 *  An implementation of {@link org.apache.tapestry.IAsset} for localizable assets within
 *  the JVM's classpath.
 *
 *  <p>The localization code here is largely cut-and-paste from
 *  {@link ContextAsset}.
 *
 *  @author Howard Ship
 * 
 **/

public class PrivateAsset extends AbstractAsset
{public static com.cortexeb.tools.clover.d __CLOVER_40_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);

    private AssetExternalizer _externalizer;

    public PrivateAsset(ClasspathResource resourceLocation, Location location)
    {
        super(resourceLocation, location);__CLOVER_40_0.S[990]++;try { __CLOVER_40_0.M[252]++;
    } finally { }}

    /**
     *  Gets the localized version of the resource.  Build
     *  the URL for the resource.  If possible, the application's
     *  {@link AssetExternalizer} is located, to copy the resource to
     *  a directory visible to the web server.
     *
     **/

    public String buildURL(IRequestCycle cycle)
    {try { __CLOVER_40_0.M[253]++;
        __CLOVER_40_0.S[991]++;if ((((_externalizer == null) && (++__CLOVER_40_0.CT[192] != 0)) || (++__CLOVER_40_0.CF[192] == 0))){
            __CLOVER_40_0.S[992]++;_externalizer = AssetExternalizer.get(cycle);}

        __CLOVER_40_0.S[993]++;String path = getResourceLocation().getPath();

        __CLOVER_40_0.S[994]++;String externalURL = _externalizer.getURL(path);

        __CLOVER_40_0.S[995]++;if ((((externalURL != null) && (++__CLOVER_40_0.CT[193] != 0)) || (++__CLOVER_40_0.CF[193] == 0))){
            __CLOVER_40_0.S[996]++;return externalURL;}

        // Otherwise, the service is responsible for dynamically retrieving the
        // resource.

        __CLOVER_40_0.S[997]++;String[] parameters = new String[] { path };

        __CLOVER_40_0.S[998]++;IEngineService service = cycle.getEngine().getService(Tapestry.ASSET_SERVICE);

        __CLOVER_40_0.S[999]++;ILink link = service.getLink(cycle, null, parameters);

        __CLOVER_40_0.S[1000]++;return link.getURL();
    } finally { }}

    public InputStream getResourceAsStream(IRequestCycle cycle)
    {try { __CLOVER_40_0.M[254]++;
        __CLOVER_40_0.S[1001]++;Resource location = getResourceLocation();

        __CLOVER_40_0.S[1002]++;try
        {
            __CLOVER_40_0.S[1003]++;URL url = location.getResourceURL();

            __CLOVER_40_0.S[1004]++;return url.openStream();
        }
        catch (Exception ex)
        {
            __CLOVER_40_0.S[1005]++;throw new ApplicationRuntimeException(
                Tapestry.format("PrivateAsset.resource-missing", location),
                ex);
        }
    } finally { }}

}