/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.binding;

import java.util.HashMap;
import java.util.Map;

import org.apache.hivemind.Location;
import org.apache.tapestry.BindingException;
import org.apache.tapestry.IBinding;
import org.apache.tapestry.Tapestry;

/**
 *  Base class for {@link IBinding} implementations.
 *
 * @author Howard Lewis Ship
 * 
 **/

public abstract class AbstractBinding implements IBinding
{public static com.cortexeb.tools.clover.d __CLOVER_51_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    /** @since 3.0 **/

    private Location _location;

    /**
     *  A mapping from primitive types to wrapper types.
     * 
     **/

    private static final Map PRIMITIVE_TYPES = new HashMap();

    static {
        __CLOVER_51_0.S[1147]++;PRIMITIVE_TYPES.put(boolean.class, Boolean.class);
        __CLOVER_51_0.S[1148]++;PRIMITIVE_TYPES.put(byte.class, Byte.class);
        __CLOVER_51_0.S[1149]++;PRIMITIVE_TYPES.put(char.class, Character.class);
        __CLOVER_51_0.S[1150]++;PRIMITIVE_TYPES.put(short.class, Short.class);
        __CLOVER_51_0.S[1151]++;PRIMITIVE_TYPES.put(int.class, Integer.class);
        __CLOVER_51_0.S[1152]++;PRIMITIVE_TYPES.put(long.class, Long.class);
        __CLOVER_51_0.S[1153]++;PRIMITIVE_TYPES.put(float.class, Float.class);
        __CLOVER_51_0.S[1154]++;PRIMITIVE_TYPES.put(double.class, Double.class);
    }

    /** @since 3.0 **/

    protected AbstractBinding(Location location)
    {try { __CLOVER_51_0.M[290]++;
        __CLOVER_51_0.S[1155]++;_location = location;
    } finally { }}

    public Location getLocation()
    {try { __CLOVER_51_0.M[291]++;
        __CLOVER_51_0.S[1156]++;return _location;
    } finally { }}

    /**
     *  Cooerces the raw value into a true or false, according to the
     *  rules set by {@link Tapestry#evaluateBoolean(Object)}.
     *
     **/

    public boolean getBoolean()
    {try { __CLOVER_51_0.M[292]++;
        __CLOVER_51_0.S[1157]++;return Tapestry.evaluateBoolean(getObject());
    } finally { }}

    public int getInt()
    {try { __CLOVER_51_0.M[293]++;
        __CLOVER_51_0.S[1158]++;Object raw;

        __CLOVER_51_0.S[1159]++;raw = getObject();
        __CLOVER_51_0.S[1160]++;if ((((raw == null) && (++__CLOVER_51_0.CT[222] != 0)) || (++__CLOVER_51_0.CF[222] == 0))){
            __CLOVER_51_0.S[1161]++;throw Tapestry.createNullBindingException(this);}

        __CLOVER_51_0.S[1162]++;if ((((raw instanceof Number) && (++__CLOVER_51_0.CT[223] != 0)) || (++__CLOVER_51_0.CF[223] == 0))){
        {
            __CLOVER_51_0.S[1163]++;return ((Number) raw).intValue();
        }}

        __CLOVER_51_0.S[1164]++;if ((((raw instanceof Boolean) && (++__CLOVER_51_0.CT[224] != 0)) || (++__CLOVER_51_0.CF[224] == 0))){
        {
            __CLOVER_51_0.S[1165]++;return (((((Boolean) raw).booleanValue() ) && (++__CLOVER_51_0.CT[225] != 0)) || (++__CLOVER_51_0.CF[225] == 0))? 1 : 0;
        }}

        // Save parsing for last.  This may also throw a number format exception.

        __CLOVER_51_0.S[1166]++;return Integer.parseInt((String) raw);
    } finally { }}

    public double getDouble()
    {try { __CLOVER_51_0.M[294]++;
        __CLOVER_51_0.S[1167]++;Object raw;

        __CLOVER_51_0.S[1168]++;raw = getObject();
        __CLOVER_51_0.S[1169]++;if ((((raw == null) && (++__CLOVER_51_0.CT[226] != 0)) || (++__CLOVER_51_0.CF[226] == 0))){
            __CLOVER_51_0.S[1170]++;throw Tapestry.createNullBindingException(this);}

        __CLOVER_51_0.S[1171]++;if ((((raw instanceof Number) && (++__CLOVER_51_0.CT[227] != 0)) || (++__CLOVER_51_0.CF[227] == 0))){
        {
            __CLOVER_51_0.S[1172]++;return ((Number) raw).doubleValue();
        }}

        __CLOVER_51_0.S[1173]++;if ((((raw instanceof Boolean) && (++__CLOVER_51_0.CT[228] != 0)) || (++__CLOVER_51_0.CF[228] == 0))){
        {
            __CLOVER_51_0.S[1174]++;return (((((Boolean) raw).booleanValue() ) && (++__CLOVER_51_0.CT[229] != 0)) || (++__CLOVER_51_0.CF[229] == 0))? 1 : 0;
        }}

        // Save parsing for last.  This may also throw a number format exception.

        __CLOVER_51_0.S[1175]++;return Double.parseDouble((String) raw);
    } finally { }}

    /**
     *  Gets the value for the binding.  If null, returns null,
     *  otherwise, returns the String (<code>toString()</code>) version of
     *  the value.
     *
     **/

    public String getString()
    {try { __CLOVER_51_0.M[295]++;
        __CLOVER_51_0.S[1176]++;Object value;

        __CLOVER_51_0.S[1177]++;value = getObject();
        __CLOVER_51_0.S[1178]++;if ((((value == null) && (++__CLOVER_51_0.CT[230] != 0)) || (++__CLOVER_51_0.CF[230] == 0))){
            __CLOVER_51_0.S[1179]++;return null;}

        __CLOVER_51_0.S[1180]++;return value.toString();
    } finally { }}

    /**
     *  @throws ReadOnlyBindingException always.
     *
     **/

    public void setBoolean(boolean value)
    {try { __CLOVER_51_0.M[296]++;
        __CLOVER_51_0.S[1181]++;throw createReadOnlyBindingException(this);
    } finally { }}

    /**
     *  @throws ReadOnlyBindingException always.
     *
     **/

    public void setInt(int value)
    {try { __CLOVER_51_0.M[297]++;
        __CLOVER_51_0.S[1182]++;throw createReadOnlyBindingException(this);
    } finally { }}

    /**
     *  @throws ReadOnlyBindingException always.
     *
     **/

    public void setDouble(double value)
    {try { __CLOVER_51_0.M[298]++;
        __CLOVER_51_0.S[1183]++;throw createReadOnlyBindingException(this);
    } finally { }}

    /**
     *  @throws ReadOnlyBindingException always.
     *
     **/

    public void setString(String value)
    {try { __CLOVER_51_0.M[299]++;
        __CLOVER_51_0.S[1184]++;throw createReadOnlyBindingException(this);
    } finally { }}

    /**
     *  @throws ReadOnlyBindingException always.
     *
     **/

    public void setObject(Object value)
    {try { __CLOVER_51_0.M[300]++;
        __CLOVER_51_0.S[1185]++;throw createReadOnlyBindingException(this);
    } finally { }}

    /**
     *  Default implementation: returns true.
     * 
     *  @since 2.0.3
     * 
     **/

    public boolean isInvariant()
    {try { __CLOVER_51_0.M[301]++;
        __CLOVER_51_0.S[1186]++;return true;
    } finally { }}

    public Object getObject(String parameterName, Class type)
    {try { __CLOVER_51_0.M[302]++;
        __CLOVER_51_0.S[1187]++;Object result = getObject();

        __CLOVER_51_0.S[1188]++;if ((((result == null) && (++__CLOVER_51_0.CT[231] != 0)) || (++__CLOVER_51_0.CF[231] == 0))){
            __CLOVER_51_0.S[1189]++;return result;}

        __CLOVER_51_0.S[1190]++;Class resultClass = result.getClass();

        __CLOVER_51_0.S[1191]++;if ((((type.isAssignableFrom(resultClass)) && (++__CLOVER_51_0.CT[232] != 0)) || (++__CLOVER_51_0.CF[232] == 0))){
            __CLOVER_51_0.S[1192]++;return result;}

        __CLOVER_51_0.S[1193]++;if ((((type.isPrimitive() && isWrapper(type, resultClass)) && (++__CLOVER_51_0.CT[233] != 0)) || (++__CLOVER_51_0.CF[233] == 0))){
            __CLOVER_51_0.S[1194]++;return result;}

        __CLOVER_51_0.S[1195]++;String key =
            (((type.isInterface() ) && (++__CLOVER_51_0.CT[234] != 0)) || (++__CLOVER_51_0.CF[234] == 0))? "AbstractBinding.wrong-interface" : "AbstractBinding.wrong-type";

        __CLOVER_51_0.S[1196]++;String message =
            Tapestry.format(
                key,
                new Object[] { parameterName, result, resultClass.getName(), type.getName()});

        __CLOVER_51_0.S[1197]++;throw new BindingException(message, this);
    } finally { }}

    public boolean isWrapper(Class primitiveType, Class subjectClass)
    {try { __CLOVER_51_0.M[303]++;
        __CLOVER_51_0.S[1198]++;return PRIMITIVE_TYPES.get(primitiveType).equals(subjectClass);
    } finally { }}

    /** @since 3.0 **/

    protected BindingException createReadOnlyBindingException(IBinding binding)
    {try { __CLOVER_51_0.M[304]++;
        __CLOVER_51_0.S[1199]++;return new BindingException(
            Tapestry.getMessage("AbstractBinding.read-only-binding"),
            binding);
    } finally { }}
}