/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.binding;

import org.apache.hivemind.Location;
import org.apache.tapestry.IComponent;

/**
 *  A binding that connects directly to a localized string for
 *  a component.
 *
 *  @see IComponent#getString(String)
 * 
 *  @author Howard Lewis Ship
 *  @since 2.0.4
 *
 **/

public class StringBinding extends AbstractBinding
{public static com.cortexeb.tools.clover.d __CLOVER_55_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private IComponent _component;
    private String _key;

    public StringBinding(IComponent component, String key, Location location)
    {
    	super(location);__CLOVER_55_0.S[1383]++;try { __CLOVER_55_0.M[338]++;
    	
        __CLOVER_55_0.S[1384]++;_component = component;
        __CLOVER_55_0.S[1385]++;_key = key;
    } finally { }}

    public IComponent getComponent()
    {try { __CLOVER_55_0.M[339]++;
        __CLOVER_55_0.S[1386]++;return _component;
    } finally { }}

    public String getKey()
    {try { __CLOVER_55_0.M[340]++;
        __CLOVER_55_0.S[1387]++;return _key;
    } finally { }}

    /**
     *  Accesses the specified localized string.  Never returns null.
     *
     **/

    public Object getObject()
    {try { __CLOVER_55_0.M[341]++;
        __CLOVER_55_0.S[1388]++;return _component.getMessages().getMessage(_key);
    } finally { }}

    /**
     *  Returns true.  Localized component strings are
     *  read-only.
     * 
     **/

    public boolean isInvariant()
    {try { __CLOVER_55_0.M[342]++;
        __CLOVER_55_0.S[1389]++;return true;
    } finally { }}

    public String toString()
    {try { __CLOVER_55_0.M[343]++;
        __CLOVER_55_0.S[1390]++;StringBuffer buffer = new StringBuffer("StringBinding");
        __CLOVER_55_0.S[1391]++;buffer.append('[');
        __CLOVER_55_0.S[1392]++;buffer.append(_component.getExtendedId());
        __CLOVER_55_0.S[1393]++;buffer.append(' ');
        __CLOVER_55_0.S[1394]++;buffer.append(_key);
        __CLOVER_55_0.S[1395]++;buffer.append(']');

        __CLOVER_55_0.S[1396]++;return buffer.toString();
    } finally { }}
}