/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.engine;

import java.text.MessageFormat;
import java.util.Locale;
import java.util.Properties;

import org.apache.hivemind.Messages;

/**
 *  Implementation of {@link org.apache.tapestry.IMessages}.  This is basically
 *  a wrapper around an instance of {@link Properties}.  This ensures
 *  that the properties are, in fact, read-only (which ensures that
 *  they don't have to be synchronized).
 * 
 * <p>TODO: Merge this code with HiveMind's implemention.
 *
 *  @author Howard Lewis Ship
 *  @since 2.0.4
 *
 */

public class ComponentMessages implements Messages
{public static com.cortexeb.tools.clover.d __CLOVER_75_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private Properties _properties;
    private Locale _locale;

    public ComponentMessages(Locale locale, Properties properties)
    {try { __CLOVER_75_0.M[442]++;
        __CLOVER_75_0.S[1935]++;_locale = locale;
        __CLOVER_75_0.S[1936]++;_properties = properties;
    } finally { }}

    public String getMessage(String key, String defaultValue)
    {try { __CLOVER_75_0.M[443]++;
        __CLOVER_75_0.S[1937]++;return _properties.getProperty(key, defaultValue);
    } finally { }}

    public String getMessage(String key)
    {try { __CLOVER_75_0.M[444]++;
        __CLOVER_75_0.S[1938]++;String result = _properties.getProperty(key);

        __CLOVER_75_0.S[1939]++;if ((((result == null) && (++__CLOVER_75_0.CT[366] != 0)) || (++__CLOVER_75_0.CF[366] == 0))){
            __CLOVER_75_0.S[1940]++;result = "[" + key.toUpperCase() + "]";}

        __CLOVER_75_0.S[1941]++;return result;
    } finally { }}

    public String format(String key, Object argument1, Object argument2, Object argument3)
    {try { __CLOVER_75_0.M[445]++;
        __CLOVER_75_0.S[1942]++;return format(key, new Object[] { argument1, argument2, argument3 });
    } finally { }}

    public String format(String key, Object argument1, Object argument2)
    {try { __CLOVER_75_0.M[446]++;
        __CLOVER_75_0.S[1943]++;return format(key, new Object[] { argument1, argument2 });
    } finally { }}

    public String format(String key, Object argument)
    {try { __CLOVER_75_0.M[447]++;
        __CLOVER_75_0.S[1944]++;return format(key, new Object[] { argument });
    } finally { }}

    public String format(String key, Object[] arguments)
    {try { __CLOVER_75_0.M[448]++;
        __CLOVER_75_0.S[1945]++;String pattern = getMessage(key);

        // This ugliness is mandated for JDK 1.3 compatibility, which has a bug 
        // in MessageFormat ... the
        // pattern is applied in the constructor, using the system default Locale,
        // regardless of what locale is later specified!
        // It appears that the problem does not exist in JDK 1.4.

        __CLOVER_75_0.S[1946]++;MessageFormat messageFormat = new MessageFormat("");
        __CLOVER_75_0.S[1947]++;messageFormat.setLocale(_locale);
        __CLOVER_75_0.S[1948]++;messageFormat.applyPattern(pattern);

        __CLOVER_75_0.S[1949]++;convert(arguments);

        __CLOVER_75_0.S[1950]++;return messageFormat.format(arguments);
    } finally { }}

    private void convert(Object[] arguments)
    {try { __CLOVER_75_0.M[449]++;
        __CLOVER_75_0.S[1951]++;if ((((arguments == null) && (++__CLOVER_75_0.CT[367] != 0)) || (++__CLOVER_75_0.CF[367] == 0))){
            __CLOVER_75_0.S[1952]++;return;}

        __CLOVER_75_0.S[1953]++;for (int i = 0; (((i < arguments.length) && (++__CLOVER_75_0.CT[368] != 0)) || (++__CLOVER_75_0.CF[368] == 0)); i++){
        {
            __CLOVER_75_0.S[1954]++;if ((((arguments[i] == null) && (++__CLOVER_75_0.CT[369] != 0)) || (++__CLOVER_75_0.CF[369] == 0))){
                __CLOVER_75_0.S[1955]++;continue;}

            __CLOVER_75_0.S[1956]++;if ((((arguments[i] instanceof Throwable) && (++__CLOVER_75_0.CT[370] != 0)) || (++__CLOVER_75_0.CF[370] == 0))){
            {
                __CLOVER_75_0.S[1957]++;Throwable t = (Throwable) arguments[i];

                __CLOVER_75_0.S[1958]++;String message = t.getMessage();

                __CLOVER_75_0.S[1959]++;if ((((message == null) && (++__CLOVER_75_0.CT[371] != 0)) || (++__CLOVER_75_0.CF[371] == 0))){
                    __CLOVER_75_0.S[1960]++;message = t.getClass().getName();}

                __CLOVER_75_0.S[1961]++;arguments[i] = message;
            }}
        }}
    } finally { }}

}
