/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.engine;

import org.apache.tapestry.IMarkupWriter;

/**
 *  A {@link IMarkupWriter} that does absolutely <em>nothing</em>; this
 *  is used during the rewind phase of the request cycle when output
 *  is discarded anyway.
 *
 *  @author Howard Lewis Ship, David Solis
 *  @since 0.2.9
 *
 **/

public class NullWriter implements IMarkupWriter
{public static com.cortexeb.tools.clover.d __CLOVER_99_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private static IMarkupWriter shared;

    public static IMarkupWriter getSharedInstance()
    {try { __CLOVER_99_0.M[518]++;
        __CLOVER_99_0.S[2244]++;if ((((shared == null) && (++__CLOVER_99_0.CT[418] != 0)) || (++__CLOVER_99_0.CF[418] == 0))){
            __CLOVER_99_0.S[2245]++;shared = new NullWriter();}

        __CLOVER_99_0.S[2246]++;return shared;
    } finally { }}

    public void printRaw(char[] buffer, int offset, int length)
    {try { __CLOVER_99_0.M[519]++;
    } finally { }}

    public void printRaw(String value)
    {try { __CLOVER_99_0.M[520]++;
    } finally { }}

    public void println()
    {try { __CLOVER_99_0.M[521]++;
    } finally { }}

    public void print(char[] data, int offset, int length)
    {try { __CLOVER_99_0.M[522]++;
    } finally { }}

    public void print(char value)
    {try { __CLOVER_99_0.M[523]++;
    } finally { }}

    public void print(int value)
    {try { __CLOVER_99_0.M[524]++;
    } finally { }}

    public void print(String value)
    {try { __CLOVER_99_0.M[525]++;
    } finally { }}

    /**
     *  Returns <code>this</code>: since a NullWriter doesn't actually
     *  do anything, one is as good as another!.
     *
     **/

    public IMarkupWriter getNestedWriter()
    {try { __CLOVER_99_0.M[526]++;
        __CLOVER_99_0.S[2247]++;return this;
    } finally { }}

    public String getContentType()
    {try { __CLOVER_99_0.M[527]++;
        __CLOVER_99_0.S[2248]++;return null;
    } finally { }}

    public void flush()
    {try { __CLOVER_99_0.M[528]++;
    } finally { }}

    public void end()
    {try { __CLOVER_99_0.M[529]++;
    } finally { }}

    public void end(String name)
    {try { __CLOVER_99_0.M[530]++;
    } finally { }}

    public void comment(String value)
    {try { __CLOVER_99_0.M[531]++;
    } finally { }}

    public void closeTag()
    {try { __CLOVER_99_0.M[532]++;
    } finally { }}

    public void close()
    {try { __CLOVER_99_0.M[533]++;
    } finally { }}

    /**
     *  Always returns false.
     *
     **/

    public boolean checkError()
    {try { __CLOVER_99_0.M[534]++;
        __CLOVER_99_0.S[2249]++;return false;
    } finally { }}

    public void beginEmpty(String name)
    {try { __CLOVER_99_0.M[535]++;
    } finally { }}

    public void begin(String name)
    {try { __CLOVER_99_0.M[536]++;
    } finally { }}

    public void attribute(String name, int value)
    {try { __CLOVER_99_0.M[537]++;
    } finally { }}

    public void attribute(String name, String value)
    {try { __CLOVER_99_0.M[538]++;
    } finally { }}

    /**
     *  @see org.apache.tapestry.IMarkupWriter#attribute(java.lang.String, boolean)
     *
     *  @since 3.0
     **/

    public void attribute(String name, boolean value)
    {try { __CLOVER_99_0.M[539]++;
    } finally { }}

    /**
     *  @see org.apache.tapestry.IMarkupWriter#attributeRaw(java.lang.String, java.lang.String)
     *
     *  @since 3.0
     **/

    public void attributeRaw(String name, String value)
    {try { __CLOVER_99_0.M[540]++;
    } finally { }}
}