/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.engine;

import java.io.IOException;

import javax.servlet.ServletException;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.tapestry.IComponent;
import org.apache.tapestry.IPage;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.Tapestry;
import org.apache.tapestry.request.RequestContext;
import org.apache.tapestry.request.ResponseOutputStream;

/**
 *  Basic server for creating a link to another page in the application.
 *
 *  @author Howard Lewis Ship
 *  @since 1.0.9
 *
 **/

public class PageService extends AbstractService
{public static com.cortexeb.tools.clover.d __CLOVER_100_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);

    public ILink getLink(IRequestCycle cycle, IComponent component, Object[] parameters)
    {try { __CLOVER_100_0.M[541]++;
        __CLOVER_100_0.S[2250]++;if ((((Tapestry.size(parameters) != 1) && (++__CLOVER_100_0.CT[419] != 0)) || (++__CLOVER_100_0.CF[419] == 0))){
            __CLOVER_100_0.S[2251]++;throw new IllegalArgumentException(
                Tapestry.format("service-single-parameter", Tapestry.PAGE_SERVICE));}

        __CLOVER_100_0.S[2252]++;return constructLink(cycle, Tapestry.PAGE_SERVICE, new String[] {(String) parameters[0]}, null, true);

    } finally { }}

    public void service(
        IEngineServiceView engine,
        IRequestCycle cycle,
        ResponseOutputStream output)
        throws ServletException, IOException
    {try { __CLOVER_100_0.M[542]++;
        __CLOVER_100_0.S[2253]++;RequestContext context = cycle.getRequestContext();
        __CLOVER_100_0.S[2254]++;String[] serviceContext = getServiceContext(context);

        __CLOVER_100_0.S[2255]++;if ((((Tapestry.size(serviceContext) != 1) && (++__CLOVER_100_0.CT[420] != 0)) || (++__CLOVER_100_0.CF[420] == 0))){
            __CLOVER_100_0.S[2256]++;throw new ApplicationRuntimeException(
                Tapestry.format("service-single-parameter", Tapestry.PAGE_SERVICE));}

        __CLOVER_100_0.S[2257]++;String pageName = serviceContext[0];

        // At one time, the page service required a session, but that is no longer necessary.
        // Users can now bookmark pages within a Tapestry application.  Pages
        // can implement validate() and throw a PageRedirectException if they don't
        // want to be accessed this way.  For example, most applications have a concept
        // of a "login" and have a few pages that don't require the user to be logged in,
        // and other pages that do.  The protected pages should redirect to a login page.

        __CLOVER_100_0.S[2258]++;IPage page = cycle.getPage(pageName);

        __CLOVER_100_0.S[2259]++;cycle.activate(page);

        __CLOVER_100_0.S[2260]++;engine.renderResponse(cycle, output);
    } finally { }}

    public String getName()
    {try { __CLOVER_100_0.M[543]++;
        __CLOVER_100_0.S[2261]++;return Tapestry.PAGE_SERVICE;
    } finally { }}

}