/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.engine;

import java.io.IOException;

import javax.servlet.ServletException;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.tapestry.IComponent;
import org.apache.tapestry.IPage;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.Tapestry;
import org.apache.tapestry.request.ResponseOutputStream;

/**
 *  ServiceLink used to discard all cached data (templates, specifications, et cetera).
 *  This is primarily used during development.  It could be a weakness of a Tapestry
 *  application, making it susceptible to denial of service attacks, which is why
 *  it is disabled by default.  The link generated by the ResetService redisplays the
 *  current page after discarding all data.
 *
 *  @author Howard Lewis Ship
 *  @since 1.0.9
 *  @see org.apache.tapestry.IEngine#isResetServiceEnabled()
 * 
 **/

public class ResetService extends AbstractService
{public static com.cortexeb.tools.clover.d __CLOVER_103_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);

    public ILink getLink(IRequestCycle cycle, IComponent component, Object[] parameters)
    {try { __CLOVER_103_0.M[578]++;
        __CLOVER_103_0.S[2472]++;if ((((Tapestry.size(parameters) != 0) && (++__CLOVER_103_0.CT[460] != 0)) || (++__CLOVER_103_0.CF[460] == 0))){
            __CLOVER_103_0.S[2473]++;throw new IllegalArgumentException(
                Tapestry.format("service-no-parameters", Tapestry.RESET_SERVICE));}

        __CLOVER_103_0.S[2474]++;String[] context = new String[1];
        __CLOVER_103_0.S[2475]++;context[0] = component.getPage().getPageName();

        __CLOVER_103_0.S[2476]++;return constructLink(cycle, Tapestry.RESET_SERVICE, context, null, true);
    } finally { }}

    public String getName()
    {try { __CLOVER_103_0.M[579]++;
        __CLOVER_103_0.S[2477]++;return Tapestry.RESET_SERVICE;
    } finally { }}

    public void service(
        IEngineServiceView engine,
        IRequestCycle cycle,
        ResponseOutputStream output)
        throws ServletException, IOException
    {try { __CLOVER_103_0.M[580]++;
        __CLOVER_103_0.S[2478]++;String[] context = getServiceContext(cycle.getRequestContext());

        __CLOVER_103_0.S[2479]++;if ((((Tapestry.size(context) != 1) && (++__CLOVER_103_0.CT[461] != 0)) || (++__CLOVER_103_0.CF[461] == 0))){
            __CLOVER_103_0.S[2480]++;throw new ApplicationRuntimeException(
                Tapestry.format("service-single-parameter", Tapestry.RESET_SERVICE));}

        __CLOVER_103_0.S[2481]++;String pageName = context[0];

        __CLOVER_103_0.S[2482]++;if ((((engine.isResetServiceEnabled()) && (++__CLOVER_103_0.CT[462] != 0)) || (++__CLOVER_103_0.CF[462] == 0))){
            __CLOVER_103_0.S[2483]++;engine.clearCachedData();}

        __CLOVER_103_0.S[2484]++;IPage page = cycle.getPage(pageName);

        __CLOVER_103_0.S[2485]++;cycle.activate(page);

        // Render the same page (that contained the reset link).

        __CLOVER_103_0.S[2486]++;engine.renderResponse(cycle, output);
    } finally { }}

}