/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.enhance;

import java.util.ArrayList;
import java.util.List;

import org.apache.hivemind.ClassResolver;
import org.apache.hivemind.service.ClassFab;
import org.apache.hivemind.service.ClassFactory;

/**
 *
 *  @author Mindbridge
 *  @since 3.0
 *
 */
public class EnhancementWorklistImpl implements EnhancementWorklist
{public static com.cortexeb.tools.clover.d __CLOVER_113_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    /**
     *  List of {@link IEnhancer}.
     * 
     */
    private List _enhancers;

    private String _className;
    private Class _parentClass;
    private ClassResolver _classResolver;
    private ClassFactory _classFactory;

    public EnhancementWorklistImpl(
        String className,
        Class parentClass,
        ClassResolver classResolver,
        ClassFactory classFactory)
    {try { __CLOVER_113_0.M[643]++;
        __CLOVER_113_0.S[2792]++;_className = className;
        __CLOVER_113_0.S[2793]++;_parentClass = parentClass;
        __CLOVER_113_0.S[2794]++;_classResolver = classResolver;
        __CLOVER_113_0.S[2795]++;_classFactory = classFactory;
    } finally { }}

    public String getClassName()
    {try { __CLOVER_113_0.M[644]++;
        __CLOVER_113_0.S[2796]++;return _className;
    } finally { }}

    public Class createEnhancedSubclass()
    {try { __CLOVER_113_0.M[645]++;
        __CLOVER_113_0.S[2797]++;ClassFab classFab =
            _classFactory.newClass(_className, _parentClass, _classResolver.getClassLoader());

        __CLOVER_113_0.S[2798]++;performEnhancement(classFab);

        __CLOVER_113_0.S[2799]++;return classFab.createClass();
    } finally { }}

    protected List getEnhancers()
    {try { __CLOVER_113_0.M[646]++;
        __CLOVER_113_0.S[2800]++;return _enhancers;
    } finally { }}

    public void addEnhancer(IEnhancer enhancer)
    {try { __CLOVER_113_0.M[647]++;
        __CLOVER_113_0.S[2801]++;if ((((_enhancers == null) && (++__CLOVER_113_0.CT[511] != 0)) || (++__CLOVER_113_0.CF[511] == 0))){
            __CLOVER_113_0.S[2802]++;_enhancers = new ArrayList();}

        __CLOVER_113_0.S[2803]++;_enhancers.add(enhancer);
    } finally { }}

    public boolean hasModifications()
    {try { __CLOVER_113_0.M[648]++;
        __CLOVER_113_0.S[2804]++;return _enhancers != null && !_enhancers.isEmpty();
    } finally { }}

    public void performEnhancement(ClassFab classFab)
    {try { __CLOVER_113_0.M[649]++;
        __CLOVER_113_0.S[2805]++;List enhancers = getEnhancers();

        __CLOVER_113_0.S[2806]++;if ((((enhancers == null) && (++__CLOVER_113_0.CT[512] != 0)) || (++__CLOVER_113_0.CF[512] == 0))){
            __CLOVER_113_0.S[2807]++;return;}

        __CLOVER_113_0.S[2808]++;int count = enhancers.size();

        __CLOVER_113_0.S[2809]++;for (int i = 0; (((i < count) && (++__CLOVER_113_0.CT[513] != 0)) || (++__CLOVER_113_0.CF[513] == 0)); i++){
        {
            __CLOVER_113_0.S[2810]++;IEnhancer enhancer = (IEnhancer) enhancers.get(i);

            __CLOVER_113_0.S[2811]++;enhancer.performEnhancement(classFab);
        }}
    } finally { }}

}
