/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.enhance;

import java.util.HashMap;
import java.util.Map;

/**
 * Holds a utility method that converts java type names (as they might appear in source code) into
 * JVM class names.
 * 
 * @author Howard M. Lewis Ship
 * @since 3.1
 */
public class JavaTypeUtils
{public static com.cortexeb.tools.clover.d __CLOVER_116_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    /**
     * Mapping between a primitive type and its Java VM representation Used for the encoding of
     * array types
     */
    private static Map PRIMITIVE_TYPES = new HashMap();

    static
    {
        __CLOVER_116_0.S[2834]++;PRIMITIVE_TYPES.put("boolean", "Z");
        __CLOVER_116_0.S[2835]++;PRIMITIVE_TYPES.put("short", "S");
        __CLOVER_116_0.S[2836]++;PRIMITIVE_TYPES.put("int", "I");
        __CLOVER_116_0.S[2837]++;PRIMITIVE_TYPES.put("long", "J");
        __CLOVER_116_0.S[2838]++;PRIMITIVE_TYPES.put("float", "F");
        __CLOVER_116_0.S[2839]++;PRIMITIVE_TYPES.put("double", "D");
        __CLOVER_116_0.S[2840]++;PRIMITIVE_TYPES.put("char", "C");
        __CLOVER_116_0.S[2841]++;PRIMITIVE_TYPES.put("byte", "B");
    }

    private JavaTypeUtils()
    {try { __CLOVER_116_0.M[652]++;
        // Prevent instantiation
    } finally { }}

    /**
     * Translates types from standard Java format to Java VM format. For example, java.util.Locale
     * remains java.util.Locale, but int[][] is translated to [[I and java.lang.Object[] to
     * [Ljava.lang.Object;
     */
    public static String getJVMClassName(String type)
    {try { __CLOVER_116_0.M[653]++;
        // if it is not an array, just return the type itself
        __CLOVER_116_0.S[2842]++;if ((((!type.endsWith("[]")) && (++__CLOVER_116_0.CT[514] != 0)) || (++__CLOVER_116_0.CF[514] == 0))){
            __CLOVER_116_0.S[2843]++;return type;}

        // if it is an array, convert it to JavaVM-style format
        __CLOVER_116_0.S[2844]++;StringBuffer buffer = new StringBuffer();

        __CLOVER_116_0.S[2845]++;while ((((type.endsWith("[]")) && (++__CLOVER_116_0.CT[515] != 0)) || (++__CLOVER_116_0.CF[515] == 0))){
        {
            __CLOVER_116_0.S[2846]++;buffer.append("[");
            __CLOVER_116_0.S[2847]++;type = type.substring(0, type.length() - 2);
        }}

        __CLOVER_116_0.S[2848]++;String primitiveIdentifier = (String) PRIMITIVE_TYPES.get(type);
        __CLOVER_116_0.S[2849]++;if ((((primitiveIdentifier != null) && (++__CLOVER_116_0.CT[516] != 0)) || (++__CLOVER_116_0.CF[516] == 0))){
            __CLOVER_116_0.S[2850]++;buffer.append(primitiveIdentifier);}
        else{
        {
            __CLOVER_116_0.S[2851]++;buffer.append("L");
            __CLOVER_116_0.S[2852]++;buffer.append(type);
            __CLOVER_116_0.S[2853]++;buffer.append(";");
        }}

        __CLOVER_116_0.S[2854]++;return buffer.toString();
    } finally { }}
}