/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.event;

import java.util.EventObject;

import org.apache.tapestry.IComponent;
import org.apache.tapestry.Tapestry;

/**
 * Event which describes a change to a particular {@link IComponent}.
 *
 * @author Howard Ship
 * 
 **/

public class ObservedChangeEvent extends EventObject
{public static com.cortexeb.tools.clover.d __CLOVER_118_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private IComponent _component;
    private String _propertyName;
    private Object _newValue;

	/**
	 * @deprecated To be removed in 3.1. Use {@link #ObservedChangeEvent(IComponent, String, Object)} instead.
	 */
    public ObservedChangeEvent(IComponent component, String propertyName, char newValue)
    {
        this(component, propertyName, new Character(newValue));__CLOVER_118_0.S[2855]++;try { __CLOVER_118_0.M[654]++;
    } finally { }}

	/**
	 * @deprecated To be removed in 3.1. Use {@link #ObservedChangeEvent(IComponent, String, Object)} instead.
	 */
    public ObservedChangeEvent(IComponent component, String propertyName, byte newValue)
    {
        this(component, propertyName, new Byte(newValue));__CLOVER_118_0.S[2856]++;try { __CLOVER_118_0.M[655]++;
    } finally { }}

	/**
	 * @deprecated To be removed in 3.1. Use {@link #ObservedChangeEvent(IComponent, String, Object)} instead.
	 */
    public ObservedChangeEvent(IComponent component, String propertyName, short newValue)
    {
        this(component, propertyName, new Short(newValue));__CLOVER_118_0.S[2857]++;try { __CLOVER_118_0.M[656]++;
    } finally { }}

	/**
	 * @deprecated To be removed in 3.1. Use {@link #ObservedChangeEvent(IComponent, String, Object)} instead.
	 */
    public ObservedChangeEvent(IComponent component, String propertyName, int newValue)
    {
        this(component, propertyName, new Integer(newValue));__CLOVER_118_0.S[2858]++;try { __CLOVER_118_0.M[657]++;
    } finally { }}

	/**
	 * @deprecated To be removed in 3.1. Use {@link #ObservedChangeEvent(IComponent, String, Object)} instead.
	 */
    public ObservedChangeEvent(IComponent component, String propertyName, long newValue)
    {
        this(component, propertyName, new Long(newValue));__CLOVER_118_0.S[2859]++;try { __CLOVER_118_0.M[658]++;
    } finally { }}

	/**
	 * @deprecated To be removed in 3.1. Use {@link #ObservedChangeEvent(IComponent, String, Object)} instead.
	 */
   public ObservedChangeEvent(IComponent component, String propertyName, double newValue)
    {
        this(component, propertyName, new Double(newValue));__CLOVER_118_0.S[2860]++;try { __CLOVER_118_0.M[659]++;
    } finally { }}

	/**
	 * @deprecated To be removed in 3.1. Use {@link #ObservedChangeEvent(IComponent, String, Object)} instead.
	 */
   public ObservedChangeEvent(IComponent component, String propertyName, float newValue)
    {
        this(component, propertyName, new Float(newValue));__CLOVER_118_0.S[2861]++;try { __CLOVER_118_0.M[660]++;
    } finally { }}

    /**
     *  Creates the event.  The new value must be null, or be a serializable object.
     *  (It is declared as Object as a concession to the Java 2 collections framework, where
     *  the implementations are serializable but the interfaces (Map, List, etc.) don't
     *  extend Serializable ... so we wait until runtime to check).
     *
     *  @param component The component (not necessarily a page) whose property changed.
     *  @param propertyName the name of the property which was changed.
     *  @param newValue The new value of the property. 
     *
     *  @throws IllegalArgumentException if propertyName is null, or
     *  if the new value is not serializable
     *
     **/

    public ObservedChangeEvent(IComponent component, String propertyName, Object newValue)
    {
        super(component);__CLOVER_118_0.S[2862]++;try { __CLOVER_118_0.M[661]++;

        __CLOVER_118_0.S[2863]++;if ((((propertyName == null) && (++__CLOVER_118_0.CT[517] != 0)) || (++__CLOVER_118_0.CF[517] == 0))){
            __CLOVER_118_0.S[2864]++;throw new IllegalArgumentException(
                Tapestry.format("ObservedChangeEvent.null-property-name", component));}

        __CLOVER_118_0.S[2865]++;_component = component;
        __CLOVER_118_0.S[2866]++;_propertyName = propertyName;
        __CLOVER_118_0.S[2867]++;_newValue = newValue;
    } finally { }}

	/**
	 * @deprecated To be removed in 3.1. Use {@link #ObservedChangeEvent(IComponent, String, Object)} instead.
	 */
    public ObservedChangeEvent(IComponent component, String propertyName, boolean newValue)
    {
        this(component, propertyName, (((newValue ) && (++__CLOVER_118_0.CT[518] != 0)) || (++__CLOVER_118_0.CF[518] == 0))? Boolean.TRUE : Boolean.FALSE);__CLOVER_118_0.S[2868]++;try { __CLOVER_118_0.M[662]++;
    } finally { }}

    public IComponent getComponent()
    {try { __CLOVER_118_0.M[663]++;
        __CLOVER_118_0.S[2869]++;return _component;
    } finally { }}

    public Object getNewValue()
    {try { __CLOVER_118_0.M[664]++;
        __CLOVER_118_0.S[2870]++;return _newValue;
    } finally { }}

    public String getPropertyName()
    {try { __CLOVER_118_0.M[665]++;
        __CLOVER_118_0.S[2871]++;return _propertyName;
    } finally { }}

}