/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.form;

import org.apache.tapestry.IForm;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;

/**
 *  Base class for implementing various types of text input fields.
 *  This includes {@link TextField} and
 *  {@link org.apache.tapestry.valid.ValidField}.
 *
 *
 *  @author Howard Lewis Ship
 *  @since 1.0.2
 * 
 **/

public abstract class AbstractTextField extends AbstractFormComponent
{public static com.cortexeb.tools.clover.d __CLOVER_125_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    /**
     *  Renders the form element, or responds when the form containing the element
     *  is submitted (by checking {@link Form#isRewinding()}.
     *
     **/

    protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_125_0.M[671]++;
        __CLOVER_125_0.S[2886]++;String value;

        __CLOVER_125_0.S[2887]++;IForm form = getForm(cycle);

        // It isn't enough to know whether the cycle in general is rewinding, need to know
        // specifically if the form which contains this component is rewinding.

        __CLOVER_125_0.S[2888]++;boolean rewinding = form.isRewinding();

        // If the cycle is rewinding, but the form containing this field is not,
        // then there's no point in doing more work.

        __CLOVER_125_0.S[2889]++;if ((((!rewinding && cycle.isRewinding()) && (++__CLOVER_125_0.CT[521] != 0)) || (++__CLOVER_125_0.CF[521] == 0))){
            __CLOVER_125_0.S[2890]++;return;}

        // Used whether rewinding or not.

        __CLOVER_125_0.S[2891]++;String name = form.getElementId(this);
		
        __CLOVER_125_0.S[2892]++;if ((((rewinding) && (++__CLOVER_125_0.CT[522] != 0)) || (++__CLOVER_125_0.CF[522] == 0))){
        {
            __CLOVER_125_0.S[2893]++;if ((((!isDisabled()) && (++__CLOVER_125_0.CT[523] != 0)) || (++__CLOVER_125_0.CF[523] == 0))){
            {
                __CLOVER_125_0.S[2894]++;value = cycle.getRequestContext().getParameter(name);

                __CLOVER_125_0.S[2895]++;updateValue(value);
            }}

            __CLOVER_125_0.S[2896]++;return;
        }}

        __CLOVER_125_0.S[2897]++;writer.beginEmpty("input");

        __CLOVER_125_0.S[2898]++;writer.attribute("type", (((isHidden() ) && (++__CLOVER_125_0.CT[524] != 0)) || (++__CLOVER_125_0.CF[524] == 0))? "password" : "text");

        __CLOVER_125_0.S[2899]++;if ((((isDisabled()) && (++__CLOVER_125_0.CT[525] != 0)) || (++__CLOVER_125_0.CF[525] == 0))){
            __CLOVER_125_0.S[2900]++;writer.attribute("disabled", "disabled");}

        __CLOVER_125_0.S[2901]++;writer.attribute("name", name);

        __CLOVER_125_0.S[2902]++;value = readValue();
        __CLOVER_125_0.S[2903]++;if ((((value != null) && (++__CLOVER_125_0.CT[526] != 0)) || (++__CLOVER_125_0.CF[526] == 0))){
            __CLOVER_125_0.S[2904]++;writer.attribute("value", value);}

        __CLOVER_125_0.S[2905]++;renderInformalParameters(writer, cycle);

        __CLOVER_125_0.S[2906]++;beforeCloseTag(writer, cycle);

        __CLOVER_125_0.S[2907]++;writer.closeTag();
    } finally { }}

    /**
     *  Invoked from {@link #render(IMarkupWriter, IRequestCycle)}
     *  just before the tag is closed.  This implementation does nothing,
     *  subclasses may override.
     *
     **/

    protected void beforeCloseTag(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_125_0.M[672]++;
        // Do nothing.
    } finally { }}

    /**
     *  Invoked by {@link #render(IMarkupWriter writer, IRequestCycle cycle)}
     *  when a value is obtained from the
     *  {@link javax.servlet.http.HttpServletRequest}.
     *
     **/

    abstract protected void updateValue(String value);

    /**
     *  Invoked by {@link #render(IMarkupWriter writer, IRequestCycle cycle)}
     *  when rendering a response.
     *
     *  @return the current value for the field, as a String, or null.
     **/

    abstract protected String readValue();

    public abstract boolean isHidden();

    public abstract boolean isDisabled();
}