/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.form;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.tapestry.AbstractComponent;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.Tapestry;

/**
 *  Implements a component that manages an HTML &lt;input type=radio&gt; form element.
 *  Such a component must be wrapped (possibly indirectly)
 *  inside a {@link RadioGroup} component.
 *
 *  [<a href="../../../../../ComponentReference/Radio.html">Component Reference</a>]
 *
 * 
 *  <p>{@link Radio} and {@link RadioGroup} are generally not used (except
 *  for very special cases).  Instead, a {@link PropertySelection} component is used.
 *
 *
 *  @author Howard Lewis Ship
 * 
 **/

public abstract class Radio extends AbstractComponent
{public static com.cortexeb.tools.clover.d __CLOVER_142_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    /**
     *  Renders the form element, or responds when the form containing the element
     *  is submitted (by checking {@link Form#isRewinding()}.
     *
     *
     **/

    protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_142_0.M[751]++;

        __CLOVER_142_0.S[3522]++;RadioGroup group = RadioGroup.get(cycle);
        __CLOVER_142_0.S[3523]++;if ((((group == null) && (++__CLOVER_142_0.CT[658] != 0)) || (++__CLOVER_142_0.CF[658] == 0))){
            __CLOVER_142_0.S[3524]++;throw new ApplicationRuntimeException(
                Tapestry.getMessage("Radio.must-be-contained-by-group"),
                this,
                null,
                null);}

        // The group determines rewinding from the form.

        __CLOVER_142_0.S[3525]++;boolean rewinding = group.isRewinding();

        __CLOVER_142_0.S[3526]++;int option = group.getNextOptionId();

        __CLOVER_142_0.S[3527]++;if ((((rewinding) && (++__CLOVER_142_0.CT[659] != 0)) || (++__CLOVER_142_0.CF[659] == 0))){
        {
            // If not disabled and this is the selected button within the radio group,
            // then update set the selection from the group to the value for this
            // radio button.  This will update the selected parameter of the RadioGroup.

            __CLOVER_142_0.S[3528]++;if ((((!isDisabled() && !group.isDisabled() && group.isSelected(option)) && (++__CLOVER_142_0.CT[660] != 0)) || (++__CLOVER_142_0.CF[660] == 0))){
                __CLOVER_142_0.S[3529]++;group.updateSelection(getValue());}
            __CLOVER_142_0.S[3530]++;return;
        }}

        __CLOVER_142_0.S[3531]++;writer.beginEmpty("input");

        __CLOVER_142_0.S[3532]++;writer.attribute("type", "radio");

        __CLOVER_142_0.S[3533]++;writer.attribute("name", group.getName());

        // As the group if the value for this Radio matches the selection
        // for the group as a whole; if so this is the default radio and is checked.

        __CLOVER_142_0.S[3534]++;if ((((group.isSelection(getValue())) && (++__CLOVER_142_0.CT[661] != 0)) || (++__CLOVER_142_0.CF[661] == 0))){
            __CLOVER_142_0.S[3535]++;writer.attribute("checked", "checked");}

        __CLOVER_142_0.S[3536]++;if ((((isDisabled() || group.isDisabled()) && (++__CLOVER_142_0.CT[662] != 0)) || (++__CLOVER_142_0.CF[662] == 0))){
            __CLOVER_142_0.S[3537]++;writer.attribute("disabled", "disabled");}

        // The value for the Radio matches the option number (provided by the RadioGroup).
        // When the form is submitted, the RadioGroup will know which option was,
        // in fact, selected by the user.

        __CLOVER_142_0.S[3538]++;writer.attribute("value", option);

        __CLOVER_142_0.S[3539]++;renderInformalParameters(writer, cycle);

    } finally { }}

    public abstract boolean isDisabled();

    public abstract Object getValue();
}