/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.form;

import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;

/**
 *  Implementation of {@link IPropertySelectionRenderer} that
 *  produces a &lt;select&gt; element (containing &lt;option&gt; elements).
 *
 *  @author Howard Lewis Ship
 *
 **/

public class SelectPropertySelectionRenderer
    implements IPropertySelectionRenderer
{public static com.cortexeb.tools.clover.d __CLOVER_146_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    /**
     *  Writes the &lt;select&gt; element.  If the
     *  {@link PropertySelection} is {@link PropertySelection#isDisabled() disabled}
     *  then a <code>disabled</code> attribute is written into the tag
     *  (though Navigator 4 will ignore this).
     *
     **/

    public void beginRender(
        PropertySelection component,
        IMarkupWriter writer,
        IRequestCycle cycle)
    {try { __CLOVER_146_0.M[769]++;
        __CLOVER_146_0.S[3642]++;writer.begin("select");
        __CLOVER_146_0.S[3643]++;writer.attribute("name", component.getName());

        __CLOVER_146_0.S[3644]++;if ((((component.isDisabled()) && (++__CLOVER_146_0.CT[685] != 0)) || (++__CLOVER_146_0.CF[685] == 0))){
            __CLOVER_146_0.S[3645]++;writer.attribute("disabled", "disabled");}

        __CLOVER_146_0.S[3646]++;writer.println();
    } finally { }}

    /**
     *  Closes the &lt;select&gt; element.
     *
     **/

    public void endRender(
        PropertySelection component,
        IMarkupWriter writer,
        IRequestCycle cycle)
    {try { __CLOVER_146_0.M[770]++;
        __CLOVER_146_0.S[3647]++;writer.end(); // <select>
    } finally { }}

    /**
     *  Writes an &lt;option&gt; element.
     *
     **/

    public void renderOption(
        PropertySelection component,
        IMarkupWriter writer,
        IRequestCycle cycle,
        IPropertySelectionModel model,
        Object option,
        int index,
        boolean selected)
    {try { __CLOVER_146_0.M[771]++;
        __CLOVER_146_0.S[3648]++;writer.beginEmpty("option");
        __CLOVER_146_0.S[3649]++;writer.attribute("value", model.getValue(index));

        __CLOVER_146_0.S[3650]++;if ((((selected) && (++__CLOVER_146_0.CT[686] != 0)) || (++__CLOVER_146_0.CF[686] == 0))){
            __CLOVER_146_0.S[3651]++;writer.attribute("selected", "selected");}

        __CLOVER_146_0.S[3652]++;writer.print(model.getLabel(index));

        __CLOVER_146_0.S[3653]++;writer.end();
        
        __CLOVER_146_0.S[3654]++;writer.println();
    } finally { }}
}