/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.form;

import org.apache.tapestry.IForm;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;

/**
 *  Implements a component that manages an HTML &lt;textarea&gt; form element.
 *
 *  [<a href="../../../../../ComponentReference/TextArea.html">Component Reference</a>]
 *
 *
 *  @author Howard Lewis Ship
 * 
 **/

public abstract class TextArea extends AbstractFormComponent
{public static com.cortexeb.tools.clover.d __CLOVER_149_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);

    /**
     *  Renders the form element, or responds when the form containing the element
     *  is submitted (by checking {@link Form#isRewinding()}.
     *
     **/

    protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_149_0.M[779]++;
        __CLOVER_149_0.S[3689]++;IForm form = getForm(cycle);
		
        // It isn't enough to know whether the cycle in general is rewinding, need to know
        // specifically if the form which contains this component is rewinding.

        __CLOVER_149_0.S[3690]++;boolean rewinding = form.isRewinding();

        // Used whether rewinding or not.

        __CLOVER_149_0.S[3691]++;String name = form.getElementId(this);

        __CLOVER_149_0.S[3692]++;if ((((rewinding) && (++__CLOVER_149_0.CT[694] != 0)) || (++__CLOVER_149_0.CF[694] == 0))){
        {
        	__CLOVER_149_0.S[3693]++;if ((((!isDisabled()) && (++__CLOVER_149_0.CT[695] != 0)) || (++__CLOVER_149_0.CF[695] == 0))){
	            __CLOVER_149_0.S[3694]++;setValue(cycle.getRequestContext().getParameter(name));}

            __CLOVER_149_0.S[3695]++;return;
        }}
        
        __CLOVER_149_0.S[3696]++;if ((((cycle.isRewinding()) && (++__CLOVER_149_0.CT[696] != 0)) || (++__CLOVER_149_0.CF[696] == 0))){
        	__CLOVER_149_0.S[3697]++;return;}

        __CLOVER_149_0.S[3698]++;writer.begin("textarea");

        __CLOVER_149_0.S[3699]++;writer.attribute("name", name);

        __CLOVER_149_0.S[3700]++;if ((((isDisabled()) && (++__CLOVER_149_0.CT[697] != 0)) || (++__CLOVER_149_0.CF[697] == 0))){
            __CLOVER_149_0.S[3701]++;writer.attribute("disabled", "disabled");}

        __CLOVER_149_0.S[3702]++;renderInformalParameters(writer, cycle);

        __CLOVER_149_0.S[3703]++;String value = getValue();

        __CLOVER_149_0.S[3704]++;if ((((value != null) && (++__CLOVER_149_0.CT[698] != 0)) || (++__CLOVER_149_0.CF[698] == 0))){
            __CLOVER_149_0.S[3705]++;writer.print(value);}

        __CLOVER_149_0.S[3706]++;writer.end();

    } finally { }}

    public abstract boolean isDisabled();

    public abstract String getValue();

    public abstract void setValue(String value);
}