/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.form;

import org.apache.tapestry.IForm;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.request.IUploadFile;

/**
 *  Form element used to upload files.  For the momement, it is necessary to
 *  explicitly set the form's enctype to "multipart/form-data".
 * 
 *  [<a href="../../../../../ComponentReference/Upload.html">Component Reference</a>]
 * 
 *  @author Howard Lewis Ship
 *  @since 1.0.8
 * 
 **/

public abstract class Upload extends AbstractFormComponent
{public static com.cortexeb.tools.clover.d __CLOVER_151_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_151_0.M[782]++;
        __CLOVER_151_0.S[3709]++;IForm form = getForm(cycle);
		
        __CLOVER_151_0.S[3710]++;String name = form.getElementId(this);

        __CLOVER_151_0.S[3711]++;if ((((form.isRewinding()) && (++__CLOVER_151_0.CT[699] != 0)) || (++__CLOVER_151_0.CF[699] == 0))){
        {
        	__CLOVER_151_0.S[3712]++;if ((((!isDisabled()) && (++__CLOVER_151_0.CT[700] != 0)) || (++__CLOVER_151_0.CF[700] == 0))){
	            __CLOVER_151_0.S[3713]++;setFile(cycle.getRequestContext().getUploadFile(name));}

            __CLOVER_151_0.S[3714]++;return;
        }}

		// Force the form to use the correct encoding type for
		// file uploads.
		
		__CLOVER_151_0.S[3715]++;form.setEncodingType("multipart/form-data");

        __CLOVER_151_0.S[3716]++;writer.beginEmpty("input");
        __CLOVER_151_0.S[3717]++;writer.attribute("type", "file");
        __CLOVER_151_0.S[3718]++;writer.attribute("name", name);

        __CLOVER_151_0.S[3719]++;if ((((isDisabled()) && (++__CLOVER_151_0.CT[701] != 0)) || (++__CLOVER_151_0.CF[701] == 0))){
            __CLOVER_151_0.S[3720]++;writer.attribute("disabled", "disabled");}

        // Size, width, etc. can be specified as informal parameters
        // (Not making the same mistake here that was made with TextField
        // and friends).

        __CLOVER_151_0.S[3721]++;renderInformalParameters(writer, cycle);
    } finally { }}

    public abstract boolean isDisabled();

    public abstract void setFile(IUploadFile file);
}