/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.html;

import java.io.OutputStream;
import java.io.PrintWriter;

import org.apache.tapestry.AbstractMarkupWriter;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.util.text.DefaultCharacterTranslatorSource;
import org.apache.tapestry.util.text.ICharacterTranslatorSource;

/**
 *  This class is used to create HTML output.
 *
 *  <p>The <code>HTMLWriter</code> handles the necessary escaping 
 *  of invalid characters.
 *  Specifically, the '&lt;', '&gt;' and '&amp;' characters are properly
 *  converted to their HTML entities by the <code>print()</code> methods.
 *  Similar measures are taken by the {@link #attribute(String, String)} method.
 *  Other invalid characters are converted to their numeric entity equivalent.
 *
 *  @author Howard Lewis Ship
 **/

public class HTMLWriter extends AbstractMarkupWriter
{public static com.cortexeb.tools.clover.d __CLOVER_156_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
	private static final ICharacterTranslatorSource TRANSLATOR_SOURCE = 
		new DefaultCharacterTranslatorSource();
	
	/**
	 *  Creates a new markup writer around the {@link PrintWriter}.
	 *  The writer will not be closed when the markup writer closes.
	 *  The content type is currently hard-wired to
	 *  <code>text/html</code>.
	 * 
	 *  @since 3.0
	 * 
	 **/
	
	public HTMLWriter(PrintWriter writer)
	{
		super(TRANSLATOR_SOURCE, "text/html", writer);__CLOVER_156_0.S[3848]++;try { __CLOVER_156_0.M[804]++;
	} finally { }}

    public HTMLWriter(String contentType, OutputStream outputStream)
    {
        super(TRANSLATOR_SOURCE, contentType, outputStream);__CLOVER_156_0.S[3849]++;try { __CLOVER_156_0.M[805]++;
    } finally { }}

    public HTMLWriter(String contentType, String encoding, OutputStream outputStream)
    {
        super(TRANSLATOR_SOURCE, contentType, encoding, outputStream);__CLOVER_156_0.S[3850]++;try { __CLOVER_156_0.M[806]++;
    } finally { }}

    protected HTMLWriter(String contentType)
    {
        super(TRANSLATOR_SOURCE, contentType);__CLOVER_156_0.S[3851]++;try { __CLOVER_156_0.M[807]++;
    } finally { }}

    /**
     *  Creates a default writer for content type "text/html; charset=utf-8".
     * 
     **/

    public HTMLWriter(OutputStream outputStream)
    {
        this(outputStream, "UTF-8");__CLOVER_156_0.S[3852]++;try { __CLOVER_156_0.M[808]++;
    } finally { }}

    public HTMLWriter(OutputStream outputStream, String encoding)
    {
        this("text/html", encoding, outputStream);__CLOVER_156_0.S[3853]++;try { __CLOVER_156_0.M[809]++;
    } finally { }}

    public IMarkupWriter getNestedWriter()
    {try { __CLOVER_156_0.M[810]++;
        __CLOVER_156_0.S[3854]++;return new NestedHTMLWriter(this);
    } finally { }}
}