/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.html;

import org.apache.tapestry.AbstractComponent;
import org.apache.tapestry.IAsset;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.Tapestry;

/**
 *  Used to insert an image.  To create a rollover image, use the
 *  {@link Rollover} class, which integrates a link with the image assets
 *  used with the button.
 *
 *  [<a href="../../../../../ComponentReference/Image.html">Component Reference</a>]
 *
 *
 *  @author Howard Lewis Ship
 * 
 **/

public abstract class Image extends AbstractComponent
{public static com.cortexeb.tools.clover.d __CLOVER_157_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    /**
     *  Renders the &lt;img&gt; element.
     *
     *
     **/

    protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_157_0.M[811]++;
        // Doesn't contain a body so no need to do anything on rewind (assumes no
        // sideffects to accessor methods via bindings).

        __CLOVER_157_0.S[3855]++;if ((((cycle.isRewinding()) && (++__CLOVER_157_0.CT[726] != 0)) || (++__CLOVER_157_0.CF[726] == 0))){
            __CLOVER_157_0.S[3856]++;return;}

        __CLOVER_157_0.S[3857]++;IAsset imageAsset = getImage();

        __CLOVER_157_0.S[3858]++;if ((((imageAsset == null) && (++__CLOVER_157_0.CT[727] != 0)) || (++__CLOVER_157_0.CF[727] == 0))){
            __CLOVER_157_0.S[3859]++;throw Tapestry.createRequiredParameterException(this, "image");}

        __CLOVER_157_0.S[3860]++;String imageURL = imageAsset.buildURL(cycle);

        __CLOVER_157_0.S[3861]++;writer.beginEmpty("img");

        __CLOVER_157_0.S[3862]++;writer.attribute("src", imageURL);

        __CLOVER_157_0.S[3863]++;writer.attribute("border", getBorder());

        __CLOVER_157_0.S[3864]++;renderInformalParameters(writer, cycle);

        __CLOVER_157_0.S[3865]++;writer.closeTag();

    } finally { }}

    public abstract IAsset getImage();

    public abstract int getBorder();
}