/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.html;

import java.io.IOException;
import java.io.LineNumberReader;
import java.io.Reader;
import java.io.StringReader;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.tapestry.AbstractComponent;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.Tapestry;

/**
 *  Inserts formatted text (possibly collected using a {@link org.apache.tapestry.form.TextArea} 
 *  component.
 * 
 *  [<a href="../../../../../ComponentReference/InsertText.html">Component Reference</a>]
 *
 *  <p>To maintain the line breaks provided originally, this component will
 *  break the input into individual lines and insert additional
 *  HTML to make each line seperate.
 *
 *  <p>This can be down more simply, using the &lt;pre&gt; HTML element, but
 *  that usually renders the text in a non-proportional font.
 *
 * @author Howard Lewis Ship
 * 
 **/

public abstract class InsertText extends AbstractComponent
{public static com.cortexeb.tools.clover.d __CLOVER_158_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_158_0.M[812]++;
        __CLOVER_158_0.S[3866]++;String value = getValue();

        __CLOVER_158_0.S[3867]++;if ((((value == null) && (++__CLOVER_158_0.CT[728] != 0)) || (++__CLOVER_158_0.CF[728] == 0))){
            __CLOVER_158_0.S[3868]++;return;}

        __CLOVER_158_0.S[3869]++;StringReader reader = null;
        __CLOVER_158_0.S[3870]++;LineNumberReader lineReader = null;
        __CLOVER_158_0.S[3871]++;InsertTextMode mode = getMode();

        __CLOVER_158_0.S[3872]++;try
        {
            __CLOVER_158_0.S[3873]++;reader = new StringReader(value);

            __CLOVER_158_0.S[3874]++;lineReader = new LineNumberReader(reader);

            __CLOVER_158_0.S[3875]++;int lineNumber = 0;

            __CLOVER_158_0.S[3876]++;while (true){
            {
                __CLOVER_158_0.S[3877]++;String line = lineReader.readLine();

                // Exit loop at end of file.

                __CLOVER_158_0.S[3878]++;if ((((line == null) && (++__CLOVER_158_0.CT[729] != 0)) || (++__CLOVER_158_0.CF[729] == 0))){
                    __CLOVER_158_0.S[3879]++;break;}

                __CLOVER_158_0.S[3880]++;mode.writeLine(lineNumber, line, writer);

                __CLOVER_158_0.S[3881]++;lineNumber++;
            }}

        }
        catch (IOException ex)
        {
            __CLOVER_158_0.S[3882]++;throw new ApplicationRuntimeException(
                Tapestry.getMessage("InsertText.conversion-error"),
                this,
                null,
                ex);
        }
        finally
        {
            __CLOVER_158_0.S[3883]++;close(lineReader);
            __CLOVER_158_0.S[3884]++;close(reader);
        }

    } finally { }}

    private void close(Reader reader)
    {try { __CLOVER_158_0.M[813]++;
        __CLOVER_158_0.S[3885]++;if ((((reader == null) && (++__CLOVER_158_0.CT[730] != 0)) || (++__CLOVER_158_0.CF[730] == 0))){
            __CLOVER_158_0.S[3886]++;return;}

        __CLOVER_158_0.S[3887]++;try
        {
            __CLOVER_158_0.S[3888]++;reader.close();
        }
        catch (IOException e)
        {
        }
    } finally { }}

    public abstract InsertTextMode getMode();

    public abstract void setMode(InsertTextMode mode);

    public abstract String getValue();

    /**
     * Sets the mode parameter property to its default,
     * {@link InsertTextMode#BREAK}.
     * 
     * @since 3.0
     */
    protected void finishLoad()
    {try { __CLOVER_158_0.M[814]++;
        __CLOVER_158_0.S[3889]++;setMode(InsertTextMode.BREAK);
    } finally { }}

}