/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.link;

import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.Tapestry;
import org.apache.tapestry.engine.ILink;

/**
 *  A component for creating a link to {@link org.apache.tapestry.IExternalPage} using the
 * {@link org.apache.tapestry.engine.ExternalService}.
 *
 *  [<a href="../../../../../ComponentReference/ExternalLink.html">Component Reference</a>]
 *
 * @see org.apache.tapestry.IExternalPage
 * @see org.apache.tapestry.engine.ExternalService
 *
 * @author Malcolm Edgar
 *
 **/

public abstract class ExternalLink extends AbstractLinkComponent
{public static com.cortexeb.tools.clover.d __CLOVER_177_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    public ILink getLink(IRequestCycle cycle)
    {try { __CLOVER_177_0.M[895]++;
        __CLOVER_177_0.S[4269]++;return getLink(cycle, Tapestry.EXTERNAL_SERVICE, getServiceParameters());
    } finally { }}

    private Object[] getServiceParameters()
    {try { __CLOVER_177_0.M[896]++;
        __CLOVER_177_0.S[4270]++;Object[] pageParameters = DirectLink.constructServiceParameters(getParameters());
        __CLOVER_177_0.S[4271]++;String targetPage = getTargetPage();

        __CLOVER_177_0.S[4272]++;if ((((pageParameters == null) && (++__CLOVER_177_0.CT[790] != 0)) || (++__CLOVER_177_0.CF[790] == 0))){
            __CLOVER_177_0.S[4273]++;return new Object[] { targetPage };}

        __CLOVER_177_0.S[4274]++;Object[] parameters = new Object[pageParameters.length + 1];

        __CLOVER_177_0.S[4275]++;parameters[0] = targetPage;

        __CLOVER_177_0.S[4276]++;System.arraycopy(pageParameters, 0, parameters, 1, pageParameters.length);

        __CLOVER_177_0.S[4277]++;return parameters;
    } finally { }}

    public abstract Object getParameters();

    public abstract String getTargetPage();
}
