/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.listener;

import java.util.Map;

import ognl.ObjectPropertyAccessor;
import ognl.OgnlException;

/**
 *  Exposes {@link org.apache.tapestry.IActionListener} listeners
 *  provided by the {@link ListenerMap} as read-only properties
 *  of the ListenerMap.
 *
 *  @author Howard Lewis Ship
 *  @since 2.2
 *
 **/

public class ListenerMapPropertyAccessor extends ObjectPropertyAccessor
{public static com.cortexeb.tools.clover.d __CLOVER_184_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    /**
     *  Checks to see if the ListenerMap provides the named
     *  listener, returning the listener if it does.  Otherwise,
     *  invokes the super implementation.
     * 
     **/
    
    public Object getProperty(Map context, Object target, Object name) throws OgnlException
    {try { __CLOVER_184_0.M[920]++;
        __CLOVER_184_0.S[4366]++;ListenerMap map = (ListenerMap) target;
        __CLOVER_184_0.S[4367]++;String listenerName = (String) name;

        __CLOVER_184_0.S[4368]++;if ((((map.canProvideListener(listenerName)) && (++__CLOVER_184_0.CT[808] != 0)) || (++__CLOVER_184_0.CF[808] == 0))){
            __CLOVER_184_0.S[4369]++;return map.getListener(listenerName);}

        __CLOVER_184_0.S[4370]++;return super.getProperty(context, target, name);
    } finally { }}
    
    /**
     *  Returns true if the ListenerMap contains the named listener,
     *  otherwise invokes super-implementation.
     * 
     **/

    public boolean hasGetProperty(Map context, Object target, Object oname) throws OgnlException
    {try { __CLOVER_184_0.M[921]++;
        __CLOVER_184_0.S[4371]++;ListenerMap map = (ListenerMap) target;
        __CLOVER_184_0.S[4372]++;String listenerName = (String) oname;

        __CLOVER_184_0.S[4373]++;if ((((map.canProvideListener(listenerName)) && (++__CLOVER_184_0.CT[809] != 0)) || (++__CLOVER_184_0.CF[809] == 0))){
            __CLOVER_184_0.S[4374]++;return true;}

        __CLOVER_184_0.S[4375]++;return super.hasGetProperty(context, target, oname);
    } finally { }}

}
