/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.multipart;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;

import org.apache.commons.fileupload.FileItem;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.tapestry.Tapestry;
import org.apache.tapestry.request.IUploadFile;

/**
 *  Portion of a multi-part request representing an uploaded file.
 *
 *  @author Joe Panico
 *  @since 2.0.1
 *
 **/
public class UploadPart extends Object implements IUploadFile, IPart
{public static com.cortexeb.tools.clover.d __CLOVER_188_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private static final Log LOG = LogFactory.getLog(UploadPart.class);

    private FileItem _fileItem;

    public UploadPart(FileItem fileItem)
    {try { __CLOVER_188_0.M[936]++;
        __CLOVER_188_0.S[4432]++;if ((((fileItem == null) && (++__CLOVER_188_0.CT[819] != 0)) || (++__CLOVER_188_0.CF[819] == 0))){
            __CLOVER_188_0.S[4433]++;throw new IllegalArgumentException(
                Tapestry.format("invalid-null-parameter", "fileItem"));}

        __CLOVER_188_0.S[4434]++;_fileItem = fileItem;
    } finally { }}

    public String getContentType()
    {try { __CLOVER_188_0.M[937]++;
        __CLOVER_188_0.S[4435]++;return _fileItem.getContentType();
    } finally { }}

    /**
     *  Leverages {@link File} to convert the full file path and extract
     *  the name.
     * 
     **/
    public String getFileName()
    {try { __CLOVER_188_0.M[938]++;
        __CLOVER_188_0.S[4436]++;File file = new File(this.getFilePath());

        __CLOVER_188_0.S[4437]++;return file.getName();
    } finally { }}

    /**
     *  @since 2.0.4
     * 
     **/

    public String getFilePath()
    {try { __CLOVER_188_0.M[939]++;
        __CLOVER_188_0.S[4438]++;return _fileItem.getName();
    } finally { }}

    public InputStream getStream()
    {try { __CLOVER_188_0.M[940]++;
        __CLOVER_188_0.S[4439]++;try
        {
            __CLOVER_188_0.S[4440]++;return _fileItem.getInputStream();
        }
        catch (IOException ex)
        {
            __CLOVER_188_0.S[4441]++;throw new ApplicationRuntimeException(
                Tapestry.format("UploadPart.unable-to-open-content-file", _fileItem.getName()),
                ex);
        }
    } finally { }}

    /**
     *  Deletes the external content file, if one exists.
     * 
     **/

    public void cleanup()
    {try { __CLOVER_188_0.M[941]++;
        __CLOVER_188_0.S[4442]++;_fileItem.delete();
    } finally { }}

    /**
     * Writes the uploaded content to a file.  This should be invoked at most once
     * (perhaps we should add a check for this).  This will often
     * be a simple file rename.
     * 
     * @since 3.0
     */
    public void write(File file)
    {try { __CLOVER_188_0.M[942]++;
        __CLOVER_188_0.S[4443]++;try
        {
            __CLOVER_188_0.S[4444]++;_fileItem.write(file);
        }
        catch (Exception ex)
        {
            __CLOVER_188_0.S[4445]++;throw new ApplicationRuntimeException(
                Tapestry.format("UploadPart.write-failure", file, ex.getMessage()),
                ex);
        }
    } finally { }}

    /**
     * @since 3.0
     */
    public long getSize()
    {try { __CLOVER_188_0.M[943]++;
        __CLOVER_188_0.S[4446]++;return _fileItem.getSize();
    } finally { }}

    /**
     * @since 3.0
     */
    public boolean isInMemory()
    {try { __CLOVER_188_0.M[944]++;
        __CLOVER_188_0.S[4447]++;return _fileItem.isInMemory();
    } finally { }}

}
