/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.param;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.hivemind.Location;

/**
 *  Identifies exceptions in connected parameters (parameters that
 *  are automatically assigned to component properties by the framework).
 *
 *  @author Howard Lewis Ship
 *  @since 2.0.3
 *
 **/

public class ConnectedParameterException extends ApplicationRuntimeException
{public static com.cortexeb.tools.clover.d __CLOVER_205_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private String _parameterName;
    private String _propertyName;

    public ConnectedParameterException(
        String message,
        Object component,
        String parameterName,
        String propertyName,
        Throwable rootCause)
    {
        this(message, component, parameterName, propertyName, null, rootCause);__CLOVER_205_0.S[4823]++;try { __CLOVER_205_0.M[1025]++;
    } finally { }}

    /** @since 3.0 **/

    public ConnectedParameterException(
        String message,
        Object component,
        String parameterName,
        String propertyName,
        Location location,
        Throwable rootCause)
    {
        super(message, location, rootCause);__CLOVER_205_0.S[4824]++;try { __CLOVER_205_0.M[1026]++;

        __CLOVER_205_0.S[4825]++;_parameterName = parameterName;
        __CLOVER_205_0.S[4826]++;_propertyName = propertyName;
    } finally { }}

    public String getParameterName()
    {try { __CLOVER_205_0.M[1027]++;
        __CLOVER_205_0.S[4827]++;return _parameterName;
    } finally { }}

    public String getPropertyName()
    {try { __CLOVER_205_0.M[1028]++;
        __CLOVER_205_0.S[4828]++;return _propertyName;
    } finally { }}
}