/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.parse;

/**
 *  Enapsulates a parsed component template, allowing access to the
 *  tokens parsed.
 *
 *  <p>TBD:  Record the name of the resource (or other location) from which
 *  the template was parsed (useful during debugging).
 *
 *  @author Howard Lewis Ship
 * 
 **/

public class ComponentTemplate
{public static com.cortexeb.tools.clover.d __CLOVER_215_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    /**
     *  The HTML template from which the tokens were generated.  This is a string
     *  read from a resource.  The tokens represents offsets and lengths into
     *  this string.
     *
     **/

    private char[] _templateData;

    private TemplateToken[] _tokens;

    /**
     *  Creates a new ComponentTemplate.
     *
     *  @param templateData The template data.  This is <em>not</em> copied, so
     *  the array passed in should not be modified further.
     *
     *  @param tokens  The tokens making up the template.  This is also
     *  retained (<em>not</em> copied), and so should not
     *  be modified once passed to the constructor.
     *
     **/

    public ComponentTemplate(char[] templateData, TemplateToken[] tokens)
    {try { __CLOVER_215_0.M[1052]++;
        __CLOVER_215_0.S[4960]++;_templateData = templateData;
        __CLOVER_215_0.S[4961]++;_tokens = tokens;
    } finally { }}

    public char[] getTemplateData()
    {try { __CLOVER_215_0.M[1053]++;
        __CLOVER_215_0.S[4962]++;return _templateData;
    } finally { }}

    public TemplateToken getToken(int index)
    {try { __CLOVER_215_0.M[1054]++;
        __CLOVER_215_0.S[4963]++;return _tokens[index];
    } finally { }}

    public int getTokenCount()
    {try { __CLOVER_215_0.M[1055]++;
        __CLOVER_215_0.S[4964]++;return _tokens.length;
    } finally { }}
}