/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.parse;

import java.util.Map;

import org.apache.hivemind.Location;

/**
 *  Represents localized text from the template.
 *
 *  @see TokenType#LOCALIZATION
 * 
 *  @author Howard Lewis Ship
 *  @since 3.0
 *
 **/

public class LocalizationToken extends TemplateToken
{public static com.cortexeb.tools.clover.d __CLOVER_221_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private String _tag;
    private String _key;
    private boolean _raw;
    private Map _attributes;
    
    /**
     *  Creates a new token.
     * 
     * 
     *  @param tag the tag of the element from the template
     *  @param key the localization key specified
     *  @param raw if true, then the localized value contains markup that should not be escaped
     *  @param attributes any additional attributes (beyond those used to define key and raw)
     *  that were specified.  This value is retained, not copied.
     *  @param location location of the tag which defines this token
     * 
     **/
    
    public LocalizationToken(String tag, String key, boolean raw, Map attributes, Location location)
    {
        super(TokenType.LOCALIZATION, location);__CLOVER_221_0.S[4972]++;try { __CLOVER_221_0.M[1061]++;
        
        __CLOVER_221_0.S[4973]++;_tag = tag;
        __CLOVER_221_0.S[4974]++;_key = key;
        __CLOVER_221_0.S[4975]++;_raw = raw;
        __CLOVER_221_0.S[4976]++;_attributes = attributes;
    } finally { }}
    
    /**
     *  Returns any attributes for the token, which may be null.  Do not modify
     *  the return value.
     * 
     **/
    
    public Map getAttributes()
    {try { __CLOVER_221_0.M[1062]++;
        __CLOVER_221_0.S[4977]++;return _attributes;
    } finally { }}

    public boolean isRaw()
    {try { __CLOVER_221_0.M[1063]++;
        __CLOVER_221_0.S[4978]++;return _raw;
    } finally { }}

    public String getTag()
    {try { __CLOVER_221_0.M[1064]++;
        __CLOVER_221_0.S[4979]++;return _tag;
    } finally { }}

    public String getKey()
    {try { __CLOVER_221_0.M[1065]++;
        __CLOVER_221_0.S[4980]++;return _key;
    } finally { }}
}
