/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.parse;

import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.hivemind.Locatable;
import org.apache.hivemind.Location;

/**
 *  Base class for a number of different types of tokens that can be extracted
 *  from a page/component template.  This class defines the
 *  type of the token,
 *  subclasses provide interpretations on the token.
 *
 *  @author Howard Lewis Ship
 * 
 **/

public abstract class TemplateToken implements Locatable
{public static com.cortexeb.tools.clover.d __CLOVER_228_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private TokenType _type;
    private Location _location;

    protected TemplateToken(TokenType type, Location location)
    {try { __CLOVER_228_0.M[1212]++;
        __CLOVER_228_0.S[5937]++;_type = type;
        __CLOVER_228_0.S[5938]++;_location = location;
    } finally { }}

    public TokenType getType()
    {try { __CLOVER_228_0.M[1213]++;
        __CLOVER_228_0.S[5939]++;return _type;
    } finally { }}
    
    public Location getLocation()
    {try { __CLOVER_228_0.M[1214]++;
    	__CLOVER_228_0.S[5940]++;return _location;
    } finally { }}

    public String toString()
    {try { __CLOVER_228_0.M[1215]++;
        __CLOVER_228_0.S[5941]++;ToStringBuilder builder = new ToStringBuilder(this);

        __CLOVER_228_0.S[5942]++;builder.append("type", _type.getName());
        __CLOVER_228_0.S[5943]++;builder.append("location", _location);

        __CLOVER_228_0.S[5944]++;extendDescription(builder);

        __CLOVER_228_0.S[5945]++;return builder.toString();
    } finally { }}

    /**
     *  Overridden in subclasses to append additional fields (defined in the subclass)
     *  to the description.  Subclasses may override this method without invoking
     *  this implementation, which is empty.
     * 
     *  @since 3.0
     * 
     **/

    protected void extendDescription(ToStringBuilder builder)
    {try { __CLOVER_228_0.M[1216]++;
    } finally { }}
}