/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.resource;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.Locale;

import javax.servlet.ServletContext;

import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.hivemind.Resource;
import org.apache.hivemind.util.AbstractResource;
import org.apache.hivemind.util.LocalizedResource;
import org.apache.tapestry.Tapestry;
import org.apache.tapestry.util.LocalizedContextResourceFinder;

/**
 *  Implementation of {@link org.apache.hivemind.Resource}
 *  for resources found within the web application context.
 * 
 *	
 *  @author Howard Lewis Ship
 *  @since 3.0
 */

public class ContextResource extends AbstractResource
{public static com.cortexeb.tools.clover.d __CLOVER_249_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private static final Log LOG = LogFactory.getLog(ContextResource.class);

    private ServletContext _context;

    public ContextResource(ServletContext context, String path)
    {
        this(context, path, null);__CLOVER_249_0.S[6670]++;try { __CLOVER_249_0.M[1355]++;
    } finally { }}

    public ContextResource(ServletContext context, String path, Locale locale)
    {
        super(path, locale);__CLOVER_249_0.S[6671]++;try { __CLOVER_249_0.M[1356]++;

        __CLOVER_249_0.S[6672]++;_context = context;
    } finally { }}

    /**
     *  Locates the resource using {@link LocalizedContextResourceFinder}
     *  and {@link ServletContext#getResource(java.lang.String)}.
     * 
     **/

    public Resource getLocalization(Locale locale)
    {try { __CLOVER_249_0.M[1357]++;
        __CLOVER_249_0.S[6673]++;LocalizedContextResourceFinder finder = new LocalizedContextResourceFinder(_context);

        __CLOVER_249_0.S[6674]++;String path = getPath();
        __CLOVER_249_0.S[6675]++;LocalizedResource localizedResource = finder.resolve(path, locale);

        __CLOVER_249_0.S[6676]++;if ((((localizedResource == null) && (++__CLOVER_249_0.CT[1183] != 0)) || (++__CLOVER_249_0.CF[1183] == 0))){
            __CLOVER_249_0.S[6677]++;return null;}

        __CLOVER_249_0.S[6678]++;String localizedPath = localizedResource.getResourcePath();
        __CLOVER_249_0.S[6679]++;Locale pathLocale = localizedResource.getResourceLocale();

        __CLOVER_249_0.S[6680]++;if ((((localizedPath == null) && (++__CLOVER_249_0.CT[1184] != 0)) || (++__CLOVER_249_0.CF[1184] == 0))){
            __CLOVER_249_0.S[6681]++;return null;}

        __CLOVER_249_0.S[6682]++;if ((((path.equals(localizedPath)) && (++__CLOVER_249_0.CT[1185] != 0)) || (++__CLOVER_249_0.CF[1185] == 0))){
            __CLOVER_249_0.S[6683]++;return this;}

        __CLOVER_249_0.S[6684]++;return new ContextResource(_context, localizedPath, pathLocale);
    } finally { }}

    public URL getResourceURL()
    {try { __CLOVER_249_0.M[1358]++;
        __CLOVER_249_0.S[6685]++;try
        {
            __CLOVER_249_0.S[6686]++;return _context.getResource(getPath());
        }
        catch (MalformedURLException ex)
        {
            __CLOVER_249_0.S[6687]++;LOG.warn(
                Tapestry.format(
                    "ContextResourceLocation.unable-to-reference-context-path",
                    getPath()),
                ex);

            __CLOVER_249_0.S[6688]++;return null;
        }
    } finally { }}

    public String toString()
    {try { __CLOVER_249_0.M[1359]++;
        __CLOVER_249_0.S[6689]++;return "context:" + getPath();
    } finally { }}

    public int hashCode()
    {try { __CLOVER_249_0.M[1360]++;
        __CLOVER_249_0.S[6690]++;HashCodeBuilder builder = new HashCodeBuilder(3265, 143);

        __CLOVER_249_0.S[6691]++;builder.append(getPath());

        __CLOVER_249_0.S[6692]++;return builder.toHashCode();
    } finally { }}

    protected Resource newResource(String path)
    {try { __CLOVER_249_0.M[1361]++;
        __CLOVER_249_0.S[6693]++;return new ContextResource(_context, path);
    } finally { }}

}
