/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.script;

import org.apache.tapestry.util.xml.RuleDirectedParser;
import org.xml.sax.Attributes;

/**
 * Constructs a {@link org.apache.tapestry.script.ForeachToken}
 * from a &lt;foreach&gt; element, which contains full content.
 * 
 * <p>As of 3.0, then index attribute has been added to foreach to keep 
 * track of the current index of the iterating collection.</p>
 *
 * @author Howard Lewis Ship, Harish Krishnaswamy
 * @since 3.0
 */
class ForeachRule extends AbstractTokenRule
{public static com.cortexeb.tools.clover.d __CLOVER_255_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);

    public void endElement(RuleDirectedParser parser)
    {try { __CLOVER_255_0.M[1375]++;
        __CLOVER_255_0.S[6782]++;parser.pop();
    } finally { }}

    public void startElement(RuleDirectedParser parser, Attributes attributes)
    {try { __CLOVER_255_0.M[1376]++;
        __CLOVER_255_0.S[6783]++;String key = getAttribute(attributes, "key");
        __CLOVER_255_0.S[6784]++;String index = getAttribute(attributes, "index");
        __CLOVER_255_0.S[6785]++;String expression = getAttribute(attributes, "expression");

        __CLOVER_255_0.S[6786]++;if ((((expression == null) && (++__CLOVER_255_0.CT[1202] != 0)) || (++__CLOVER_255_0.CF[1202] == 0))){
            __CLOVER_255_0.S[6787]++;expression = getAttribute(attributes, "property-path");} // 1.0, 1.1 DTD

        __CLOVER_255_0.S[6788]++;IScriptToken token = new ForeachToken(key, index, expression, parser.getLocation());

        __CLOVER_255_0.S[6789]++;addToParent(parser, token);

        __CLOVER_255_0.S[6790]++;parser.push(token);
    } finally { }}

}
