/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.script;

import org.apache.hivemind.ClassResolver;
import org.apache.tapestry.Tapestry;
import org.apache.tapestry.util.xml.BaseRule;
import org.apache.tapestry.util.xml.DocumentParseException;
import org.apache.tapestry.util.xml.RuleDirectedParser;
import org.xml.sax.Attributes;

/**
 * Constructs an {@link org.apache.tapestry.script.InputSymbolToken}
 * from an &lt;input-symbol&gt; element.
 *
 * @author Howard Lewis Ship
 * @since 3.0
 */
class InputSymbolRule extends BaseRule
{public static com.cortexeb.tools.clover.d __CLOVER_264_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private ClassResolver _resolver;

    public InputSymbolRule(ClassResolver resolver)
    {try { __CLOVER_264_0.M[1392]++;
        __CLOVER_264_0.S[6846]++;_resolver = resolver;
    } finally { }}

    public void startElement(RuleDirectedParser parser, Attributes attributes)
    {try { __CLOVER_264_0.M[1393]++;
        __CLOVER_264_0.S[6847]++;String key = getAttribute(attributes, "key");

        __CLOVER_264_0.S[6848]++;parser.validate(key, Tapestry.SIMPLE_PROPERTY_NAME_PATTERN, "ScriptParser.invalid-key");

        __CLOVER_264_0.S[6849]++;String className = getAttribute(attributes, "class");
        __CLOVER_264_0.S[6850]++;Class expectedClass = lookupClass(parser, className);

        __CLOVER_264_0.S[6851]++;String required = getAttribute(attributes, "required");

        __CLOVER_264_0.S[6852]++;InputSymbolToken token =
            new InputSymbolToken(key, expectedClass, required.equals("yes"), parser.getLocation());

        __CLOVER_264_0.S[6853]++;IScriptToken parent = (IScriptToken) parser.peek();
        __CLOVER_264_0.S[6854]++;parent.addToken(token);
    } finally { }}

    private Class lookupClass(RuleDirectedParser parser, String className)
    {try { __CLOVER_264_0.M[1394]++;
        __CLOVER_264_0.S[6855]++;if ((((Tapestry.isBlank(className)) && (++__CLOVER_264_0.CT[1210] != 0)) || (++__CLOVER_264_0.CF[1210] == 0))){
            __CLOVER_264_0.S[6856]++;return null;}

        __CLOVER_264_0.S[6857]++;try
        {
            __CLOVER_264_0.S[6858]++;return _resolver.findClass(className);
        }
        catch (Exception ex)
        {
            __CLOVER_264_0.S[6859]++;throw new DocumentParseException(
                Tapestry.format("ScriptParser.unable-to-resolve-class", className),
                parser.getLocation(),
                ex);
        }
    } finally { }}
}
