/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.script;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.hivemind.Location;
import org.apache.tapestry.Tapestry;

/**
 *  A token that validates that an input symbol exists or is of a
 *  declared type.
 *
 *
 *  @author Howard Lewis Ship
 *  @since 2.2
 * 
 **/

class InputSymbolToken extends AbstractToken
{public static com.cortexeb.tools.clover.d __CLOVER_265_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private String _key;
    private Class _class;
    private boolean _required;

    InputSymbolToken(String key, Class clazz, boolean required, Location location)
    {
        super(location);__CLOVER_265_0.S[6860]++;try { __CLOVER_265_0.M[1395]++;

        __CLOVER_265_0.S[6861]++;_key = key;
        __CLOVER_265_0.S[6862]++;_class = clazz;
        __CLOVER_265_0.S[6863]++;_required = required;
    } finally { }}

    public void write(StringBuffer buffer, ScriptSession session)
    {try { __CLOVER_265_0.M[1396]++;
        __CLOVER_265_0.S[6864]++;Object value = session.getSymbols().get(_key);

        __CLOVER_265_0.S[6865]++;if ((((_required && value == null) && (++__CLOVER_265_0.CT[1211] != 0)) || (++__CLOVER_265_0.CF[1211] == 0))){
            __CLOVER_265_0.S[6866]++;throw new ApplicationRuntimeException(
                Tapestry.format("InputSymbolToken.required", _key),
                getLocation(),
                null);}

        __CLOVER_265_0.S[6867]++;if ((((value != null && _class != null && !_class.isAssignableFrom(value.getClass())) && (++__CLOVER_265_0.CT[1212] != 0)) || (++__CLOVER_265_0.CF[1212] == 0))){
            __CLOVER_265_0.S[6868]++;throw new ApplicationRuntimeException(
                Tapestry.format(
                    "InputSymbolToken.wrong-type",
                    _key,
                    value.getClass().getName(),
                    _class.getName()),
                getLocation(),
                null);}
    } finally { }}

}
