/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.script;

import org.apache.tapestry.Tapestry;
import org.apache.tapestry.util.xml.RuleDirectedParser;
import org.xml.sax.Attributes;

/**
 * Constructs an {@link org.apache.tapestry.script.LetToken}
 * from a &lt;let&gt; element, which may contain full content.
 *
 * @author Howard Lewis Ship
 * @since 3.0
 */
class LetRule extends AbstractTokenRule
{public static com.cortexeb.tools.clover.d __CLOVER_268_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);

    public void startElement(RuleDirectedParser parser, Attributes attributes)
    {try { __CLOVER_268_0.M[1402]++;
        __CLOVER_268_0.S[6881]++;String key = getAttribute(attributes, "key");
        
        __CLOVER_268_0.S[6882]++;String unique = getAttribute(attributes, "unique");
        __CLOVER_268_0.S[6883]++;boolean uniqueFlag = unique != null && unique.equals("yes"); 

        __CLOVER_268_0.S[6884]++;parser.validate(key, Tapestry.SIMPLE_PROPERTY_NAME_PATTERN, "ScriptParser.invalid-key");

        __CLOVER_268_0.S[6885]++;LetToken token = new LetToken(key, uniqueFlag, parser.getLocation());

        __CLOVER_268_0.S[6886]++;addToParent(parser, token);

        __CLOVER_268_0.S[6887]++;parser.push(token);
    } finally { }}

    public void endElement(RuleDirectedParser parser)
    {try { __CLOVER_268_0.M[1403]++;
        __CLOVER_268_0.S[6888]++;parser.pop();
    } finally { }}

}
