/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.script;

import java.util.Map;

import org.apache.hivemind.Location;

/**
 *  Allows for the creation of new symbols that can be used in the script
 *  or returned to the caller.
 *
 *  <p>The &lt;let&gt; tag wraps around static text and &lt;insert&gt;
 *  elements.  The results are trimmed.
 *
 *  @author Howard Lewis Ship
 *  @since 0.2.9
 * 
 **/

class LetToken extends AbstractToken
{public static com.cortexeb.tools.clover.d __CLOVER_269_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private String _key;
    private boolean _unique;
    private int _bufferLengthHighwater = 20;

    public LetToken(String key, boolean unique, Location location)
    {
        super(location);__CLOVER_269_0.S[6889]++;try { __CLOVER_269_0.M[1404]++;

        __CLOVER_269_0.S[6890]++;_key = key;
        __CLOVER_269_0.S[6891]++;_unique = unique;
    } finally { }}

    public void write(StringBuffer buffer, ScriptSession session)
    {try { __CLOVER_269_0.M[1405]++;
        __CLOVER_269_0.S[6892]++;if ((((buffer != null) && (++__CLOVER_269_0.CT[1215] != 0)) || (++__CLOVER_269_0.CF[1215] == 0))){
            __CLOVER_269_0.S[6893]++;throw new IllegalArgumentException();}

        __CLOVER_269_0.S[6894]++;buffer = new StringBuffer(_bufferLengthHighwater);

        __CLOVER_269_0.S[6895]++;writeChildren(buffer, session);

        // Store the symbol back into the root set of symbols.

        __CLOVER_269_0.S[6896]++;Map symbols = session.getSymbols();

        __CLOVER_269_0.S[6897]++;String value = buffer.toString().trim();

        __CLOVER_269_0.S[6898]++;if ((((_unique) && (++__CLOVER_269_0.CT[1216] != 0)) || (++__CLOVER_269_0.CF[1216] == 0))){
            __CLOVER_269_0.S[6899]++;value = session.getProcessor().getUniqueString(value);}

        __CLOVER_269_0.S[6900]++;symbols.put(_key, value);

        // Store the buffer length from this run for the next run, since its
        // going to be approximately the right size.

        __CLOVER_269_0.S[6901]++;_bufferLengthHighwater = Math.max(_bufferLengthHighwater, buffer.length());
    } finally { }}
}