/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.script;

import org.apache.hivemind.Location;

/**
 *  
 *  Like {@link org.apache.tapestry.script.LetToken}, but sets the value
 *  from an expression attribute, rather than a body of full content.
 *
 *  @author Howard Lewis Ship
 *  @since 2.2
 *
 **/

class SetToken extends AbstractToken
{public static com.cortexeb.tools.clover.d __CLOVER_275_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private String _key;
    private String _expression;

    SetToken(String key, String expression, Location location)
    {
        super(location);__CLOVER_275_0.S[6949]++;try { __CLOVER_275_0.M[1422]++;
        __CLOVER_275_0.S[6950]++;_key = key;
        __CLOVER_275_0.S[6951]++;_expression = expression;
    } finally { }}

    /**
     *   
     *  Doesn't <em>write</em>, it evaluates the expression and assigns
     *  the result back to the key. 
     * 
     **/

    public void write(StringBuffer buffer, ScriptSession session)
    {try { __CLOVER_275_0.M[1423]++;

        __CLOVER_275_0.S[6952]++;Object value = evaluate(_expression, session);

        __CLOVER_275_0.S[6953]++;session.getSymbols().put(_key, value);
    } finally { }}

}