/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.services.impl;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.apache.hivemind.Location;
import org.apache.tapestry.IBinding;
import org.apache.tapestry.IComponent;
import org.apache.tapestry.services.BindingFactory;
import org.apache.tapestry.services.BindingSource;

/**
 * Implementation of the <code>tapestry.bindings.BindingSource</code> service.
 * 
 * @author Howard Lewis Ship
 * @since 3.1
 */
public class BindingSourceImpl implements BindingSource
{public static com.cortexeb.tools.clover.d __CLOVER_303_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private List _contributions;

    private BindingFactory _literalBindingFactory;

    /**
     * Keyed on prefix, value is {@link BindingFactory}.
     */
    private Map _factoryMap = new HashMap();

    public void initializeService()
    {try { __CLOVER_303_0.M[1451]++;
        __CLOVER_303_0.S[7018]++;Iterator i = _contributions.iterator();

        __CLOVER_303_0.S[7019]++;while ((((i.hasNext()) && (++__CLOVER_303_0.CT[1223] != 0)) || (++__CLOVER_303_0.CF[1223] == 0))){
        {
            __CLOVER_303_0.S[7020]++;BindingPrefixContribution c = (BindingPrefixContribution) i.next();

            __CLOVER_303_0.S[7021]++;_factoryMap.put(c.getPrefix(), c.getFactory());
        }}
    } finally { }}

    public IBinding createBinding(IComponent component, String locator, Location location)
    {try { __CLOVER_303_0.M[1452]++;
        __CLOVER_303_0.S[7022]++;BindingFactory factory = _literalBindingFactory;
        __CLOVER_303_0.S[7023]++;String path = locator;

        __CLOVER_303_0.S[7024]++;int colonx = locator.indexOf(':');

        __CLOVER_303_0.S[7025]++;if ((((colonx > 1) && (++__CLOVER_303_0.CT[1224] != 0)) || (++__CLOVER_303_0.CF[1224] == 0))){
        {
            __CLOVER_303_0.S[7026]++;String prefix = locator.substring(0, colonx);

            __CLOVER_303_0.S[7027]++;BindingFactory prefixedFactory = (BindingFactory) _factoryMap.get(prefix);

            __CLOVER_303_0.S[7028]++;if ((((prefixedFactory != null) && (++__CLOVER_303_0.CT[1225] != 0)) || (++__CLOVER_303_0.CF[1225] == 0))){
            {
                __CLOVER_303_0.S[7029]++;factory = prefixedFactory;
                __CLOVER_303_0.S[7030]++;path = locator.substring(colonx + 1);
            }}
        }}

        __CLOVER_303_0.S[7031]++;return factory.createBinding(component, path, location);
    } finally { }}

    public void setContributions(List contributions)
    {try { __CLOVER_303_0.M[1453]++;
        __CLOVER_303_0.S[7032]++;_contributions = contributions;
    } finally { }}

    public void setLiteralBindingFactory(BindingFactory literalBindingFactory)
    {try { __CLOVER_303_0.M[1454]++;
        __CLOVER_303_0.S[7033]++;_literalBindingFactory = literalBindingFactory;
    } finally { }}
}