/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.services.impl;

import org.apache.commons.logging.Log;
import org.apache.tapestry.IComponent;
import org.apache.tapestry.IRender;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.ITemplateComponent;
import org.apache.tapestry.engine.IPageLoader;
import org.apache.tapestry.parse.ComponentTemplate;
import org.apache.tapestry.services.BindingSource;
import org.apache.tapestry.services.ComponentTemplateLoader;
import org.apache.tapestry.services.TemplateSource;

/**
 * Utility service, <code>tapestry.page.ComponentTemplateLoader</code>,
 * which will process the component's
 * {@link org.apache.tapestry.parse.ComponentTemplate template}, which involves working through the
 * nested structure of the template and hooking the various static template blocks and components
 * together using {@link org.apache.tapestry.IComponent#addBody(IRender)}and
 * {@link org.apache.tapestry.ITemplateComponent#addOuter(IRender)}.
 * 
 * <p>
 * Because this service must be reentrant, it acts as a factory for
 * a {@link org.apache.tapestry.services.impl.ComponentTemplateLoaderLogic} that
 * is created (and discarded) for each component whose template is loaded.
 * 
 * @author Howard Lewis Ship
 * @since 3.0
 */

public class ComponentTemplateLoaderImpl implements ComponentTemplateLoader
{public static com.cortexeb.tools.clover.d __CLOVER_306_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private Log _log;

    private IPageLoader _pageLoader;

    private TemplateSource _templateSource;

    /** @since 3.1 */

    private BindingSource _bindingSource;

    public void loadTemplate(IRequestCycle requestCycle, ITemplateComponent loadComponent)
    {try { __CLOVER_306_0.M[1465]++;
        __CLOVER_306_0.S[7117]++;ComponentTemplate template = _templateSource.getTemplate(requestCycle, loadComponent);

        __CLOVER_306_0.S[7118]++;ComponentTemplateLoaderLogic logic = new ComponentTemplateLoaderLogic(_log, _pageLoader, _bindingSource);

        __CLOVER_306_0.S[7119]++;logic.loadTemplate(requestCycle, loadComponent, template);
    } finally { }}

    /** @since 3.1 */

    public void setPageLoader(IPageLoader pageLoader)
    {try { __CLOVER_306_0.M[1466]++;
        __CLOVER_306_0.S[7120]++;_pageLoader = pageLoader;
    } finally { }}

    /** @since 3.1 */

    public void setLog(Log log)
    {try { __CLOVER_306_0.M[1467]++;
        __CLOVER_306_0.S[7121]++;_log = log;
    } finally { }}

    /**
     * @since 3.1
     */

    public void setTemplateSource(TemplateSource templateSource)
    {try { __CLOVER_306_0.M[1468]++;
        __CLOVER_306_0.S[7122]++;_templateSource = templateSource;
    } finally { }}

    /**
     * @since 3.1
     */

    public void setBindingSource(BindingSource bindingSource)
    {try { __CLOVER_306_0.M[1469]++;
        __CLOVER_306_0.S[7123]++;_bindingSource = bindingSource;
    } finally { }}
}