/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.services.impl;

import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import org.apache.commons.logging.Log;
import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.hivemind.Location;
import org.apache.tapestry.BaseComponent;
import org.apache.tapestry.IBinding;
import org.apache.tapestry.IComponent;
import org.apache.tapestry.IRender;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.ITemplateComponent;
import org.apache.tapestry.Tapestry;
import org.apache.tapestry.binding.StaticBinding;
import org.apache.tapestry.engine.IPageLoader;
import org.apache.tapestry.parse.CloseToken;
import org.apache.tapestry.parse.ComponentTemplate;
import org.apache.tapestry.parse.LocalizationToken;
import org.apache.tapestry.parse.OpenToken;
import org.apache.tapestry.parse.TemplateToken;
import org.apache.tapestry.parse.TextToken;
import org.apache.tapestry.parse.TokenType;
import org.apache.tapestry.services.BindingSource;
import org.apache.tapestry.services.TemplateSource;
import org.apache.tapestry.spec.IComponentSpecification;
import org.apache.tapestry.spec.IContainedComponent;

/**
 * Contains the logic from {@link org.apache.tapestry.services.impl.ComponentTemplateLoaderImpl},
 * which creates one of these instances to process the request. This is necessary because the
 * service must be re-entrant (because templates can contain components that have templates).
 * 
 * @author Howard Lewis Ship
 * @since 3.1
 */
public class ComponentTemplateLoaderLogic
{public static com.cortexeb.tools.clover.d __CLOVER_307_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private Log _log;

    private IPageLoader _pageLoader;

    private IRequestCycle _requestCycle;

    private ITemplateComponent _loadComponent;

    private BindingSource _bindingSource;

    private IComponent[] _stack;

    private int _stackx;

    private IComponent _activeComponent = null;

    private Set _seenIds = new HashSet();

    public ComponentTemplateLoaderLogic(Log log, IPageLoader pageLoader, BindingSource bindingSource)
    {try { __CLOVER_307_0.M[1470]++;
        __CLOVER_307_0.S[7124]++;_log = log;
        __CLOVER_307_0.S[7125]++;_pageLoader = pageLoader;
        __CLOVER_307_0.S[7126]++;_bindingSource = bindingSource;
    } finally { }}

    public void loadTemplate(IRequestCycle requestCycle, ITemplateComponent loadComponent,
            ComponentTemplate template)
    {try { __CLOVER_307_0.M[1471]++;
        __CLOVER_307_0.S[7127]++;_requestCycle = requestCycle;
        __CLOVER_307_0.S[7128]++;_loadComponent = loadComponent;

        __CLOVER_307_0.S[7129]++;process(template);
    } finally { }}

    private void process(ComponentTemplate template)
    {try { __CLOVER_307_0.M[1472]++;
        __CLOVER_307_0.S[7130]++;int count = template.getTokenCount();

        __CLOVER_307_0.S[7131]++;_stack = new IComponent[count];

        __CLOVER_307_0.S[7132]++;for (int i = 0; (((i < count) && (++__CLOVER_307_0.CT[1240] != 0)) || (++__CLOVER_307_0.CF[1240] == 0)); i++){
        {
            __CLOVER_307_0.S[7133]++;TemplateToken token = template.getToken(i);

            __CLOVER_307_0.S[7134]++;TokenType type = token.getType();

            __CLOVER_307_0.S[7135]++;if ((((type == TokenType.TEXT) && (++__CLOVER_307_0.CT[1241] != 0)) || (++__CLOVER_307_0.CF[1241] == 0))){
            {
                __CLOVER_307_0.S[7136]++;process((TextToken) token);
                __CLOVER_307_0.S[7137]++;continue;
            }}

            __CLOVER_307_0.S[7138]++;if ((((type == TokenType.OPEN) && (++__CLOVER_307_0.CT[1242] != 0)) || (++__CLOVER_307_0.CF[1242] == 0))){
            {
                __CLOVER_307_0.S[7139]++;process((OpenToken) token);
                __CLOVER_307_0.S[7140]++;continue;
            }}

            __CLOVER_307_0.S[7141]++;if ((((type == TokenType.CLOSE) && (++__CLOVER_307_0.CT[1243] != 0)) || (++__CLOVER_307_0.CF[1243] == 0))){
            {
                __CLOVER_307_0.S[7142]++;process((CloseToken) token);
                __CLOVER_307_0.S[7143]++;continue;
            }}

            __CLOVER_307_0.S[7144]++;if ((((type == TokenType.LOCALIZATION) && (++__CLOVER_307_0.CT[1244] != 0)) || (++__CLOVER_307_0.CF[1244] == 0))){
            {
                __CLOVER_307_0.S[7145]++;process((LocalizationToken) token);
                __CLOVER_307_0.S[7146]++;continue;
            }}
        }}

        // This is also pretty much unreachable, and the message is kind of out
        // of date, too.

        __CLOVER_307_0.S[7147]++;if ((((_stackx != 0) && (++__CLOVER_307_0.CT[1245] != 0)) || (++__CLOVER_307_0.CF[1245] == 0))){
            __CLOVER_307_0.S[7148]++;throw new ApplicationRuntimeException(Tapestry
                    .getMessage("BaseComponent.unbalance-open-tags"), _loadComponent, null, null);}

        __CLOVER_307_0.S[7149]++;checkAllComponentsReferenced();
    } finally { }}

    /**
     * Adds the token (which implements {@link IRender}) to the active component (using
     * {@link IComponent#addBody(IRender)}), or to this component
     * {@link BaseComponent#addOuter(IRender)}.
     * <p>
     * A check is made that the active component allows a body.
     */

    private void process(TextToken token)
    {try { __CLOVER_307_0.M[1473]++;
        __CLOVER_307_0.S[7150]++;if ((((_activeComponent == null) && (++__CLOVER_307_0.CT[1246] != 0)) || (++__CLOVER_307_0.CF[1246] == 0))){
        {
            __CLOVER_307_0.S[7151]++;_loadComponent.addOuter(token);
            __CLOVER_307_0.S[7152]++;return;
        }}

        __CLOVER_307_0.S[7153]++;if ((((!_activeComponent.getSpecification().getAllowBody()) && (++__CLOVER_307_0.CT[1247] != 0)) || (++__CLOVER_307_0.CF[1247] == 0))){
            __CLOVER_307_0.S[7154]++;throw createBodylessComponentException(_activeComponent);}

        __CLOVER_307_0.S[7155]++;_activeComponent.addBody(token);
    } finally { }}

    private void process(OpenToken token)
    {try { __CLOVER_307_0.M[1474]++;
        __CLOVER_307_0.S[7156]++;String id = token.getId();
        __CLOVER_307_0.S[7157]++;IComponent component = null;
        __CLOVER_307_0.S[7158]++;String componentType = token.getComponentType();

        __CLOVER_307_0.S[7159]++;if ((((componentType == null) && (++__CLOVER_307_0.CT[1248] != 0)) || (++__CLOVER_307_0.CF[1248] == 0))){
            __CLOVER_307_0.S[7160]++;component = getEmbeddedComponent(id);}
        else{
        {
            __CLOVER_307_0.S[7161]++;checkForDuplicateId(id, token.getLocation());

            __CLOVER_307_0.S[7162]++;component = createImplicitComponent(id, componentType, token.getLocation());
        }}

        // Make sure the template contains each component only once.

        __CLOVER_307_0.S[7163]++;if ((((_seenIds.contains(id)) && (++__CLOVER_307_0.CT[1249] != 0)) || (++__CLOVER_307_0.CF[1249] == 0))){
            __CLOVER_307_0.S[7164]++;throw new ApplicationRuntimeException(ImplMessages.multipleComponentReferences(
                    _loadComponent,
                    id), _loadComponent, token.getLocation(), null);}

        __CLOVER_307_0.S[7165]++;_seenIds.add(id);

        __CLOVER_307_0.S[7166]++;if ((((_activeComponent == null) && (++__CLOVER_307_0.CT[1250] != 0)) || (++__CLOVER_307_0.CF[1250] == 0))){
            __CLOVER_307_0.S[7167]++;_loadComponent.addOuter(component);}
        else{
        {
            // Note: this code may no longer be reachable (because the
            // template parser does this check first).

            __CLOVER_307_0.S[7168]++;if ((((!_activeComponent.getSpecification().getAllowBody()) && (++__CLOVER_307_0.CT[1251] != 0)) || (++__CLOVER_307_0.CF[1251] == 0))){
                __CLOVER_307_0.S[7169]++;throw createBodylessComponentException(_activeComponent);}

            __CLOVER_307_0.S[7170]++;_activeComponent.addBody(component);
        }}

        __CLOVER_307_0.S[7171]++;addTemplateBindings(component, token);

        __CLOVER_307_0.S[7172]++;_stack[_stackx++] = _activeComponent;

        __CLOVER_307_0.S[7173]++;_activeComponent = component;
    } finally { }}

    private void checkForDuplicateId(String id, Location location)
    {try { __CLOVER_307_0.M[1475]++;
        __CLOVER_307_0.S[7174]++;if ((((id == null) && (++__CLOVER_307_0.CT[1252] != 0)) || (++__CLOVER_307_0.CF[1252] == 0))){
            __CLOVER_307_0.S[7175]++;return;}

        __CLOVER_307_0.S[7176]++;IContainedComponent cc = _loadComponent.getSpecification().getComponent(id);

        __CLOVER_307_0.S[7177]++;if ((((cc != null) && (++__CLOVER_307_0.CT[1253] != 0)) || (++__CLOVER_307_0.CF[1253] == 0))){
            __CLOVER_307_0.S[7178]++;throw new ApplicationRuntimeException(ImplMessages.dupeComponentId(id, cc),
                    _loadComponent, location, null);}
    } finally { }}

    private IComponent createImplicitComponent(String id, String componentType, Location location)
    {try { __CLOVER_307_0.M[1476]++;
        __CLOVER_307_0.S[7179]++;IComponent result = _pageLoader.createImplicitComponent(
                _requestCycle,
                _loadComponent,
                id,
                componentType,
                location);

        __CLOVER_307_0.S[7180]++;return result;
    } finally { }}

    private IComponent getEmbeddedComponent(String id)
    {try { __CLOVER_307_0.M[1477]++;
        __CLOVER_307_0.S[7181]++;return _loadComponent.getComponent(id);
    } finally { }}

    private void process(CloseToken token)
    {try { __CLOVER_307_0.M[1478]++;
        // Again, this is pretty much impossible to reach because
        // the template parser does a great job.

        __CLOVER_307_0.S[7182]++;if ((((_stackx <= 0) && (++__CLOVER_307_0.CT[1254] != 0)) || (++__CLOVER_307_0.CF[1254] == 0))){
            __CLOVER_307_0.S[7183]++;throw new ApplicationRuntimeException(ImplMessages.unbalancedCloseTags(),
                    _loadComponent, token.getLocation(), null);}

        // Null and forget the top element on the stack.

        __CLOVER_307_0.S[7184]++;_stack[_stackx--] = null;

        __CLOVER_307_0.S[7185]++;_activeComponent = _stack[_stackx];
    } finally { }}

    private void process(LocalizationToken token)
    {try { __CLOVER_307_0.M[1479]++;
        __CLOVER_307_0.S[7186]++;IRender render = new LocalizedStringRender(_loadComponent, token);

        __CLOVER_307_0.S[7187]++;if ((((_activeComponent == null) && (++__CLOVER_307_0.CT[1255] != 0)) || (++__CLOVER_307_0.CF[1255] == 0))){
            __CLOVER_307_0.S[7188]++;_loadComponent.addOuter(render);}
        else{
            __CLOVER_307_0.S[7189]++;_activeComponent.addBody(render);}
    } finally { }}

    /**
     * Adds bindings based on attributes in the template.
     */

    private void addTemplateBindings(IComponent component, OpenToken token)
    {try { __CLOVER_307_0.M[1480]++;
        __CLOVER_307_0.S[7190]++;IComponentSpecification spec = component.getSpecification();

        __CLOVER_307_0.S[7191]++;Map attributes = token.getAttributesMap();

        __CLOVER_307_0.S[7192]++;if ((((attributes != null) && (++__CLOVER_307_0.CT[1256] != 0)) || (++__CLOVER_307_0.CF[1256] == 0))){
        {
            __CLOVER_307_0.S[7193]++;Iterator i = attributes.entrySet().iterator();

            __CLOVER_307_0.S[7194]++;while ((((i.hasNext()) && (++__CLOVER_307_0.CT[1257] != 0)) || (++__CLOVER_307_0.CF[1257] == 0))){
            {
                __CLOVER_307_0.S[7195]++;Map.Entry entry = (Map.Entry) i.next();

                __CLOVER_307_0.S[7196]++;String name = (String) entry.getKey();
                __CLOVER_307_0.S[7197]++;String value = (String) entry.getValue();

                __CLOVER_307_0.S[7198]++;IBinding binding = _bindingSource.createBinding(_loadComponent, value, token
                        .getLocation());

                __CLOVER_307_0.S[7199]++;addBinding(component, spec, name, binding);
            }}
        }}

        // if the component defines a templateTag parameter and
        // there is no established binding for that parameter,
        // add a static binding carrying the template tag

        __CLOVER_307_0.S[7200]++;if ((((spec.getParameter(TemplateSource.TEMPLATE_TAG_PARAMETER_NAME) != null
                && component.getBinding(TemplateSource.TEMPLATE_TAG_PARAMETER_NAME) == null) && (++__CLOVER_307_0.CT[1258] != 0)) || (++__CLOVER_307_0.CF[1258] == 0))){
        {
            __CLOVER_307_0.S[7201]++;IBinding binding = _bindingSource.createBinding(component, token.getTag(), token
                    .getLocation());

            __CLOVER_307_0.S[7202]++;addBinding(component, spec, TemplateSource.TEMPLATE_TAG_PARAMETER_NAME, binding);
        }}
    } finally { }}

    /**
     * Adds an expression binding, checking for errors related to reserved and informal parameters.
     * <p>
     * It is an error to specify expression bindings in both the specification and the template.
     */

    private void addBinding(IComponent component, IComponentSpecification spec, String name,
            IBinding binding)
    {try { __CLOVER_307_0.M[1481]++;

        // If matches a formal parameter name, allow it to be set
        // unless there's already a binding.

        __CLOVER_307_0.S[7203]++;boolean valid = validate(component, spec, name, binding);

        __CLOVER_307_0.S[7204]++;if ((((valid) && (++__CLOVER_307_0.CT[1259] != 0)) || (++__CLOVER_307_0.CF[1259] == 0))){
            __CLOVER_307_0.S[7205]++;component.setBinding(name, binding);}
    } finally { }}

    private boolean validate(IComponent component, IComponentSpecification spec, String name,
            IBinding binding)
    {try { __CLOVER_307_0.M[1482]++;
        // TODO: This is ugly! Need a better/smarter way, even if we have to extend BindingSource
        // to tell us.

        __CLOVER_307_0.S[7206]++;boolean literal = binding instanceof StaticBinding;

        __CLOVER_307_0.S[7207]++;boolean isFormal = (spec.getParameter(name) != null);

        __CLOVER_307_0.S[7208]++;if ((((isFormal) && (++__CLOVER_307_0.CT[1260] != 0)) || (++__CLOVER_307_0.CF[1260] == 0))){
        {
            __CLOVER_307_0.S[7209]++;if ((((component.getBinding(name) != null) && (++__CLOVER_307_0.CT[1261] != 0)) || (++__CLOVER_307_0.CF[1261] == 0))){
            {
                // Literal bindings in the template that conflict with bound parameters
                // from the spec are silently ignored.

                __CLOVER_307_0.S[7210]++;if ((((literal) && (++__CLOVER_307_0.CT[1262] != 0)) || (++__CLOVER_307_0.CF[1262] == 0))){
                    __CLOVER_307_0.S[7211]++;return false;}

                __CLOVER_307_0.S[7212]++;throw new ApplicationRuntimeException(ImplMessages.dupeTemplateBinding(
                        name,
                        component,
                        _loadComponent), component, binding.getLocation(), null);
            }}

            __CLOVER_307_0.S[7213]++;return true;
        }}

        __CLOVER_307_0.S[7214]++;if ((((!spec.getAllowInformalParameters()) && (++__CLOVER_307_0.CT[1263] != 0)) || (++__CLOVER_307_0.CF[1263] == 0))){
        {
            // Again; if informal parameters are disallowed, ignore literal bindings, as they
            // are there as placeholders or for WYSIWYG.

            __CLOVER_307_0.S[7215]++;if ((((literal) && (++__CLOVER_307_0.CT[1264] != 0)) || (++__CLOVER_307_0.CF[1264] == 0))){
                __CLOVER_307_0.S[7216]++;return false;}

            __CLOVER_307_0.S[7217]++;throw new ApplicationRuntimeException(ImplMessages.templateBindingForInformalParameter(
                    _loadComponent,
                    name,
                    component), component, binding.getLocation(), null);
        }}

        // If the name is reserved (matches a formal parameter
        // or reserved name, caselessly), then skip it.

        __CLOVER_307_0.S[7218]++;if ((((spec.isReservedParameterName(name)) && (++__CLOVER_307_0.CT[1265] != 0)) || (++__CLOVER_307_0.CF[1265] == 0))){
        {
            // Final case for literals: if they conflict with a reserved name, they are ignored.
            // Again, there for WYSIWYG.

            __CLOVER_307_0.S[7219]++;if ((((literal) && (++__CLOVER_307_0.CT[1266] != 0)) || (++__CLOVER_307_0.CF[1266] == 0))){
                __CLOVER_307_0.S[7220]++;return false;}

            __CLOVER_307_0.S[7221]++;throw new ApplicationRuntimeException(ImplMessages.templateBindingForReservedParameter(
                    _loadComponent,
                    name,
                    component), component, binding.getLocation(), null);
        }}

        __CLOVER_307_0.S[7222]++;return true;
    } finally { }}

    private void checkAllComponentsReferenced()
    {try { __CLOVER_307_0.M[1483]++;
        // First, contruct a modifiable copy of the ids of all expected components
        // (that is, components declared in the specification).

        __CLOVER_307_0.S[7223]++;Map components = _loadComponent.getComponents();

        __CLOVER_307_0.S[7224]++;Set ids = components.keySet();

        // If the seen ids ... ids referenced in the template, matches
        // all the ids in the specification then we're fine.

        __CLOVER_307_0.S[7225]++;if ((((_seenIds.containsAll(ids)) && (++__CLOVER_307_0.CT[1267] != 0)) || (++__CLOVER_307_0.CF[1267] == 0))){
            __CLOVER_307_0.S[7226]++;return;}

        // Create a modifiable copy. Remove the ids that are referenced in
        // the template. The remainder are worthy of note.

        __CLOVER_307_0.S[7227]++;ids = new HashSet(ids);
        __CLOVER_307_0.S[7228]++;ids.removeAll(_seenIds);

        __CLOVER_307_0.S[7229]++;_log.error(ImplMessages.missingComponentSpec(_loadComponent, ids));

    } finally { }}

    private ApplicationRuntimeException createBodylessComponentException(IComponent component)
    {try { __CLOVER_307_0.M[1484]++;
        __CLOVER_307_0.S[7230]++;return new ApplicationRuntimeException(ImplMessages.bodylessComponent(), component, null,
                null);
    } finally { }}
}