/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.services.impl;

import java.util.Locale;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.hivemind.ClassResolver;
import org.apache.tapestry.IEngine;
import org.apache.tapestry.services.EngineFactory;
import org.apache.tapestry.spec.IApplicationSpecification;

/**
 * Standard implementation of {@link org.apache.tapestry.services.EngineFactory} service.
 * This should do for most purposes, since a major focus of Tapestry 3.1 is to no longer
 * require subclassing of {@link org.apache.tapestry.engine.BaseEngine}.
 *
 * @author Howard Lewis Ship
 * @since 3.1
 */
public class EngineFactoryImpl implements EngineFactory
{public static com.cortexeb.tools.clover.d __CLOVER_310_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private IApplicationSpecification _applicationSpecification;
    private String _defaultEngineClassName;
    private EngineConstructor _constructor;
    private ClassResolver _classResolver;

    interface EngineConstructor
    {
        IEngine construct();
    }


	// TODO: Create a BaseEngineConstructor that is hardcoded to
	// instantiate a BaseEngine instance, without using reflection
	// (for efficiency). 

    static class ReflectiveEngineConstructor implements EngineConstructor
    {
        private Class _engineClass;

        ReflectiveEngineConstructor(Class engineClass)
        {try { __CLOVER_310_0.M[1491]++;
            __CLOVER_310_0.S[7251]++;_engineClass = engineClass;
        } finally { }}

        public IEngine construct()
        {try { __CLOVER_310_0.M[1492]++;
            __CLOVER_310_0.S[7252]++;try
            {
                __CLOVER_310_0.S[7253]++;return (IEngine) _engineClass.newInstance();
            }
            catch (Exception ex)
            {
                __CLOVER_310_0.S[7254]++;throw new ApplicationRuntimeException(
                    ImplMessages.errorInstantiatingEngine(_engineClass, ex),
                    ex);
            }
        } finally { }}
    }

    public void initializeService()
    {try { __CLOVER_310_0.M[1493]++;
        __CLOVER_310_0.S[7255]++;String engineClassName = _applicationSpecification.getEngineClassName();

		// TODO: Check in web.xml first.

        __CLOVER_310_0.S[7256]++;if ((((engineClassName == null) && (++__CLOVER_310_0.CT[1272] != 0)) || (++__CLOVER_310_0.CF[1272] == 0))){
            __CLOVER_310_0.S[7257]++;engineClassName = _defaultEngineClassName;}

        __CLOVER_310_0.S[7258]++;Class engineClass = _classResolver.findClass(engineClassName);

        __CLOVER_310_0.S[7259]++;_constructor = new ReflectiveEngineConstructor(engineClass);
    } finally { }}

    public IEngine constructNewEngineInstance(Locale locale)
    {try { __CLOVER_310_0.M[1494]++;
        __CLOVER_310_0.S[7260]++;IEngine result = _constructor.construct();

        __CLOVER_310_0.S[7261]++;result.setLocale(locale);

        __CLOVER_310_0.S[7262]++;return result;
    } finally { }}

    public void setApplicationSpecification(IApplicationSpecification specification)
    {try { __CLOVER_310_0.M[1495]++;
        __CLOVER_310_0.S[7263]++;_applicationSpecification = specification;
    } finally { }}

    public void setClassResolver(ClassResolver resolver)
    {try { __CLOVER_310_0.M[1496]++;
        __CLOVER_310_0.S[7264]++;_classResolver = resolver;
    } finally { }}

    public void setDefaultEngineClassName(String string)
    {try { __CLOVER_310_0.M[1497]++;
        __CLOVER_310_0.S[7265]++;_defaultEngineClassName = string;
    } finally { }}

}
