/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.services.impl;

import java.util.Locale;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.apache.tapestry.IEngine;
import org.apache.tapestry.services.EngineFactory;
import org.apache.tapestry.services.EngineManager;
import org.apache.tapestry.services.LocaleExtractor;
import org.apache.tapestry.services.ObjectPool;

/**
 * Implementation of service {@link org.apache.tapestry.services.EngineManager}.
 *
 * @author Howard Lewis Ship
 * @since 3.1
 */
public class EngineManagerImpl implements EngineManager
{public static com.cortexeb.tools.clover.d __CLOVER_311_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private ObjectPool _enginePool;
    private HttpServletRequest _request;
    private String _servletName;
    private String _engineKey;
    private EngineFactory _engineFactory;
    private LocaleExtractor _localeExtractor;

    static final String ENGINE_KEY_PREFIX = "org.apache.tapestry.engine:";

    public void initializeService()
    {try { __CLOVER_311_0.M[1498]++;
        __CLOVER_311_0.S[7266]++;_engineKey = ENGINE_KEY_PREFIX + _servletName;
    } finally { }}

    public IEngine getEngineInstance()
    {try { __CLOVER_311_0.M[1499]++;
        __CLOVER_311_0.S[7267]++;HttpSession session = getSession();
        __CLOVER_311_0.S[7268]++;IEngine result = null;

        __CLOVER_311_0.S[7269]++;if ((((session != null) && (++__CLOVER_311_0.CT[1273] != 0)) || (++__CLOVER_311_0.CF[1273] == 0))){
        {
            __CLOVER_311_0.S[7270]++;result = (IEngine) session.getAttribute(_engineKey);

            __CLOVER_311_0.S[7271]++;if ((((result != null) && (++__CLOVER_311_0.CT[1274] != 0)) || (++__CLOVER_311_0.CF[1274] == 0))){
                __CLOVER_311_0.S[7272]++;return result;}
        }}

        __CLOVER_311_0.S[7273]++;Locale locale = _localeExtractor.extractLocaleForCurrentRequest();

        __CLOVER_311_0.S[7274]++;result = (IEngine) _enginePool.get(locale);

        // This happens when either the pool is empty, or when a session exists
        // but the engine has not been stored into it (which should never happen, and
        // probably indicates an error in the framework or the application).

        __CLOVER_311_0.S[7275]++;if ((((result == null) && (++__CLOVER_311_0.CT[1275] != 0)) || (++__CLOVER_311_0.CF[1275] == 0))){
            __CLOVER_311_0.S[7276]++;result = _engineFactory.constructNewEngineInstance(locale);}

        __CLOVER_311_0.S[7277]++;return result;
    } finally { }}

    private HttpSession getSession()
    {try { __CLOVER_311_0.M[1500]++;
        __CLOVER_311_0.S[7278]++;return _request.getSession(false);
    } finally { }}

    public void storeEngineInstance(IEngine engine)
    {try { __CLOVER_311_0.M[1501]++;
        __CLOVER_311_0.S[7279]++;HttpSession session = getSession();

        __CLOVER_311_0.S[7280]++;if ((((session == null) && (++__CLOVER_311_0.CT[1276] != 0)) || (++__CLOVER_311_0.CF[1276] == 0))){
        {
            __CLOVER_311_0.S[7281]++;_enginePool.store(engine.getLocale(), engine);
            __CLOVER_311_0.S[7282]++;return;
        }}

        // TODO: We've lost the optimizations for only storing the engine when dirty.
        // However, since (I believe) in 3.1, the engine will no longer be session persistent,
        // this is OK.

        __CLOVER_311_0.S[7283]++;session.setAttribute(_engineKey, engine);
    } finally { }}

    public void setEngineFactory(EngineFactory factory)
    {try { __CLOVER_311_0.M[1502]++;
        __CLOVER_311_0.S[7284]++;_engineFactory = factory;
    } finally { }}

    public void setEnginePool(ObjectPool pool)
    {try { __CLOVER_311_0.M[1503]++;
        __CLOVER_311_0.S[7285]++;_enginePool = pool;
    } finally { }}

    public void setLocaleExtractor(LocaleExtractor extractor)
    {try { __CLOVER_311_0.M[1504]++;
        __CLOVER_311_0.S[7286]++;_localeExtractor = extractor;
    } finally { }}

    public void setRequest(HttpServletRequest request)
    {try { __CLOVER_311_0.M[1505]++;
        __CLOVER_311_0.S[7287]++;_request = request;
    } finally { }}

    public void setServletName(String string)
    {try { __CLOVER_311_0.M[1506]++;
        __CLOVER_311_0.S[7288]++;_servletName = string;
    } finally { }}
}
