/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.services.impl;

import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.hivemind.ServiceImplementationFactory;
import org.apache.hivemind.internal.Module;
import org.apache.hivemind.lib.DefaultImplementationBuilder;
import org.apache.tapestry.spec.IApplicationSpecification;

/**
 * An implementation of {@link org.apache.hivemind.ServiceImplementationFactory}
 * that looks for a service implementation provided as an
 * {@link org.apache.tapestry.spec.ILibrarySpecification#getExtension(String) application
 * extension}. If no such extension exists, then a
 * {@link org.apache.hivemind.lib.DefaultImplementationBuilder default implementation}
 * is constructed and returned instead. This allows compatibility with Tapestry 3.0 and
 * earlier application extensions (though those will be phased out in the future).
 *
 * @author Howard Lewis Ship
 * @since 3.1
 */
public class ExtensionLookupFactory implements ServiceImplementationFactory
{public static com.cortexeb.tools.clover.d __CLOVER_312_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private IApplicationSpecification _specification;
    private DefaultImplementationBuilder _defaultBuilder;

    public Object createCoreServiceImplementation(
        String serviceId,
        Class serviceInterface,
        Log serviceLog,
        Module invokingModule,
        List parameters)
    {try { __CLOVER_312_0.M[1507]++;
        __CLOVER_312_0.S[7289]++;ExtensionLookupParameter p = (ExtensionLookupParameter) parameters.get(0);

        __CLOVER_312_0.S[7290]++;String extensionName = p.getExtensionName();

        __CLOVER_312_0.S[7291]++;try
        {
            __CLOVER_312_0.S[7292]++;if ((((_specification.checkExtension(extensionName)) && (++__CLOVER_312_0.CT[1277] != 0)) || (++__CLOVER_312_0.CF[1277] == 0))){
                __CLOVER_312_0.S[7293]++;return _specification.getExtension(extensionName, serviceInterface);}

            __CLOVER_312_0.S[7294]++;return _defaultBuilder.buildDefaultImplementation(serviceInterface, invokingModule);
        }
        catch (Exception ex)
        {
            __CLOVER_312_0.S[7295]++;throw new ApplicationRuntimeException(ex.getMessage(), p.getLocation(), ex);
        }
    } finally { }}

    public void setDefaultBuilder(DefaultImplementationBuilder builder)
    {try { __CLOVER_312_0.M[1508]++;
        __CLOVER_312_0.S[7296]++;_defaultBuilder = builder;
    } finally { }}

    public void setSpecification(IApplicationSpecification specification)
    {try { __CLOVER_312_0.M[1509]++;
        __CLOVER_312_0.S[7297]++;_specification = specification;
    } finally { }}

}
