/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.services.impl;

import java.net.URL;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Locale;

import javax.servlet.http.HttpServlet;

import org.apache.hivemind.HiveMind;
import org.apache.hivemind.Resource;
import org.apache.hivemind.impl.MessageFormatter;
import org.apache.tapestry.IComponent;
import org.apache.tapestry.engine.IEngineService;
import org.apache.tapestry.services.Infrastructure;
import org.apache.tapestry.spec.IContainedComponent;

/**
 * @author Howard Lewis Ship
 * @since 3.1
 */
final class ImplMessages
{public static com.cortexeb.tools.clover.d __CLOVER_314_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private static final MessageFormatter _formatter = new MessageFormatter(ImplMessages.class,
            "ImplStrings");

    public static String initializerContribution()
    {try { __CLOVER_314_0.M[1512]++;
        __CLOVER_314_0.S[7300]++;return _formatter.getMessage("initializer-contribution");
    } finally { }}

    public static String noApplicationSpecification(HttpServlet servlet)
    {try { __CLOVER_314_0.M[1513]++;
        __CLOVER_314_0.S[7301]++;return _formatter.format("no-application-specification", servlet.getServletName());
    } finally { }}

    public static String errorInstantiatingEngine(Class engineClass, Throwable cause)
    {try { __CLOVER_314_0.M[1514]++;
        __CLOVER_314_0.S[7302]++;return _formatter.format("error-instantiating-engine", engineClass.getName(), cause);
    } finally { }}

    public static String noTemplateForComponent(String componentId, Locale locale)
    {try { __CLOVER_314_0.M[1515]++;
        __CLOVER_314_0.S[7303]++;return _formatter.format("no-template-for-component", componentId, locale);
    } finally { }}

    public static String noTemplateForPage(String pageName, Locale locale)
    {try { __CLOVER_314_0.M[1516]++;
        __CLOVER_314_0.S[7304]++;return _formatter.format("no-template-for-page", pageName, locale);
    } finally { }}

    public static String unableToReadTemplate(Object template)
    {try { __CLOVER_314_0.M[1517]++;
        __CLOVER_314_0.S[7305]++;return _formatter.format("unable-to-read-template", template);
    } finally { }}

    public static String unableToParseTemplate(Resource resource)
    {try { __CLOVER_314_0.M[1518]++;
        __CLOVER_314_0.S[7306]++;return _formatter.format("unable-to-parse-template", resource);
    } finally { }}

    public static String unableToParseSpecification(Resource resource)
    {try { __CLOVER_314_0.M[1519]++;
        __CLOVER_314_0.S[7307]++;return _formatter.format("unable-to-parse-specification", resource);
    } finally { }}

    public static String unableToReadInfrastructureProperty(String propertyName,
            Infrastructure service, Throwable cause)
    {try { __CLOVER_314_0.M[1520]++;
        __CLOVER_314_0.S[7308]++;return _formatter.format(
                "unable-to-read-infrastructure-property",
                propertyName,
                service,
                cause);
    } finally { }}

    public static String multipleComponentReferences(IComponent component, String id)
    {try { __CLOVER_314_0.M[1521]++;
        __CLOVER_314_0.S[7309]++;return _formatter.format("multiple-component-references", component.getExtendedId(), id);
    } finally { }}

    public static String dupeComponentId(String id, IContainedComponent containedComponent)
    {try { __CLOVER_314_0.M[1522]++;
        __CLOVER_314_0.S[7310]++;return _formatter.format("dupe-component-id", id, HiveMind
                .getLocationString(containedComponent));
    } finally { }}

    public static String unbalancedCloseTags()
    {try { __CLOVER_314_0.M[1523]++;
        __CLOVER_314_0.S[7311]++;return _formatter.getMessage("unbalanced-close-tags");
    } finally { }}

    public static String templateBindingForInformalParameter(IComponent loadComponent,
            String parameterName, IComponent component)
    {try { __CLOVER_314_0.M[1524]++;
        __CLOVER_314_0.S[7312]++;return _formatter.format("template-binding-for-informal-parameter", loadComponent
                .getExtendedId(), parameterName, component.getExtendedId());
    } finally { }}

    public static String templateBindingForReservedParameter(IComponent loadComponent,
            String parameterName, IComponent component)
    {try { __CLOVER_314_0.M[1525]++;
        __CLOVER_314_0.S[7313]++;return _formatter.format("template-binding-for-reserved-parameter", loadComponent
                .getExtendedId(), parameterName, component.getExtendedId());
    } finally { }}

    public static String missingComponentSpec(IComponent component, Collection ids)
    {try { __CLOVER_314_0.M[1526]++;
        __CLOVER_314_0.S[7314]++;StringBuffer buffer = new StringBuffer();
        __CLOVER_314_0.S[7315]++;List idList = new ArrayList(ids);
        __CLOVER_314_0.S[7316]++;int count = idList.size();

        __CLOVER_314_0.S[7317]++;for (int i = 0; (((i < count) && (++__CLOVER_314_0.CT[1278] != 0)) || (++__CLOVER_314_0.CF[1278] == 0)); i++){
        {
            __CLOVER_314_0.S[7318]++;if ((((i > 0) && (++__CLOVER_314_0.CT[1279] != 0)) || (++__CLOVER_314_0.CF[1279] == 0))){
                __CLOVER_314_0.S[7319]++;buffer.append(", ");}

            __CLOVER_314_0.S[7320]++;buffer.append(idList.get(i));
        }}

        __CLOVER_314_0.S[7321]++;return _formatter.format("missing-component-spec", component.getExtendedId(), new Integer(
                count), buffer.toString());
    } finally { }}

    public static String bodylessComponent()
    {try { __CLOVER_314_0.M[1527]++;
        __CLOVER_314_0.S[7322]++;return _formatter.getMessage("bodyless-component");
    } finally { }}

    public static String dupeTemplateBinding(String name, IComponent component,
            IComponent loadComponent)
    {try { __CLOVER_314_0.M[1528]++;
        __CLOVER_314_0.S[7323]++;return _formatter.format(
                "dupe-template-binding",
                name,
                component.getExtendedId(),
                loadComponent.getExtendedId());
    } finally { }}

    public static String unableToLoadProperties(URL url, Throwable cause)
    {try { __CLOVER_314_0.M[1529]++;
        __CLOVER_314_0.S[7324]++;return _formatter.format("unable-to-load-properties", url, cause);
    } finally { }}

    public static String noSuchService(String name)
    {try { __CLOVER_314_0.M[1530]++;
        __CLOVER_314_0.S[7325]++;return _formatter.format("no-such-service", name);
    } finally { }}

    public static String dupeService(String name, IEngineService existing)
    {try { __CLOVER_314_0.M[1531]++;
        __CLOVER_314_0.S[7326]++;return _formatter.format("dupe-service", name, HiveMind.getLocationString(existing));
    } finally { }}
}