/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.services.impl;

import java.util.Collections;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.apache.tapestry.ApplicationServlet;
import org.apache.tapestry.services.CookieSource;
import org.apache.tapestry.services.LocaleExtractor;
import org.apache.tapestry.util.StringSplitter;

/**
 * Identifies the Locale provided by the client (either in a Tapestry-specific
 * cookie, or interpolated from the HTTP header.
 * 
 * TODO: Add the ability to "filter down" Locales down to a predifined set
 * (specified using some form of HiveMInd configuration).
 *
 * @author Howard Lewis Ship
 * @since 3.1
 */
public class LocaleExtractorImpl implements LocaleExtractor
{public static com.cortexeb.tools.clover.d __CLOVER_320_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private HttpServletRequest _request;
    private CookieSource _cookieSource;
    private Map _localeMap = Collections.synchronizedMap(new HashMap());

    public Locale extractLocaleForCurrentRequest()
    {try { __CLOVER_320_0.M[1576]++;
        __CLOVER_320_0.S[7380]++;String localeName = _cookieSource.getCookieValue(ApplicationServlet.LOCALE_COOKIE_NAME);

        __CLOVER_320_0.S[7381]++;if ((((localeName != null) && (++__CLOVER_320_0.CT[1280] != 0)) || (++__CLOVER_320_0.CF[1280] == 0))){
            __CLOVER_320_0.S[7382]++;return getLocale(localeName);}

        __CLOVER_320_0.S[7383]++;return _request.getLocale();
    } finally { }}

    private Locale getLocale(String name)
    {try { __CLOVER_320_0.M[1577]++;
        __CLOVER_320_0.S[7384]++;Locale result = (Locale) _localeMap.get(name);

        __CLOVER_320_0.S[7385]++;if ((((result == null) && (++__CLOVER_320_0.CT[1281] != 0)) || (++__CLOVER_320_0.CF[1281] == 0))){
        {
            __CLOVER_320_0.S[7386]++;result = constructLocale(name);
            __CLOVER_320_0.S[7387]++;_localeMap.put(name, result);
        }}

        __CLOVER_320_0.S[7388]++;return result;
    } finally { }}

    private Locale constructLocale(String name)
    {try { __CLOVER_320_0.M[1578]++;
        __CLOVER_320_0.S[7389]++;StringSplitter splitter = new StringSplitter('_');
        __CLOVER_320_0.S[7390]++;String[] terms = splitter.splitToArray(name);

        __CLOVER_320_0.S[7391]++;switch (terms.length)
        {
            case 1 :
                __CLOVER_320_0.S[7392]++;return new Locale(terms[0], "");

            case 2 :
                __CLOVER_320_0.S[7393]++;return new Locale(terms[0], terms[1]);

            case 3 :

                __CLOVER_320_0.S[7394]++;return new Locale(terms[0], terms[1], terms[2]);

            default :

                __CLOVER_320_0.S[7395]++;throw new IllegalArgumentException();
        }
    } finally { }}
    
    public void setCookieSource(CookieSource source)
    {try { __CLOVER_320_0.M[1579]++;
        __CLOVER_320_0.S[7396]++;_cookieSource = source;
    } finally { }}

    public void setRequest(HttpServletRequest request)
    {try { __CLOVER_320_0.M[1580]++;
        __CLOVER_320_0.S[7397]++;_request = request;
    } finally { }}

}
