/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.services.impl;

import java.util.Iterator;
import java.util.Map;

import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.tapestry.IComponent;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRender;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.parse.LocalizationToken;
import org.apache.tapestry.parse.TextToken;

/**
 * A class used with invisible localizations. Constructed from a {@link TextToken}.
 * 
 * @author Howard Lewis Ship
 * @since 3.0
 */

public class LocalizedStringRender implements IRender
{public static com.cortexeb.tools.clover.d __CLOVER_321_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private IComponent _component;

    private String _key;

    private Map _attributes;

    private String _value;

    private boolean _raw;

    public LocalizedStringRender(IComponent component, LocalizationToken token)
    {try { __CLOVER_321_0.M[1581]++;
        __CLOVER_321_0.S[7398]++;_component = component;
        __CLOVER_321_0.S[7399]++;_key = token.getKey();
        __CLOVER_321_0.S[7400]++;_raw = token.isRaw();
        __CLOVER_321_0.S[7401]++;_attributes = token.getAttributes();
    } finally { }}

    public void render(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_321_0.M[1582]++;
        __CLOVER_321_0.S[7402]++;if ((((cycle.isRewinding()) && (++__CLOVER_321_0.CT[1282] != 0)) || (++__CLOVER_321_0.CF[1282] == 0))){
            __CLOVER_321_0.S[7403]++;return;}

        __CLOVER_321_0.S[7404]++;if ((((_attributes != null) && (++__CLOVER_321_0.CT[1283] != 0)) || (++__CLOVER_321_0.CF[1283] == 0))){
        {
            __CLOVER_321_0.S[7405]++;writer.begin("span");

            __CLOVER_321_0.S[7406]++;Iterator i = _attributes.entrySet().iterator();

            __CLOVER_321_0.S[7407]++;while ((((i.hasNext()) && (++__CLOVER_321_0.CT[1284] != 0)) || (++__CLOVER_321_0.CF[1284] == 0))){
            {
                __CLOVER_321_0.S[7408]++;Map.Entry entry = (Map.Entry) i.next();
                __CLOVER_321_0.S[7409]++;String attributeName = (String) entry.getKey();
                __CLOVER_321_0.S[7410]++;String attributeValue = (String) entry.getValue();

                __CLOVER_321_0.S[7411]++;writer.attribute(attributeName, attributeValue);
            }}
        }}

        __CLOVER_321_0.S[7412]++;if ((((_value == null) && (++__CLOVER_321_0.CT[1285] != 0)) || (++__CLOVER_321_0.CF[1285] == 0))){
            __CLOVER_321_0.S[7413]++;_value = _component.getMessage(_key);}

        __CLOVER_321_0.S[7414]++;if ((((_raw) && (++__CLOVER_321_0.CT[1286] != 0)) || (++__CLOVER_321_0.CF[1286] == 0))){
            __CLOVER_321_0.S[7415]++;writer.printRaw(_value);}
        else{
            __CLOVER_321_0.S[7416]++;writer.print(_value);}

        __CLOVER_321_0.S[7417]++;if ((((_attributes != null) && (++__CLOVER_321_0.CT[1287] != 0)) || (++__CLOVER_321_0.CF[1287] == 0))){
            __CLOVER_321_0.S[7418]++;writer.end();}
    } finally { }}

    public String toString()
    {try { __CLOVER_321_0.M[1583]++;
        __CLOVER_321_0.S[7419]++;ToStringBuilder builder = new ToStringBuilder(this);

        __CLOVER_321_0.S[7420]++;builder.append("component", _component);
        __CLOVER_321_0.S[7421]++;builder.append("key", _key);
        __CLOVER_321_0.S[7422]++;builder.append("raw", _raw);
        __CLOVER_321_0.S[7423]++;builder.append("attributes", _attributes);

        __CLOVER_321_0.S[7424]++;return builder.toString();
    } finally { }}

}