/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.services.impl;

import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServlet;

import org.apache.commons.logging.Log;
import org.apache.hivemind.ErrorHandler;
import org.apache.hivemind.order.Orderer;
import org.apache.tapestry.services.ApplicationInitializer;

/**
 * Uses an orderable list of {@link org.apache.tapestry.services.ApplicationInitializer}s
 * to initialize the application. 
 *
 * @author Howard Lewis Ship
 * @since 3.1
 */
public class MasterInitializer implements ApplicationInitializer
{public static com.cortexeb.tools.clover.d __CLOVER_322_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private Log _log;
    private ErrorHandler _errorHandler;
    private List _initializers;

    public void initializeService()
    {try { __CLOVER_322_0.M[1584]++;
        __CLOVER_322_0.S[7425]++;Orderer o = new Orderer(_log, _errorHandler, ImplMessages.initializerContribution());

        __CLOVER_322_0.S[7426]++;Iterator i = _initializers.iterator();
        __CLOVER_322_0.S[7427]++;while ((((i.hasNext()) && (++__CLOVER_322_0.CT[1288] != 0)) || (++__CLOVER_322_0.CF[1288] == 0))){
        {
            __CLOVER_322_0.S[7428]++;InitializerContribution c = (InitializerContribution) i.next();

            __CLOVER_322_0.S[7429]++;o.add(c, c.getName(), c.getAfter(), c.getBefore());
        }}

        __CLOVER_322_0.S[7430]++;_initializers = o.getOrderedObjects();
    } finally { }}

    public void initialize(HttpServlet servlet)
    {try { __CLOVER_322_0.M[1585]++;
        __CLOVER_322_0.S[7431]++;Iterator i = _initializers.iterator();
        __CLOVER_322_0.S[7432]++;while ((((i.hasNext()) && (++__CLOVER_322_0.CT[1289] != 0)) || (++__CLOVER_322_0.CF[1289] == 0))){
        {
            __CLOVER_322_0.S[7433]++;InitializerContribution c = (InitializerContribution) i.next();

            __CLOVER_322_0.S[7434]++;c.initialize(servlet);
        }}
    } finally { }}

    public void setErrorHandler(ErrorHandler handler)
    {try { __CLOVER_322_0.M[1586]++;
        __CLOVER_322_0.S[7435]++;_errorHandler = handler;
    } finally { }}

    public void setInitializers(List list)
    {try { __CLOVER_322_0.M[1587]++;
        __CLOVER_322_0.S[7436]++;_initializers = list;
    } finally { }}

    public void setLog(Log log)
    {try { __CLOVER_322_0.M[1588]++;
        __CLOVER_322_0.S[7437]++;_log = log;
    } finally { }}

}
