/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.services.impl;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.apache.tapestry.event.ResetEventListener;
import org.apache.tapestry.services.ObjectPool;

/**
 * Implementation of the {@link org.apache.tapestry.services.ObjectPool} interface.
 * 
 * <p>
 * This ia a minimal implementation, one that has no concept of automatically removing
 * unused pooled objects. Eventually, it will also register for notifications about
 * general cache cleaning.
 *
 * @author Howard Lewis Ship
 * @since 3.1
 */
public class ObjectPoolImpl implements ObjectPool, ResetEventListener
{public static com.cortexeb.tools.clover.d __CLOVER_325_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    /**
     * Pool of Lists (of pooled objects), keyed on arbitrary key.
     */
    private Map _pool = new HashMap();

    public synchronized Object get(Object key)
    {try { __CLOVER_325_0.M[1591]++;
        __CLOVER_325_0.S[7440]++;List pooled = (List) _pool.get(key);

        __CLOVER_325_0.S[7441]++;if ((((pooled == null || pooled.isEmpty()) && (++__CLOVER_325_0.CT[1290] != 0)) || (++__CLOVER_325_0.CF[1290] == 0))){
            __CLOVER_325_0.S[7442]++;return null;}

        __CLOVER_325_0.S[7443]++;return pooled.remove(0);
    } finally { }}

    public synchronized void store(Object key, Object value)
    {try { __CLOVER_325_0.M[1592]++;
        __CLOVER_325_0.S[7444]++;List pooled = (List) _pool.get(key);

        __CLOVER_325_0.S[7445]++;if ((((pooled == null) && (++__CLOVER_325_0.CT[1291] != 0)) || (++__CLOVER_325_0.CF[1291] == 0))){
        {
            __CLOVER_325_0.S[7446]++;pooled = new LinkedList();
            __CLOVER_325_0.S[7447]++;_pool.put(key, pooled);
        }}

        __CLOVER_325_0.S[7448]++;pooled.add(value);
    } finally { }}

    public synchronized void resetEventDidOccur()
    {try { __CLOVER_325_0.M[1593]++;
        __CLOVER_325_0.S[7449]++;_pool.clear();
    } finally { }}

}
