/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.services.impl;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.apache.commons.logging.Log;
import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.hivemind.ErrorHandler;
import org.apache.hivemind.HiveMind;
import org.apache.tapestry.engine.IEngineService;
import org.apache.tapestry.services.ServiceMap;

/**
 * Implementation of {@link org.apache.tapestry.services.ServiceMap}
 * 
 * @author Howard Lewis Ship
 * @since 3.1
 */
public class ServiceMapImpl implements ServiceMap
{public static com.cortexeb.tools.clover.d __CLOVER_332_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private List _applicationServices;

    private ErrorHandler _errorHandler;

    private List _factoryServices;

    private Log _log;

    /**
     * Map of {@link IEngineService}keyed on String name.
     */
    private Map _services;

    public void initializeService()
    {try { __CLOVER_332_0.M[1617]++;
        __CLOVER_332_0.S[7491]++;Map factoryMap = buildServiceMap(_factoryServices);
        __CLOVER_332_0.S[7492]++;Map applicationMap = buildServiceMap(_applicationServices);

        // Add services from the applicationMap to factoryMap, overwriting
        // factoryMap entries with the same name.

        __CLOVER_332_0.S[7493]++;factoryMap.putAll(applicationMap);

        __CLOVER_332_0.S[7494]++;_services = factoryMap;
    } finally { }}

    private Map buildServiceMap(List services)
    {try { __CLOVER_332_0.M[1618]++;
        __CLOVER_332_0.S[7495]++;Map result = new HashMap();

        __CLOVER_332_0.S[7496]++;Iterator i = services.iterator();
        __CLOVER_332_0.S[7497]++;while ((((i.hasNext()) && (++__CLOVER_332_0.CT[1295] != 0)) || (++__CLOVER_332_0.CF[1295] == 0))){
        {
            __CLOVER_332_0.S[7498]++;IEngineService s = (IEngineService) i.next();
            __CLOVER_332_0.S[7499]++;String name = s.getName();

            __CLOVER_332_0.S[7500]++;IEngineService existing = (IEngineService) result.get(name);

            __CLOVER_332_0.S[7501]++;if ((((existing != null) && (++__CLOVER_332_0.CT[1296] != 0)) || (++__CLOVER_332_0.CF[1296] == 0))){
            {
                __CLOVER_332_0.S[7502]++;_errorHandler.error(_log, ImplMessages.dupeService(name, existing), HiveMind
                        .getLocation(s), null);
                __CLOVER_332_0.S[7503]++;continue;
            }}

            __CLOVER_332_0.S[7504]++;result.put(name, s);
        }}

        __CLOVER_332_0.S[7505]++;return result;
    } finally { }}

    public IEngineService getService(String name)
    {try { __CLOVER_332_0.M[1619]++;
        __CLOVER_332_0.S[7506]++;IEngineService result = (IEngineService) _services.get(name);

        __CLOVER_332_0.S[7507]++;if ((((result == null) && (++__CLOVER_332_0.CT[1297] != 0)) || (++__CLOVER_332_0.CF[1297] == 0))){
            __CLOVER_332_0.S[7508]++;throw new ApplicationRuntimeException(ImplMessages.noSuchService(name));}

        __CLOVER_332_0.S[7509]++;return result;
    } finally { }}

    public void setApplicationServices(List applicationServices)
    {try { __CLOVER_332_0.M[1620]++;
        __CLOVER_332_0.S[7510]++;_applicationServices = applicationServices;
    } finally { }}

    public void setErrorHandler(ErrorHandler errorHandler)
    {try { __CLOVER_332_0.M[1621]++;
        __CLOVER_332_0.S[7511]++;_errorHandler = errorHandler;
    } finally { }}

    public void setFactoryServices(List factoryServices)
    {try { __CLOVER_332_0.M[1622]++;
        __CLOVER_332_0.S[7512]++;_factoryServices = factoryServices;
    } finally { }}

    public void setLog(Log log)
    {try { __CLOVER_332_0.M[1623]++;
        __CLOVER_332_0.S[7513]++;_log = log;
    } finally { }}

}