/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.spec;

import org.apache.hivemind.impl.BaseLocatable;

/**
 *  Defines a formal parameter to a component.  A <code>IParameterSpecification</code>
 *  is contained by a {@link IComponentSpecification}.
 *
 *  <p>TBD: Identify arrays in some way.
 *
 *  @author Howard Lewis Ship
 * 
 **/

public class ParameterSpecification extends BaseLocatable implements IParameterSpecification
{public static com.cortexeb.tools.clover.d __CLOVER_364_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private boolean required = false;
    private String type;

    /** @since 1.0.9 **/
    private String description;
    
    /** @since 2.0.3 **/
    private String propertyName;
    
    /** @since 3.0 **/
    private String defaultValue = null;

	private Direction direction = Direction.CUSTOM;
	
    /**
     *  Returns the class name of the expected type of the parameter.  The default value
     *  is <code>java.lang.Object</code> which matches anything.
     *
     **/

    public String getType()
    {try { __CLOVER_364_0.M[1796]++;
        __CLOVER_364_0.S[7967]++;return type;
    } finally { }}

    /**
     *  Returns true if the parameter is required by the component.
     *  The default is false, meaning the parameter is optional.
     *
     **/

    public boolean isRequired()
    {try { __CLOVER_364_0.M[1797]++;
        __CLOVER_364_0.S[7968]++;return required;
    } finally { }}

    public void setRequired(boolean value)
    {try { __CLOVER_364_0.M[1798]++;
        __CLOVER_364_0.S[7969]++;required = value;
    } finally { }}

	/**
	 *  Sets the type of value expected for the parameter.  This can be
	 *  left blank to indicate any type.
	 * 
	 **/
	
    public void setType(String value)
    {try { __CLOVER_364_0.M[1799]++;
        __CLOVER_364_0.S[7970]++;type = value;
    } finally { }}

    /**
     *  Returns the documentation for this parameter.
     * 
     *  @since 1.0.9
     * 
     **/

    public String getDescription()
    {try { __CLOVER_364_0.M[1800]++;
        __CLOVER_364_0.S[7971]++;return description;
    } finally { }}

    /**
     *  Sets the documentation for this parameter.
     * 
     *  @since 1.0.9
     *    	 
     **/

    public void setDescription(String description)
    {try { __CLOVER_364_0.M[1801]++;
        __CLOVER_364_0.S[7972]++;this.description = description;
    } finally { }}
    
    /**
     *  Sets the property name (of the component class)
     *  to connect the parameter to.
     * 
     **/
    
    public void setPropertyName(String propertyName)
    {try { __CLOVER_364_0.M[1802]++;
        __CLOVER_364_0.S[7973]++;this.propertyName = propertyName;
    } finally { }}
    
    /**
     *  Returns the name of the JavaBeans property to connect the
     *  parameter to.
     * 
     **/
    
    public String getPropertyName()
    {try { __CLOVER_364_0.M[1803]++;
       __CLOVER_364_0.S[7974]++;return propertyName;
    } finally { }}

	/**
	 *  Returns the parameter value direction, defaulting to {@link Direction#CUSTOM}
	 *  if not otherwise specified.
	 * 
	 **/
	
    public Direction getDirection()
    {try { __CLOVER_364_0.M[1804]++;
        __CLOVER_364_0.S[7975]++;return direction;
    } finally { }}

    public void setDirection(Direction direction)
    {try { __CLOVER_364_0.M[1805]++;
        __CLOVER_364_0.S[7976]++;if ((((direction == null) && (++__CLOVER_364_0.CT[1374] != 0)) || (++__CLOVER_364_0.CF[1374] == 0))){
        	__CLOVER_364_0.S[7977]++;throw new IllegalArgumentException("direction may not be null.");}
        	
        __CLOVER_364_0.S[7978]++;this.direction = direction;
    } finally { }}


    /**
     * @see org.apache.tapestry.spec.IParameterSpecification#getDefaultValue()
     */
    public String getDefaultValue()
    {try { __CLOVER_364_0.M[1806]++;
        __CLOVER_364_0.S[7979]++;return defaultValue;
    } finally { }}

    /**
     * @see org.apache.tapestry.spec.IParameterSpecification#setDefaultValue(java.lang.String)
     */
    public void setDefaultValue(String defaultValue)
    {try { __CLOVER_364_0.M[1807]++;
        __CLOVER_364_0.S[7980]++;this.defaultValue = defaultValue;
    } finally { }}

}