/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.spec;

import org.apache.hivemind.impl.BaseLocatable;

/**
 *  Defines a transient or persistant property of a component or page.  
 *  A {@link org.apache.tapestry.engine.IComponentClassEnhancer} uses this information
 *  to create a subclass with the necessary instance variables and methods.  
 *
 *  @author Howard Lewis Ship
 *  @since 3.0
 * 
 **/

public class PropertySpecification extends BaseLocatable implements IPropertySpecification
{public static com.cortexeb.tools.clover.d __CLOVER_365_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
	private String _name;
	private String _type = "java.lang.Object";
	private boolean _persistent;
	private String _initialValue;
	
    public String getInitialValue()
    {try { __CLOVER_365_0.M[1808]++;
        __CLOVER_365_0.S[7981]++;return _initialValue;
    } finally { }}

    public String getName()
    {try { __CLOVER_365_0.M[1809]++;
        __CLOVER_365_0.S[7982]++;return _name;
    } finally { }}

    public boolean isPersistent()
    {try { __CLOVER_365_0.M[1810]++;
        __CLOVER_365_0.S[7983]++;return _persistent;
    } finally { }}

    public String getType()
    {try { __CLOVER_365_0.M[1811]++;
        __CLOVER_365_0.S[7984]++;return _type;
    } finally { }}

    public void setInitialValue(String initialValue)
    {try { __CLOVER_365_0.M[1812]++;
        __CLOVER_365_0.S[7985]++;_initialValue = initialValue;
    } finally { }}

	/**
	 *  Sets the name of the property.  This should not be changed
	 *  once this IPropertySpecification is added to
	 *  a {@link org.apache.tapestry.spec.ComponentSpecification}.
	 * 
	 **/
	
    public void setName(String name)
    {try { __CLOVER_365_0.M[1813]++;
        __CLOVER_365_0.S[7986]++;_name = name;
    } finally { }}

    public void setPersistent(boolean persistant)
    {try { __CLOVER_365_0.M[1814]++;
        __CLOVER_365_0.S[7987]++;_persistent = persistant;
    } finally { }}

    public void setType(String type)
    {try { __CLOVER_365_0.M[1815]++;
        __CLOVER_365_0.S[7988]++;_type = type;
    } finally { }}

}
