/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.test;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.apache.hivemind.impl.BaseLocatable;

/**
 * 
 *
 * @author Howard Lewis Ship
 * @since 3.1
 */
public class RequestDescriptor extends BaseLocatable
{public static com.cortexeb.tools.clover.d __CLOVER_370_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private String _servletName;
    private String _servletPath;

    /** Map, on name, to {@link org.apache.tapestry.test.ParameterList}. **/
    private Map _parameters = new HashMap();

    /** Map of {@link ResponseAssertion}. **/
    private List _assertions = new ArrayList();

    public void addAssertion(ResponseAssertion assertion)
    {try { __CLOVER_370_0.M[1876]++;
        __CLOVER_370_0.S[8256]++;_assertions.add(assertion);
    } finally { }}

    /**
     * Invokes all assertions for the request.
     */

    public void executeAssertions(ScriptedTestSession session)
    {try { __CLOVER_370_0.M[1877]++;
        __CLOVER_370_0.S[8257]++;Iterator i = _assertions.iterator();
        __CLOVER_370_0.S[8258]++;while ((((i.hasNext()) && (++__CLOVER_370_0.CT[1402] != 0)) || (++__CLOVER_370_0.CF[1402] == 0))){
        {
            __CLOVER_370_0.S[8259]++;ResponseAssertion a = (ResponseAssertion) i.next();

            __CLOVER_370_0.S[8260]++;a.execute(session);
        }}
    } finally { }}

    public void addParameter(String name, String value)
    {try { __CLOVER_370_0.M[1878]++;
        __CLOVER_370_0.S[8261]++;ParameterList pl = (ParameterList) _parameters.get(name);
        __CLOVER_370_0.S[8262]++;if ((((pl == null) && (++__CLOVER_370_0.CT[1403] != 0)) || (++__CLOVER_370_0.CF[1403] == 0))){
        {
            __CLOVER_370_0.S[8263]++;pl = new ParameterList();
            __CLOVER_370_0.S[8264]++;_parameters.put(name, pl);
        }}

        __CLOVER_370_0.S[8265]++;pl.add(value);
    } finally { }}

    /**
     * Returns the values for the given parameter name.
     * 
     * @return array of strings, or null if no values have been recorded for
     * the given name
     */
    public String[] getParameterValues(String name)
    {try { __CLOVER_370_0.M[1879]++;
        __CLOVER_370_0.S[8266]++;ParameterList pl = (ParameterList) _parameters.get(name);

        __CLOVER_370_0.S[8267]++;if ((((pl == null) && (++__CLOVER_370_0.CT[1404] != 0)) || (++__CLOVER_370_0.CF[1404] == 0))){
            __CLOVER_370_0.S[8268]++;return null;}

        __CLOVER_370_0.S[8269]++;return pl.getValues();
    } finally { }}

    public String getServletName()
    {try { __CLOVER_370_0.M[1880]++;
        __CLOVER_370_0.S[8270]++;return _servletName;
    } finally { }}

    public void setServletName(String string)
    {try { __CLOVER_370_0.M[1881]++;
        __CLOVER_370_0.S[8271]++;_servletName = string;
    } finally { }}

    public String getServletPath()
    {try { __CLOVER_370_0.M[1882]++;
        __CLOVER_370_0.S[8272]++;return _servletPath;
    } finally { }}

    public void setServletPath(String string)
    {try { __CLOVER_370_0.M[1883]++;
        __CLOVER_370_0.S[8273]++;_servletPath = string;
    } finally { }}

    /**
     * Returns names of all parameters. Order is not determinate. May return empty (but not null).
     */
    public String[] getParameterNames()
    {try { __CLOVER_370_0.M[1884]++;
        __CLOVER_370_0.S[8274]++;Collection c = _parameters.keySet();

        __CLOVER_370_0.S[8275]++;return (String[]) c.toArray(new String[c.size()]);
    } finally { }}

}
