/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.hivemind.impl.BaseLocatable;

/**
 * Top level object for test scripts.
 *
 * @author Howard Lewis Ship
 * @since 3.1
 */
public class ScriptDescriptor extends BaseLocatable
{public static com.cortexeb.tools.clover.d __CLOVER_372_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private String _contextName;
    private String _rootDirectory;

    private Map _servletDescriptors = new HashMap();
    private List _requests = new ArrayList();

    private ServletDescriptor _defaultServletDescriptor;

    public String getContextName()
    {try { __CLOVER_372_0.M[1885]++;
        __CLOVER_372_0.S[8276]++;return _contextName;
    } finally { }}

    public String getRootDirectory()
    {try { __CLOVER_372_0.M[1886]++;
        __CLOVER_372_0.S[8277]++;return _rootDirectory;
    } finally { }}

    public void setContextName(String string)
    {try { __CLOVER_372_0.M[1887]++;
        __CLOVER_372_0.S[8278]++;_contextName = string;
    } finally { }}

    public void setRootDirectory(String string)
    {try { __CLOVER_372_0.M[1888]++;
        __CLOVER_372_0.S[8279]++;_rootDirectory = string;
    } finally { }}

    /**
     * Gets the named servlet descriptor, or returns null.
     */
    public ServletDescriptor getServletDescriptor(String name)
    {try { __CLOVER_372_0.M[1889]++;
        __CLOVER_372_0.S[8280]++;return (ServletDescriptor) _servletDescriptors.get(name);
    } finally { }}

    /**
     * Adds a new ServletDescriptor to the script.
     * 
     * @throws ApplicationRuntimeException if the descriptor's name
     * duplicates an existing descriptor
     */
    public void addServletDescriptor(ServletDescriptor sd)
    {try { __CLOVER_372_0.M[1890]++;
        __CLOVER_372_0.S[8281]++;String name = sd.getName();

        __CLOVER_372_0.S[8282]++;ServletDescriptor existing = getServletDescriptor(name);

        __CLOVER_372_0.S[8283]++;if ((((existing != null) && (++__CLOVER_372_0.CT[1405] != 0)) || (++__CLOVER_372_0.CF[1405] == 0))){
            __CLOVER_372_0.S[8284]++;throw new ApplicationRuntimeException(
                "Servlet descriptor '"
                    + name
                    + "' (at "
                    + sd.getLocation()
                    + ") conflicts with prior instance at "
                    + existing.getLocation()
                    + ".",
                sd.getLocation(),
                null);}

        __CLOVER_372_0.S[8285]++;_servletDescriptors.put(name, sd);

        __CLOVER_372_0.S[8286]++;if ((((_defaultServletDescriptor == null) && (++__CLOVER_372_0.CT[1406] != 0)) || (++__CLOVER_372_0.CF[1406] == 0))){
            __CLOVER_372_0.S[8287]++;_defaultServletDescriptor = sd;}
    } finally { }}

    public void addRequestDescriptor(RequestDescriptor rd)
    {try { __CLOVER_372_0.M[1891]++;
        __CLOVER_372_0.S[8288]++;_requests.add(rd);
    } finally { }}

    /**
     * @return List of {@link RequestDescriptor}
     * @see #addRequestDescriptor(RequestDescriptor)
     */
    public List getRequestDescriptors()
    {try { __CLOVER_372_0.M[1892]++;
        __CLOVER_372_0.S[8289]++;return _requests;
    } finally { }}
    
    public ServletDescriptor getDefaultServletDescriptor()
    {try { __CLOVER_372_0.M[1893]++;
        __CLOVER_372_0.S[8290]++;return _defaultServletDescriptor;
    } finally { }}

}
