/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.test.mock;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.security.Principal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletInputStream;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

/**
 * Mock implementation of {@link javax.servlet.http.HttpServletRequest}.
 *
 *
 * @author Howard Lewis Ship
 * @since 3.1
 */

public class MockRequest extends AttributeHolder implements HttpServletRequest
{public static com.cortexeb.tools.clover.d __CLOVER_383_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    /**
     * HTTP content type header name.
     */
    private static final String CONTENT_TYPE_HEADER_KEY = "Content-type";
    /**
     *  Map of String[].
     * 
     */

    private Map _parameters = new HashMap();

    /**
     *  Map of String[]
     * 
     */

    private Map _headers = new HashMap();

    private String _method = "GET";

    private String _contextPath;

    private MockContext _servletContext;
    private MockSession _session;
    private String _servletPath;
    private List _cookies = new ArrayList();
    private String _contentPath;

    /**
     *  This can be stored within the header, but doing it this way emulates a browser that 
     *  does not put the encoding in the request, which appears to be the general case. 
     */
    private String _encoding = null;

    public MockRequest(MockContext servletContext, String servletPath)
    {try { __CLOVER_383_0.M[1971]++;
        __CLOVER_383_0.S[8470]++;_servletContext = servletContext;

        __CLOVER_383_0.S[8471]++;_contextPath = "/" + servletContext.getServletContextName();
        __CLOVER_383_0.S[8472]++;_servletPath = servletPath;

        __CLOVER_383_0.S[8473]++;_session = _servletContext.getSession();
    } finally { }}

    public String getAuthType()
    {try { __CLOVER_383_0.M[1972]++;
        __CLOVER_383_0.S[8474]++;return null;
    } finally { }}

    public Cookie[] getCookies()
    {try { __CLOVER_383_0.M[1973]++;
        __CLOVER_383_0.S[8475]++;return (Cookie[]) _cookies.toArray(new Cookie[_cookies.size()]);
    } finally { }}

    public long getDateHeader(String arg0)
    {try { __CLOVER_383_0.M[1974]++;
        __CLOVER_383_0.S[8476]++;return 0;
    } finally { }}

    public String getHeader(String key)
    {try { __CLOVER_383_0.M[1975]++;
        __CLOVER_383_0.S[8477]++;String getHeader = null;

        __CLOVER_383_0.S[8478]++;if ((((key != null) && (++__CLOVER_383_0.CT[1425] != 0)) || (++__CLOVER_383_0.CF[1425] == 0))){
        {
            __CLOVER_383_0.S[8479]++;getHeader = (String) _headers.get(key.toLowerCase());
        }}
        __CLOVER_383_0.S[8480]++;return getHeader;
    } finally { }}

    public Enumeration getHeaders(String name)
    {try { __CLOVER_383_0.M[1976]++;
        __CLOVER_383_0.S[8481]++;String[] headers = (String[]) _headers.get(name);

        __CLOVER_383_0.S[8482]++;if ((((headers == null) && (++__CLOVER_383_0.CT[1426] != 0)) || (++__CLOVER_383_0.CF[1426] == 0))){
            __CLOVER_383_0.S[8483]++;return Collections.enumeration(Collections.EMPTY_LIST);}

        __CLOVER_383_0.S[8484]++;return Collections.enumeration(Arrays.asList(headers));
    } finally { }}

    public Enumeration getHeaderNames()
    {try { __CLOVER_383_0.M[1977]++;
        __CLOVER_383_0.S[8485]++;return getEnumeration(_headers);
    } finally { }}

    public int getIntHeader(String arg0)
    {try { __CLOVER_383_0.M[1978]++;
        __CLOVER_383_0.S[8486]++;return 0;
    } finally { }}

    public String getMethod()
    {try { __CLOVER_383_0.M[1979]++;
        __CLOVER_383_0.S[8487]++;return _method;
    } finally { }}

    public String getPathInfo()
    {try { __CLOVER_383_0.M[1980]++;
        __CLOVER_383_0.S[8488]++;return null;
    } finally { }}

    public String getPathTranslated()
    {try { __CLOVER_383_0.M[1981]++;
        __CLOVER_383_0.S[8489]++;return null;
    } finally { }}

    public String getContextPath()
    {try { __CLOVER_383_0.M[1982]++;
        __CLOVER_383_0.S[8490]++;return _contextPath;
    } finally { }}

    public String getQueryString()
    {try { __CLOVER_383_0.M[1983]++;
        __CLOVER_383_0.S[8491]++;return null;
    } finally { }}

    public String getRemoteUser()
    {try { __CLOVER_383_0.M[1984]++;
        __CLOVER_383_0.S[8492]++;return null;
    } finally { }}

    public boolean isUserInRole(String arg0)
    {try { __CLOVER_383_0.M[1985]++;
        __CLOVER_383_0.S[8493]++;return false;
    } finally { }}

    public Principal getUserPrincipal()
    {try { __CLOVER_383_0.M[1986]++;
        __CLOVER_383_0.S[8494]++;return null;
    } finally { }}

    public String getRequestedSessionId()
    {try { __CLOVER_383_0.M[1987]++;
        __CLOVER_383_0.S[8495]++;return null;
    } finally { }}

    public String getRequestURI()
    {try { __CLOVER_383_0.M[1988]++;
        __CLOVER_383_0.S[8496]++;return null;
    } finally { }}

    public StringBuffer getRequestURL()
    {try { __CLOVER_383_0.M[1989]++;
        __CLOVER_383_0.S[8497]++;return null;
    } finally { }}

    public String getServletPath()
    {try { __CLOVER_383_0.M[1990]++;
        __CLOVER_383_0.S[8498]++;return _servletPath;
    } finally { }}

    public HttpSession getSession(boolean create)
    {try { __CLOVER_383_0.M[1991]++;
        __CLOVER_383_0.S[8499]++;if ((((create && _session == null) && (++__CLOVER_383_0.CT[1427] != 0)) || (++__CLOVER_383_0.CF[1427] == 0))){
            __CLOVER_383_0.S[8500]++;_session = _servletContext.createSession();}

        __CLOVER_383_0.S[8501]++;return _session;
    } finally { }}

    public HttpSession getSession()
    {try { __CLOVER_383_0.M[1992]++;
        __CLOVER_383_0.S[8502]++;return _session;
    } finally { }}

    public boolean isRequestedSessionIdValid()
    {try { __CLOVER_383_0.M[1993]++;
        __CLOVER_383_0.S[8503]++;return false;
    } finally { }}

    public boolean isRequestedSessionIdFromCookie()
    {try { __CLOVER_383_0.M[1994]++;
        __CLOVER_383_0.S[8504]++;return false;
    } finally { }}

    public boolean isRequestedSessionIdFromURL()
    {try { __CLOVER_383_0.M[1995]++;
        __CLOVER_383_0.S[8505]++;return false;
    } finally { }}

    public boolean isRequestedSessionIdFromUrl()
    {try { __CLOVER_383_0.M[1996]++;
        __CLOVER_383_0.S[8506]++;return false;
    } finally { }}

    public String getCharacterEncoding()
    {try { __CLOVER_383_0.M[1997]++;
        __CLOVER_383_0.S[8507]++;return _encoding;
    } finally { }}

    public void setCharacterEncoding(String arg0) throws UnsupportedEncodingException
    {try { __CLOVER_383_0.M[1998]++;
        __CLOVER_383_0.S[8508]++;_encoding = arg0;
    } finally { }}

    public int getContentLength()
    {try { __CLOVER_383_0.M[1999]++;
        __CLOVER_383_0.S[8509]++;return 0;
    } finally { }}

    public String getContentType()
    {try { __CLOVER_383_0.M[2000]++;
        __CLOVER_383_0.S[8510]++;return getHeader(CONTENT_TYPE_HEADER_KEY);
    } finally { }}

    public void setContentType(String contentType)
    {try { __CLOVER_383_0.M[2001]++;
        __CLOVER_383_0.S[8511]++;setHeader(CONTENT_TYPE_HEADER_KEY, contentType);
    } finally { }}

    public ServletInputStream getInputStream() throws IOException
    {try { __CLOVER_383_0.M[2002]++;
        __CLOVER_383_0.S[8512]++;if ((((_contentPath == null) && (++__CLOVER_383_0.CT[1428] != 0)) || (++__CLOVER_383_0.CF[1428] == 0))){
            __CLOVER_383_0.S[8513]++;return null;}

        __CLOVER_383_0.S[8514]++;return new MockServletInputStream(_contentPath);
    } finally { }}

    public String getParameter(String name)
    {try { __CLOVER_383_0.M[2003]++;
        __CLOVER_383_0.S[8515]++;String[] values = getParameterValues(name);

        __CLOVER_383_0.S[8516]++;if ((((values == null || values.length == 0) && (++__CLOVER_383_0.CT[1429] != 0)) || (++__CLOVER_383_0.CF[1429] == 0))){
            __CLOVER_383_0.S[8517]++;return null;}

        __CLOVER_383_0.S[8518]++;return values[0];
    } finally { }}

    public Enumeration getParameterNames()
    {try { __CLOVER_383_0.M[2004]++;
        __CLOVER_383_0.S[8519]++;return Collections.enumeration(_parameters.keySet());
    } finally { }}

    public String[] getParameterValues(String name)
    {try { __CLOVER_383_0.M[2005]++;
        __CLOVER_383_0.S[8520]++;return (String[]) _parameters.get(name);
    } finally { }}

    /** 
     *  Not part of 2.1 API, not used by Tapestry.
     * 
     */

    public Map getParameterMap()
    {try { __CLOVER_383_0.M[2006]++;
        __CLOVER_383_0.S[8521]++;return null;
    } finally { }}

    public String getProtocol()
    {try { __CLOVER_383_0.M[2007]++;
        __CLOVER_383_0.S[8522]++;return null;
    } finally { }}

    public String getScheme()
    {try { __CLOVER_383_0.M[2008]++;
        __CLOVER_383_0.S[8523]++;return "http";
    } finally { }}

    public String getServerName()
    {try { __CLOVER_383_0.M[2009]++;
        __CLOVER_383_0.S[8524]++;return "junit-test";
    } finally { }}

    public int getServerPort()
    {try { __CLOVER_383_0.M[2010]++;
        __CLOVER_383_0.S[8525]++;return 80;
    } finally { }}

    public BufferedReader getReader() throws IOException
    {try { __CLOVER_383_0.M[2011]++;
        __CLOVER_383_0.S[8526]++;return null;
    } finally { }}

    public String getRemoteAddr()
    {try { __CLOVER_383_0.M[2012]++;
        __CLOVER_383_0.S[8527]++;return null;
    } finally { }}

    public String getRemoteHost()
    {try { __CLOVER_383_0.M[2013]++;
        __CLOVER_383_0.S[8528]++;return null;
    } finally { }}

    private Locale _locale = Locale.ENGLISH;

    public Locale getLocale()
    {try { __CLOVER_383_0.M[2014]++;
        __CLOVER_383_0.S[8529]++;return _locale;
    } finally { }}

    public void setLocale(Locale locale)
    {try { __CLOVER_383_0.M[2015]++;
        __CLOVER_383_0.S[8530]++;_locale = locale;
    } finally { }}

    public Enumeration getLocales()
    {try { __CLOVER_383_0.M[2016]++;
        __CLOVER_383_0.S[8531]++;return Collections.enumeration(Collections.singleton(_locale));
    } finally { }}

    public boolean isSecure()
    {try { __CLOVER_383_0.M[2017]++;
        __CLOVER_383_0.S[8532]++;return false;
    } finally { }}

    public RequestDispatcher getRequestDispatcher(String path)
    {try { __CLOVER_383_0.M[2018]++;
        __CLOVER_383_0.S[8533]++;return _servletContext.getRequestDispatcher(path);
    } finally { }}

    public String getRealPath(String arg0)
    {try { __CLOVER_383_0.M[2019]++;
        __CLOVER_383_0.S[8534]++;return null;
    } finally { }}

    public void setContextPath(String contextPath)
    {try { __CLOVER_383_0.M[2020]++;
        __CLOVER_383_0.S[8535]++;_contextPath = contextPath;
    } finally { }}

    public void setMethod(String method)
    {try { __CLOVER_383_0.M[2021]++;
        __CLOVER_383_0.S[8536]++;_method = method;
    } finally { }}

    public void setParameter(String name, String[] values)
    {try { __CLOVER_383_0.M[2022]++;
        __CLOVER_383_0.S[8537]++;_parameters.put(name, values);
    } finally { }}

    public void setParameter(String name, String value)
    {try { __CLOVER_383_0.M[2023]++;
        __CLOVER_383_0.S[8538]++;setParameter(name, new String[] { value });
    } finally { }}

    public void addCookie(Cookie cookie)
    {try { __CLOVER_383_0.M[2024]++;
        __CLOVER_383_0.S[8539]++;_cookies.add(cookie);
    } finally { }}

    public void addCookies(Cookie[] cookies)
    {try { __CLOVER_383_0.M[2025]++;
        __CLOVER_383_0.S[8540]++;if ((((cookies == null) && (++__CLOVER_383_0.CT[1430] != 0)) || (++__CLOVER_383_0.CF[1430] == 0))){
            __CLOVER_383_0.S[8541]++;return;}

        __CLOVER_383_0.S[8542]++;for (int i = 0; (((i < cookies.length) && (++__CLOVER_383_0.CT[1431] != 0)) || (++__CLOVER_383_0.CF[1431] == 0)); i++){
            __CLOVER_383_0.S[8543]++;addCookie(cookies[i]);}
    } finally { }}

    private void setHeader(String key, String value)
    {try { __CLOVER_383_0.M[2026]++;
        __CLOVER_383_0.S[8544]++;if ((((key != null) && (++__CLOVER_383_0.CT[1432] != 0)) || (++__CLOVER_383_0.CF[1432] == 0))){
        {
            __CLOVER_383_0.S[8545]++;_headers.put(key.toLowerCase(), value);
        }}
    } finally { }}

    /**
     *  Delegates this to the {@link org.apache.tapestry.junit.mock.MockSession}, if
     *  it exists.
     * 
     */

    public void simulateFailover()
    {try { __CLOVER_383_0.M[2027]++;
        __CLOVER_383_0.S[8546]++;if ((((_session != null) && (++__CLOVER_383_0.CT[1433] != 0)) || (++__CLOVER_383_0.CF[1433] == 0))){
            __CLOVER_383_0.S[8547]++;_session.simulateFailover();}
    } finally { }}

    public String getContentPath()
    {try { __CLOVER_383_0.M[2028]++;
        __CLOVER_383_0.S[8548]++;return _contentPath;
    } finally { }}

    public void setContentPath(String contentPath)
    {try { __CLOVER_383_0.M[2029]++;
        __CLOVER_383_0.S[8549]++;_contentPath = contentPath;
    } finally { }}

    public int getRemotePort()
    {try { __CLOVER_383_0.M[2030]++;
        __CLOVER_383_0.S[8550]++;return 0;
    } finally { }}

    public String getLocalName()
    {try { __CLOVER_383_0.M[2031]++;
        __CLOVER_383_0.S[8551]++;return null;
    } finally { }}

    public String getLocalAddr()
    {try { __CLOVER_383_0.M[2032]++;
        __CLOVER_383_0.S[8552]++;return null;
    } finally { }}

    public int getLocalPort()
    {try { __CLOVER_383_0.M[2033]++;
        __CLOVER_383_0.S[8553]++;return 0;
    } finally { }}

}
