/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.test.mock;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.*;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletResponse;

/**
 * Mock implementation of {@link javax.servlet.http.HttpServletResponse}.
 *
 *
 * @author Howard Lewis Ship
 * @since 3.1
 */

public class MockResponse implements HttpServletResponse
{public static com.cortexeb.tools.clover.d __CLOVER_385_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private MockRequest _request;
    private boolean _commited = false;
    private ByteArrayOutputStream _outputByteStream;
    private ServletOutputStream _outputStream;
    private String _outputString;
    private List _cookies = new ArrayList();

    private String _redirectLocation;
    private String _contentType;

    private class ServletOutputStreamImpl extends ServletOutputStream
    {
        private ServletOutputStreamImpl()
        {try { __CLOVER_385_0.M[2037]++;
        } finally { }}

        public void close() throws IOException
        {try { __CLOVER_385_0.M[2038]++;
            __CLOVER_385_0.S[8569]++;super.close();

            __CLOVER_385_0.S[8570]++;if ((((_outputByteStream != null) && (++__CLOVER_385_0.CT[1436] != 0)) || (++__CLOVER_385_0.CF[1436] == 0))){
                __CLOVER_385_0.S[8571]++;_outputByteStream.close();}
        } finally { }}

        public void write(byte[] b, int off, int len) throws IOException
        {try { __CLOVER_385_0.M[2039]++;
            __CLOVER_385_0.S[8572]++;commit();

            __CLOVER_385_0.S[8573]++;_outputByteStream.write(b, off, len);
        } finally { }}

        public void write(byte[] b) throws IOException
        {try { __CLOVER_385_0.M[2040]++;
            __CLOVER_385_0.S[8574]++;commit();

            __CLOVER_385_0.S[8575]++;_outputByteStream.write(b);
        } finally { }}

        public void write(int b) throws IOException
        {try { __CLOVER_385_0.M[2041]++;
            __CLOVER_385_0.S[8576]++;commit();

            __CLOVER_385_0.S[8577]++;_outputByteStream.write(b);
        } finally { }}

        private void commit()
        {try { __CLOVER_385_0.M[2042]++;
            __CLOVER_385_0.S[8578]++;if ((((!_commited) && (++__CLOVER_385_0.CT[1437] != 0)) || (++__CLOVER_385_0.CF[1437] == 0))){
            {
                __CLOVER_385_0.S[8579]++;_commited = true;
                __CLOVER_385_0.S[8580]++;_outputByteStream = new ByteArrayOutputStream();
            }}
        } finally { }}
    }

    public MockResponse(MockRequest request)
    {try { __CLOVER_385_0.M[2043]++;
        __CLOVER_385_0.S[8581]++;_request = request;
    } finally { }}

    public void addCookie(Cookie cookie)
    {try { __CLOVER_385_0.M[2044]++;
        __CLOVER_385_0.S[8582]++;_cookies.add(cookie);
    } finally { }}

    public boolean containsHeader(String arg0)
    {try { __CLOVER_385_0.M[2045]++;
        __CLOVER_385_0.S[8583]++;return false;
    } finally { }}

    public String encodeURL(String path)
    {try { __CLOVER_385_0.M[2046]++;
        __CLOVER_385_0.S[8584]++;return path;
    } finally { }}

    public String encodeRedirectURL(String path)
    {try { __CLOVER_385_0.M[2047]++;
        __CLOVER_385_0.S[8585]++;return path;
    } finally { }}

    public String encodeUrl(String path)
    {try { __CLOVER_385_0.M[2048]++;
        __CLOVER_385_0.S[8586]++;return encodeURL(path);
    } finally { }}

    public String encodeRedirectUrl(String path)
    {try { __CLOVER_385_0.M[2049]++;
        __CLOVER_385_0.S[8587]++;return encodeRedirectURL(path);
    } finally { }}

    public void sendError(int code, String message) throws IOException
    {try { __CLOVER_385_0.M[2050]++;
        __CLOVER_385_0.S[8588]++;if ((((_commited) && (++__CLOVER_385_0.CT[1438] != 0)) || (++__CLOVER_385_0.CF[1438] == 0))){
            __CLOVER_385_0.S[8589]++;throw new IllegalStateException("sendError() when committed.");}
    } finally { }}

    public void sendError(int code) throws IOException
    {try { __CLOVER_385_0.M[2051]++;
        __CLOVER_385_0.S[8590]++;sendError(code, null);
    } finally { }}

    public void sendRedirect(String location) throws IOException
    {try { __CLOVER_385_0.M[2052]++;
        __CLOVER_385_0.S[8591]++;if ((((_commited) && (++__CLOVER_385_0.CT[1439] != 0)) || (++__CLOVER_385_0.CF[1439] == 0))){
            __CLOVER_385_0.S[8592]++;throw new IllegalStateException("sendRedirect() when committed.");}

        __CLOVER_385_0.S[8593]++;if ((((location.endsWith("/FAIL_IO")) && (++__CLOVER_385_0.CT[1440] != 0)) || (++__CLOVER_385_0.CF[1440] == 0))){
            __CLOVER_385_0.S[8594]++;throw new IOException("Forced IOException in MockResponse.sendRedirect().");}

        __CLOVER_385_0.S[8595]++;_redirectLocation = location;

        __CLOVER_385_0.S[8596]++;_commited = true;

    } finally { }}

    public String getRedirectLocation()
    {try { __CLOVER_385_0.M[2053]++;
        __CLOVER_385_0.S[8597]++;return _redirectLocation;
    } finally { }}

    public void setDateHeader(String name, long value)
    {try { __CLOVER_385_0.M[2054]++;
    } finally { }}

    public void addDateHeader(String name, long value)
    {try { __CLOVER_385_0.M[2055]++;
    } finally { }}

    public void setHeader(String name, String value)
    {try { __CLOVER_385_0.M[2056]++;
    } finally { }}

    public void addHeader(String name, String value)
    {try { __CLOVER_385_0.M[2057]++;
    } finally { }}

    public void setIntHeader(String name, int value)
    {try { __CLOVER_385_0.M[2058]++;
    } finally { }}

    public void addIntHeader(String name, int value)
    {try { __CLOVER_385_0.M[2059]++;
    } finally { }}

    public void setStatus(int name)
    {try { __CLOVER_385_0.M[2060]++;
    } finally { }}

    public void setStatus(int name, String arg1)
    {try { __CLOVER_385_0.M[2061]++;
    } finally { }}

    public String getCharacterEncoding()
    {try { __CLOVER_385_0.M[2062]++;
        __CLOVER_385_0.S[8598]++;return null;
    } finally { }}

    public ServletOutputStream getOutputStream() throws IOException
    {try { __CLOVER_385_0.M[2063]++;
        __CLOVER_385_0.S[8599]++;if ((((_outputStream != null) && (++__CLOVER_385_0.CT[1441] != 0)) || (++__CLOVER_385_0.CF[1441] == 0))){
            __CLOVER_385_0.S[8600]++;throw new IllegalStateException("getOutputStream() invoked more than once.");}

        __CLOVER_385_0.S[8601]++;_outputStream = new ServletOutputStreamImpl();

        __CLOVER_385_0.S[8602]++;return _outputStream;
    } finally { }}

    public PrintWriter getWriter() throws IOException
    {try { __CLOVER_385_0.M[2064]++;
        __CLOVER_385_0.S[8603]++;return new PrintWriter(getOutputStream());
    } finally { }}

    public void setContentLength(int arg0)
    {try { __CLOVER_385_0.M[2065]++;
    } finally { }}

    public void setContentType(String contentType)
    {try { __CLOVER_385_0.M[2066]++;
        __CLOVER_385_0.S[8604]++;_contentType = contentType;
    } finally { }}

    public void setBufferSize(int arg0)
    {try { __CLOVER_385_0.M[2067]++;
    } finally { }}

    public int getBufferSize()
    {try { __CLOVER_385_0.M[2068]++;
        __CLOVER_385_0.S[8605]++;return 0;
    } finally { }}

    public void flushBuffer() throws IOException
    {try { __CLOVER_385_0.M[2069]++;
    } finally { }}

    public void resetBuffer()
    {try { __CLOVER_385_0.M[2070]++;
    } finally { }}

    public boolean isCommitted()
    {try { __CLOVER_385_0.M[2071]++;
        __CLOVER_385_0.S[8606]++;return _commited;
    } finally { }}

    public void reset()
    {try { __CLOVER_385_0.M[2072]++;
    } finally { }}

    public void setLocale(Locale arg0)
    {try { __CLOVER_385_0.M[2073]++;
    } finally { }}

    public Locale getLocale()
    {try { __CLOVER_385_0.M[2074]++;
        __CLOVER_385_0.S[8607]++;return null;
    } finally { }}

    /**
     *  Invoked by {@link org.apache.tapestry.junit.mock.MockTester} after
     *  the test is complete, to close and otherwise finish up.
     * 
     **/

    public void end() throws IOException
    {try { __CLOVER_385_0.M[2075]++;
        // For redirects, we may never open an output stream.

        __CLOVER_385_0.S[8608]++;if ((((_outputStream != null) && (++__CLOVER_385_0.CT[1442] != 0)) || (++__CLOVER_385_0.CF[1442] == 0))){
            __CLOVER_385_0.S[8609]++;_outputStream.close();}
    } finally { }}

    /**
     *  Converts the binary output stream back into a String.
     * 
     **/

    public String getOutputString()
    {try { __CLOVER_385_0.M[2076]++;
        __CLOVER_385_0.S[8610]++;if ((((_outputString != null) && (++__CLOVER_385_0.CT[1443] != 0)) || (++__CLOVER_385_0.CF[1443] == 0))){
            __CLOVER_385_0.S[8611]++;return _outputString;}

        __CLOVER_385_0.S[8612]++;if ((((_outputByteStream == null) && (++__CLOVER_385_0.CT[1444] != 0)) || (++__CLOVER_385_0.CF[1444] == 0))){
            __CLOVER_385_0.S[8613]++;return null;}

        __CLOVER_385_0.S[8614]++;try
        {
            __CLOVER_385_0.S[8615]++;String encoding = _request.getCharacterEncoding();

            __CLOVER_385_0.S[8616]++;if ((((encoding != null) && (++__CLOVER_385_0.CT[1445] != 0)) || (++__CLOVER_385_0.CF[1445] == 0))){
                __CLOVER_385_0.S[8617]++;_outputString = new String(_outputByteStream.toByteArray(), encoding);}
        }
        catch (UnsupportedEncodingException e)
        {
        }

        __CLOVER_385_0.S[8618]++;if ((((_outputString == null) && (++__CLOVER_385_0.CT[1446] != 0)) || (++__CLOVER_385_0.CF[1446] == 0))){
            __CLOVER_385_0.S[8619]++;_outputString = _outputByteStream.toString();}

        __CLOVER_385_0.S[8620]++;return _outputString;
    } finally { }}

    public byte[] getResponseBytes()
    {try { __CLOVER_385_0.M[2077]++;
        __CLOVER_385_0.S[8621]++;return _outputByteStream.toByteArray();
    } finally { }}

    public Cookie[] getCookies()
    {try { __CLOVER_385_0.M[2078]++;
        __CLOVER_385_0.S[8622]++;return (Cookie[]) _cookies.toArray(new Cookie[_cookies.size()]);
    } finally { }}

    public String getContentType()
    {try { __CLOVER_385_0.M[2079]++;
        __CLOVER_385_0.S[8623]++;return _contentType;
    } finally { }}

    public void setCharacterEncoding(String enc)
    {try { __CLOVER_385_0.M[2080]++;
    } finally { }}

}
