/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.test.mock;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;

import javax.servlet.ServletInputStream;

/**
 * Implementation of {@link ServletInputStream} used in mock object testing.
 * The data in the stream is provided by a binary file.  The implemenation
 * wraps around a {@link java.io.FileInputStream} redirecting all method
 * invocations to the inner stream.
 *
 * @author Howard Lewis Ship
 * @since 3.1
 */

public class MockServletInputStream extends ServletInputStream
{public static com.cortexeb.tools.clover.d __CLOVER_387_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private InputStream _inner;

    public MockServletInputStream(String path) throws IOException
    {try { __CLOVER_387_0.M[2087]++;
        __CLOVER_387_0.S[8631]++;_inner = new FileInputStream(path);
    } finally { }}

    public int read() throws IOException
    {try { __CLOVER_387_0.M[2088]++;
        __CLOVER_387_0.S[8632]++;return _inner.read();
    } finally { }}

    public int available() throws IOException
    {try { __CLOVER_387_0.M[2089]++;
        __CLOVER_387_0.S[8633]++;return _inner.available();
    } finally { }}

    public void close() throws IOException
    {try { __CLOVER_387_0.M[2090]++;
        __CLOVER_387_0.S[8634]++;_inner.close();
    } finally { }}

    public synchronized void mark(int readlimit)
    {try { __CLOVER_387_0.M[2091]++;
        __CLOVER_387_0.S[8635]++;_inner.mark(readlimit);
    } finally { }}

    public boolean markSupported()
    {try { __CLOVER_387_0.M[2092]++;
        __CLOVER_387_0.S[8636]++;return _inner.markSupported();
    } finally { }}

    public int read(byte[] b, int off, int len) throws IOException
    {try { __CLOVER_387_0.M[2093]++;
        __CLOVER_387_0.S[8637]++;return _inner.read(b, off, len);
    } finally { }}

    public int read(byte[] b) throws IOException
    {try { __CLOVER_387_0.M[2094]++;
        __CLOVER_387_0.S[8638]++;return _inner.read(b);
    } finally { }}

    public synchronized void reset() throws IOException
    {try { __CLOVER_387_0.M[2095]++;
        __CLOVER_387_0.S[8639]++;_inner.reset();
    } finally { }}

    public long skip(long n) throws IOException
    {try { __CLOVER_387_0.M[2096]++;
        __CLOVER_387_0.S[8640]++;return _inner.skip(n);
    } finally { }}

}
