/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.util;

import java.util.Locale;

import org.apache.hivemind.util.LocalizedNameGenerator;
import org.apache.tapestry.engine.IPropertySource;

/**
 *  A PropertySource extending the DelegatingPropertySources and adding the 
 *  capability of searching for localized versions of the desired property.
 *  Useful when peoperties related to localization are needed.
 * 
 *  @author mindbridge
 *  @since 3.0
 */
public class LocalizedPropertySource extends DelegatingPropertySource
{public static com.cortexeb.tools.clover.d __CLOVER_397_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private Locale _locale;
    
    /**
     *  Creates a LocalizedPropertySource with the default locale
     */
    public LocalizedPropertySource()
    {
        this(Locale.getDefault());__CLOVER_397_0.S[8840]++;try { __CLOVER_397_0.M[2154]++;
    } finally { }}

    /**
     *  Creates a LocalizedPropertySource with the provided locale
     */
    public LocalizedPropertySource(Locale locale)
    {
        super();__CLOVER_397_0.S[8841]++;try { __CLOVER_397_0.M[2155]++;
        __CLOVER_397_0.S[8842]++;setLocale(locale);
    } finally { }}

    /**
     *  Creates a LocalizedPropertySource with the default locale and the provided delegate
     */
    public LocalizedPropertySource(IPropertySource delegate)
    {
        this(Locale.getDefault(), delegate);__CLOVER_397_0.S[8843]++;try { __CLOVER_397_0.M[2156]++;
    } finally { }}

    /**
     *  Creates a LocalizedPropertySource with the provided locale and delegate
     */
    public LocalizedPropertySource(Locale locale, IPropertySource delegate)
    {
        super(delegate);__CLOVER_397_0.S[8844]++;try { __CLOVER_397_0.M[2157]++;
        __CLOVER_397_0.S[8845]++;setLocale(locale);
    } finally { }}


    /**
     * @return the locale currently used 
     */
    public Locale getLocale()
    {try { __CLOVER_397_0.M[2158]++;
        __CLOVER_397_0.S[8846]++;return _locale;
    } finally { }}

    /**
     * @param locale the locale currently used
     */
    public void setLocale(Locale locale)
    {try { __CLOVER_397_0.M[2159]++;
        __CLOVER_397_0.S[8847]++;_locale = locale;
    } finally { }}

    
    /**
     *  Examines the properties localized using the provided locale in the order
     *  of more specific to more general and returns the first that has a value. 
     *  @see org.apache.tapestry.util.DelegatingPropertySource#getPropertyValue(java.lang.String)
     */
    public String getPropertyValue(String propertyName)
    {try { __CLOVER_397_0.M[2160]++;
        __CLOVER_397_0.S[8848]++;LocalizedNameGenerator generator = new LocalizedNameGenerator(propertyName, getLocale(), "");

        __CLOVER_397_0.S[8849]++;while ((((generator.more()) && (++__CLOVER_397_0.CT[1490] != 0)) || (++__CLOVER_397_0.CF[1490] == 0))){
        {
            __CLOVER_397_0.S[8850]++;String candidateName = generator.next();

            __CLOVER_397_0.S[8851]++;String value = super.getPropertyValue(candidateName); 
            __CLOVER_397_0.S[8852]++;if ((((value != null) && (++__CLOVER_397_0.CT[1491] != 0)) || (++__CLOVER_397_0.CF[1491] == 0))){
                __CLOVER_397_0.S[8853]++;return value;}
        }}

        __CLOVER_397_0.S[8854]++;return null;
    } finally { }}

}
