/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.util;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.oro.text.regex.MalformedPatternException;
import org.apache.oro.text.regex.MatchResult;
import org.apache.oro.text.regex.Pattern;
import org.apache.oro.text.regex.PatternCompiler;
import org.apache.oro.text.regex.PatternMatcher;
import org.apache.oro.text.regex.PatternMatcherInput;
import org.apache.oro.text.regex.Perl5Compiler;
import org.apache.oro.text.regex.Perl5Matcher;

/**
 *  Streamlines the interface to ORO by implicitly constructing the
 *  necessary compilers and matchers, and by
 *  caching compiled patterns.
 *
 *  @author Howard Lewis Ship
 *  @since 3.0
 *
 **/

public class RegexpMatcher
{public static com.cortexeb.tools.clover.d __CLOVER_400_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private PatternCompiler _patternCompiler;

    private PatternMatcher _matcher;

    private Map _compiledPatterns = new HashMap();

    private Map _escapedPatternStrings = new HashMap();

    protected Pattern compilePattern(String pattern)
    {try { __CLOVER_400_0.M[2170]++;
        __CLOVER_400_0.S[8909]++;if ((((_patternCompiler == null) && (++__CLOVER_400_0.CT[1510] != 0)) || (++__CLOVER_400_0.CF[1510] == 0))){
            __CLOVER_400_0.S[8910]++;_patternCompiler = new Perl5Compiler();}

        __CLOVER_400_0.S[8911]++;try
        {
            __CLOVER_400_0.S[8912]++;return _patternCompiler.compile(pattern, Perl5Compiler.SINGLELINE_MASK);
        }
        catch (MalformedPatternException ex)
        {
            __CLOVER_400_0.S[8913]++;throw new ApplicationRuntimeException(ex);
        }
    } finally { }}

    protected Pattern getCompiledPattern(String pattern)
    {try { __CLOVER_400_0.M[2171]++;
        __CLOVER_400_0.S[8914]++;Pattern result = (Pattern) _compiledPatterns.get(pattern);

        __CLOVER_400_0.S[8915]++;if ((((result == null) && (++__CLOVER_400_0.CT[1511] != 0)) || (++__CLOVER_400_0.CF[1511] == 0))){
        {
            __CLOVER_400_0.S[8916]++;result = compilePattern(pattern);
            __CLOVER_400_0.S[8917]++;_compiledPatterns.put(pattern, result);
        }}

        __CLOVER_400_0.S[8918]++;return result;
    } finally { }}

    /**
     *  Clears any previously compiled patterns.
     * 
     **/

    public void clear()
    {try { __CLOVER_400_0.M[2172]++;
        __CLOVER_400_0.S[8919]++;_compiledPatterns.clear();
    } finally { }}

    protected PatternMatcher getPatternMatcher()
    {try { __CLOVER_400_0.M[2173]++;
        __CLOVER_400_0.S[8920]++;if ((((_matcher == null) && (++__CLOVER_400_0.CT[1512] != 0)) || (++__CLOVER_400_0.CF[1512] == 0))){
            __CLOVER_400_0.S[8921]++;_matcher = new Perl5Matcher();}

        __CLOVER_400_0.S[8922]++;return _matcher;
    } finally { }}

    public boolean matches(String pattern, String input)
    {try { __CLOVER_400_0.M[2174]++;
        __CLOVER_400_0.S[8923]++;Pattern compiledPattern = getCompiledPattern(pattern);

        __CLOVER_400_0.S[8924]++;return getPatternMatcher().matches(input, compiledPattern);
    } finally { }}

    public boolean contains(String pattern, String input)
    {try { __CLOVER_400_0.M[2175]++;
        __CLOVER_400_0.S[8925]++;Pattern compiledPattern = getCompiledPattern(pattern);

        __CLOVER_400_0.S[8926]++;return getPatternMatcher().contains(input, compiledPattern);
    } finally { }}

    public String getEscapedPatternString(String pattern)
    {try { __CLOVER_400_0.M[2176]++;
        __CLOVER_400_0.S[8927]++;String result = (String) _escapedPatternStrings.get(pattern);

        __CLOVER_400_0.S[8928]++;if ((((result == null) && (++__CLOVER_400_0.CT[1513] != 0)) || (++__CLOVER_400_0.CF[1513] == 0))){
        {
            __CLOVER_400_0.S[8929]++;result = Perl5Compiler.quotemeta(pattern);

            __CLOVER_400_0.S[8930]++;_escapedPatternStrings.put(pattern, result);
        }}

        __CLOVER_400_0.S[8931]++;return result;
    } finally { }}

    /**
     * Given an input string, finds all matches in an input string for the pattern.
     * 
     * @param pattern the regexp pattern for matching
     * @param input the string to search for matches within
     * @param subgroup the group (sub-expression) within the pattern to return as a match
     * @return array (possibly empty) of matching strings
     * 
     */
    public String[] getMatches(String pattern, String input, int subgroup)
    {try { __CLOVER_400_0.M[2177]++;
        __CLOVER_400_0.S[8932]++;Pattern compiledPattern = getCompiledPattern(pattern);

        __CLOVER_400_0.S[8933]++;PatternMatcher matcher = getPatternMatcher();
        __CLOVER_400_0.S[8934]++;PatternMatcherInput matcherInput = new PatternMatcherInput(input);

        __CLOVER_400_0.S[8935]++;List matches = new ArrayList();

        __CLOVER_400_0.S[8936]++;while ((((matcher.contains(matcherInput, compiledPattern)) && (++__CLOVER_400_0.CT[1514] != 0)) || (++__CLOVER_400_0.CF[1514] == 0))){
        {
            __CLOVER_400_0.S[8937]++;MatchResult match = matcher.getMatch();

            __CLOVER_400_0.S[8938]++;String matchedInput = match.group(subgroup);

            __CLOVER_400_0.S[8939]++;matches.add(matchedInput);
        }}

        __CLOVER_400_0.S[8940]++;return (String[]) matches.toArray(new String[matches.size()]);
    } finally { }}

}
