/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.util;

/**
 *  Implementation of {@link IPropertySource}
 *  that returns values defined as ServletContext initialization parameters
 *  (defined as <code>&lt;init-param&gt;</code> in the
 *  <code>web.xml</code> deployment descriptor.
 *
 *  @author Howard Lewis Ship
 *  @since 2.3
 *
 **/

import javax.servlet.ServletContext;

import org.apache.tapestry.engine.IPropertySource;

public class ServletContextPropertySource implements IPropertySource
{public static com.cortexeb.tools.clover.d __CLOVER_402_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private ServletContext _context;

    public ServletContextPropertySource(ServletContext context)
    {try { __CLOVER_402_0.M[2180]++;
        __CLOVER_402_0.S[8945]++;_context = context;
    } finally { }}

    /**
     *  Invokes {@link ServletContext#getInitParameter(java.lang.String)}.
     *
     **/

    public String getPropertyValue(String propertyName)
    {try { __CLOVER_402_0.M[2181]++;
        __CLOVER_402_0.S[8946]++;return _context.getInitParameter(propertyName);
    } finally { }}

}
