/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.util.io;

import java.io.IOException;

import org.apache.tapestry.Tapestry;
import org.apache.tapestry.services.DataSqueezer;
import org.apache.tapestry.util.ComponentAddress;

/**
 *  Squeezes a org.apache.tapestry.ComponentAddress.
 * 
 *  @author mindbridge
 *  @since 2.2
 * 
 **/

public class ComponentAddressAdaptor implements ISqueezeAdaptor
{public static com.cortexeb.tools.clover.d __CLOVER_413_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private static final String PREFIX = "A";
    private static final char SEPARATOR = '/';
    
    public String squeeze(DataSqueezer squeezer, Object data) throws IOException
    {try { __CLOVER_413_0.M[2233]++;
        __CLOVER_413_0.S[9241]++;ComponentAddress address = (ComponentAddress) data;

        // a 'null' id path is encoded as an empty string
        __CLOVER_413_0.S[9242]++;String idPath = address.getIdPath();
        __CLOVER_413_0.S[9243]++;if ((((idPath == null) && (++__CLOVER_413_0.CT[1569] != 0)) || (++__CLOVER_413_0.CF[1569] == 0))){
        	__CLOVER_413_0.S[9244]++;idPath = "";}

        __CLOVER_413_0.S[9245]++;return PREFIX + address.getPageName() + SEPARATOR + idPath;
    } finally { }}

    public Object unsqueeze(DataSqueezer squeezer, String string) throws IOException
    {try { __CLOVER_413_0.M[2234]++;
        __CLOVER_413_0.S[9246]++;int separator = string.indexOf(SEPARATOR);
        __CLOVER_413_0.S[9247]++;if ((((separator < 0) && (++__CLOVER_413_0.CT[1570] != 0)) || (++__CLOVER_413_0.CF[1570] == 0))){ 
            __CLOVER_413_0.S[9248]++;throw new IOException(Tapestry.getMessage("ComponentAddressAdaptor.no-separator"));}

        __CLOVER_413_0.S[9249]++;String pageName = string.substring(1, separator);
        __CLOVER_413_0.S[9250]++;String idPath = string.substring(separator + 1);
        __CLOVER_413_0.S[9251]++;if ((((idPath.equals("")) && (++__CLOVER_413_0.CT[1571] != 0)) || (++__CLOVER_413_0.CF[1571] == 0))){
        	__CLOVER_413_0.S[9252]++;idPath = null;}

        __CLOVER_413_0.S[9253]++;return new ComponentAddress(pageName, idPath);
    } finally { }}

    public void register(DataSqueezer squeezer)
    {try { __CLOVER_413_0.M[2235]++;
        __CLOVER_413_0.S[9254]++;squeezer.register(PREFIX, ComponentAddress.class, this);
    } finally { }}

}
