/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.util.io;

import java.io.IOException;

import org.apache.commons.lang.enum.Enum;
import org.apache.commons.lang.enum.EnumUtils;
import org.apache.tapestry.services.DataSqueezer;

/**
 *  Adaptor for {@link Enum} classes.
 *
 *  @author Howard Lewis Ship
 *  @since 3.0
 *
 **/
public class EnumAdaptor implements ISqueezeAdaptor
{public static com.cortexeb.tools.clover.d __CLOVER_416_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private static final String PREFIX = "E";
    private static final char SEPARATOR = '@';

    public String squeeze(DataSqueezer squeezer, Object o) throws IOException
    {try { __CLOVER_416_0.M[2250]++;
        __CLOVER_416_0.S[9336]++;Enum e = (Enum) o;
        __CLOVER_416_0.S[9337]++;return PREFIX + e.getClass().getName() + SEPARATOR + e.getName();
    } finally { }}

    public Object unsqueeze(DataSqueezer squeezer, String str) throws IOException
    {try { __CLOVER_416_0.M[2251]++;
        __CLOVER_416_0.S[9338]++;int pos = str.indexOf(SEPARATOR);

        __CLOVER_416_0.S[9339]++;String className = str.substring(1, pos);
        __CLOVER_416_0.S[9340]++;String name = str.substring(pos + 1, str.length());

		__CLOVER_416_0.S[9341]++;Class enumClass = squeezer.getResolver().findClass(className);
		
        __CLOVER_416_0.S[9342]++;try
        {        	
            __CLOVER_416_0.S[9343]++;return EnumUtils.getEnum(enumClass, name);
        }
        catch (IllegalArgumentException ex)
        {
            __CLOVER_416_0.S[9344]++;throw new IOException(ex.getMessage());
        }
    } finally { }}

    public void register(DataSqueezer squeezer)
    {try { __CLOVER_416_0.M[2252]++;
        __CLOVER_416_0.S[9345]++;squeezer.register(PREFIX, Enum.class, this);
    } finally { }}

}
