/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.util.text;

/**
 * An object that translates selected ASCII characters into equivalent strings.
 * 
 * @author mb
 * @since 3.1
 */
public class AsciiCharacterTranslator implements ICharacterTranslator
{public static com.cortexeb.tools.clover.d __CLOVER_428_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
	private String[] _charMap;
	
	/**
	 * Creates and initializes a new translator that translates the provided 
	 * ASCII characters into strings. All other characters will be translated to null.
	 * 
	 * @param characterMap an array of pairs of strings. 
	 *        Each pair consists of a key that must be a single ASCII character, 
	 *        and a value that is its equivalent string. 
	 */
	public AsciiCharacterTranslator(String[][] characterMap)
	{try { __CLOVER_428_0.M[2294]++;
		__CLOVER_428_0.S[9495]++;_charMap = new String[128];
		
		__CLOVER_428_0.S[9496]++;int pairCount = characterMap.length;
		__CLOVER_428_0.S[9497]++;for (int i = 0; (((i < pairCount) && (++__CLOVER_428_0.CT[1618] != 0)) || (++__CLOVER_428_0.CF[1618] == 0)); i++){ {
			__CLOVER_428_0.S[9498]++;String[] pair = characterMap[i];
			__CLOVER_428_0.S[9499]++;if ((((pair.length != 2) && (++__CLOVER_428_0.CT[1619] != 0)) || (++__CLOVER_428_0.CF[1619] == 0))){
				__CLOVER_428_0.S[9500]++;continue;}
			__CLOVER_428_0.S[9501]++;String key = pair[0];
			__CLOVER_428_0.S[9502]++;String value = pair[1];
			__CLOVER_428_0.S[9503]++;if ((((key.length() != 1) && (++__CLOVER_428_0.CT[1620] != 0)) || (++__CLOVER_428_0.CF[1620] == 0))){
				__CLOVER_428_0.S[9504]++;continue;}
			__CLOVER_428_0.S[9505]++;char ch = key.charAt(0);
			__CLOVER_428_0.S[9506]++;if ((((ch >= 128) && (++__CLOVER_428_0.CT[1621] != 0)) || (++__CLOVER_428_0.CF[1621] == 0))){
				__CLOVER_428_0.S[9507]++;continue;}
			
			__CLOVER_428_0.S[9508]++;_charMap[ch] = value;
		}}
	} finally { }}
	
	/**
	 * @see org.apache.tapestry.util.text.ICharacterTranslator#translate(char)
	 */
	public String translate(char ch) {try { __CLOVER_428_0.M[2295]++;
		__CLOVER_428_0.S[9509]++;if ((((ch >= 128) && (++__CLOVER_428_0.CT[1622] != 0)) || (++__CLOVER_428_0.CF[1622] == 0))){
			__CLOVER_428_0.S[9510]++;return null;}
		__CLOVER_428_0.S[9511]++;return _charMap[ch];
	} finally { }}
}
