/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.util.text;

/**
 * Matches a whitespace character.
 * 
 * @author mb
 * @since 3.1
 */
public class WhitespaceMatcher implements ICharacterMatcher 
{public static com.cortexeb.tools.clover.d __CLOVER_439_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private boolean _matchEndLines;
    
    /**
     * Creates an object that matches all whitespace characters, line terminators included
     */
    public WhitespaceMatcher()
    {
        this(true);__CLOVER_439_0.S[9677]++;try { __CLOVER_439_0.M[2335]++;
    } finally { }}
    
    /**
     * Creates an object that matches whitespace characters. 
     * Line terminators are included only if this is specified.
     * 
     * @param matchEndLines match line terminators as well
     */
    public WhitespaceMatcher(boolean matchEndLines)
    {try { __CLOVER_439_0.M[2336]++;
        __CLOVER_439_0.S[9678]++;_matchEndLines = matchEndLines;
    } finally { }}
    
    /**
     * Matches whitespace characters. Line terminators may be matched 
     * depending on the constructor used to create the object.
     * 
     * @see org.apache.tapestry.util.text.ICharacterMatcher#matches(char)
     */
    public boolean matches(char ch)
    {try { __CLOVER_439_0.M[2337]++;
        __CLOVER_439_0.S[9679]++;if ((((!_matchEndLines) && (++__CLOVER_439_0.CT[1655] != 0)) || (++__CLOVER_439_0.CF[1655] == 0))){
            __CLOVER_439_0.S[9680]++;if ((((ch == '\n' || ch == '\r') && (++__CLOVER_439_0.CT[1656] != 0)) || (++__CLOVER_439_0.CF[1656] == 0))){
                __CLOVER_439_0.S[9681]++;return false;}}
        
        __CLOVER_439_0.S[9682]++;return Character.isWhitespace(ch);
    } finally { }}
}