/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.util.xml;

import org.apache.hivemind.Locatable;
import org.apache.hivemind.Location;
import org.apache.hivemind.Resource;

/**
 *  Exception thrown if there is any kind of error validating a string
 *  during document parsing
 *
 *  @author Geoffrey Longman
 *  @since 2.2
 *
 **/

public class InvalidStringException extends DocumentParseException implements Locatable
{public static com.cortexeb.tools.clover.d __CLOVER_443_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private String _invalidString;

    public InvalidStringException(
        String message,
        String invalidString,
        Resource resourceLocation)
    {
        super(message, resourceLocation);__CLOVER_443_0.S[9702]++;try { __CLOVER_443_0.M[2352]++;

        __CLOVER_443_0.S[9703]++;_invalidString = invalidString;
    } finally { }}

    public InvalidStringException(String message, String invalidString, Location location)
    {
        super(message, location, null);__CLOVER_443_0.S[9704]++;try { __CLOVER_443_0.M[2353]++;

        __CLOVER_443_0.S[9705]++;_invalidString = invalidString;
    } finally { }}

    public String getInvalidString()
    {try { __CLOVER_443_0.M[2354]++;
        __CLOVER_443_0.S[9706]++;return _invalidString;
    } finally { }}
}
