/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.valid;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.tapestry.AbstractComponent;
import org.apache.tapestry.BindingException;
import org.apache.tapestry.IForm;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.Tapestry;
import org.apache.tapestry.form.Form;
import org.apache.tapestry.form.IFormComponent;

/**
 *  Used to label an {@link IFormComponent}.  Because such fields
 *  know their displayName (user-presentable name), there's no reason
 *  to hard code the label in a page's HTML template (this also helps
 *  with localization).
 *
 *  [<a href="../../../../../ComponentReference/FieldLabel.html">Component Reference</a>]

 *
 *  @author Howard Lewis Lewis Ship
 * 
 **/

public abstract class FieldLabel extends AbstractComponent
{public static com.cortexeb.tools.clover.d __CLOVER_448_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    /**
    *  Gets the {@link IFormComponent}
    *  and {@link IValidationDelegate delegate},
    *  then renders the label obtained from the field.  Does nothing
    *  when rewinding.
    *
    **/

    protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_448_0.M[2445]++;
        __CLOVER_448_0.S[9971]++;if ((((cycle.isRewinding()) && (++__CLOVER_448_0.CT[1708] != 0)) || (++__CLOVER_448_0.CF[1708] == 0))){
            __CLOVER_448_0.S[9972]++;return;}

        __CLOVER_448_0.S[9973]++;IFormComponent field = getField();
        __CLOVER_448_0.S[9974]++;String displayName = getDisplayName();

        __CLOVER_448_0.S[9975]++;if ((((displayName == null) && (++__CLOVER_448_0.CT[1709] != 0)) || (++__CLOVER_448_0.CF[1709] == 0))){
        {
            __CLOVER_448_0.S[9976]++;if ((((field == null) && (++__CLOVER_448_0.CT[1710] != 0)) || (++__CLOVER_448_0.CF[1710] == 0))){
                __CLOVER_448_0.S[9977]++;throw Tapestry.createRequiredParameterException(this, "field");}

            __CLOVER_448_0.S[9978]++;displayName = field.getDisplayName();

            __CLOVER_448_0.S[9979]++;if ((((displayName == null) && (++__CLOVER_448_0.CT[1711] != 0)) || (++__CLOVER_448_0.CF[1711] == 0))){
            {
                __CLOVER_448_0.S[9980]++;String msg = Tapestry.format("FieldLabel.no-display-name", field.getExtendedId());

                __CLOVER_448_0.S[9981]++;throw new BindingException(msg, this, null, getBinding("field"), null);
            }}
        }}

        __CLOVER_448_0.S[9982]++;IForm form = Form.get(cycle);

        __CLOVER_448_0.S[9983]++;if ((((form == null) && (++__CLOVER_448_0.CT[1712] != 0)) || (++__CLOVER_448_0.CF[1712] == 0))){
        {
            __CLOVER_448_0.S[9984]++;String msg = Tapestry.getMessage("FieldLabel.must-be-contained-by-form");

            __CLOVER_448_0.S[9985]++;throw new ApplicationRuntimeException(msg, this, null, null);
        }}

        __CLOVER_448_0.S[9986]++;IValidationDelegate delegate = form.getDelegate();

        __CLOVER_448_0.S[9987]++;if ((((delegate == null) && (++__CLOVER_448_0.CT[1713] != 0)) || (++__CLOVER_448_0.CF[1713] == 0))){
        {
            __CLOVER_448_0.S[9988]++;String msg =
                Tapestry.format("FieldLabel.no-delegate", getExtendedId(), form.getExtendedId());

            __CLOVER_448_0.S[9989]++;throw new ApplicationRuntimeException(msg, this, null, null);
        }}

        __CLOVER_448_0.S[9990]++;delegate.writeLabelPrefix(field, writer, cycle);

        __CLOVER_448_0.S[9991]++;if ((((getRaw()) && (++__CLOVER_448_0.CT[1714] != 0)) || (++__CLOVER_448_0.CF[1714] == 0))){ {
            __CLOVER_448_0.S[9992]++;writer.printRaw(displayName);
        }} else{ {
            __CLOVER_448_0.S[9993]++;writer.print(displayName);
        }}

        __CLOVER_448_0.S[9994]++;delegate.writeLabelSuffix(field, writer, cycle);
    } finally { }}

    public abstract String getDisplayName();

    public abstract IFormComponent getField();

    public abstract boolean getRaw();
}
