/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.valid;

import org.apache.tapestry.IRender;

/**
 *  Thrown by a {@link IValidator} when submitted input is not valid.
 *
 *  @author Howard Lewis Ship
 *  @since 1.0.8
 *
 **/

public class ValidatorException extends Exception
{public static com.cortexeb.tools.clover.d __CLOVER_462_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    private IRender _errorRenderer;
    private ValidationConstraint _constraint;

    public ValidatorException(String errorMessage)
    {
        this(errorMessage, null, null);__CLOVER_462_0.S[10485]++;try { __CLOVER_462_0.M[2596]++;
    } finally { }}

    public ValidatorException(String errorMessage, ValidationConstraint constraint)
    {
        this(errorMessage, null, constraint);__CLOVER_462_0.S[10486]++;try { __CLOVER_462_0.M[2597]++;
    } finally { }}

    /**
     *  Creates a new instance.
     *  @param errorMessage the default error message to be used (this may be
     *  overriden by the {@link IValidationDelegate})
     *  @param errorRenderer to use to render the error message (may be null)
     *  @param constraint a validation constraint that has been compromised, or
     *  null if no constraint is applicable
     * 
     **/

    public ValidatorException(
        String errorMessage,
        IRender errorRenderer,
        ValidationConstraint constraint)
    {
        super(errorMessage);__CLOVER_462_0.S[10487]++;try { __CLOVER_462_0.M[2598]++;

        __CLOVER_462_0.S[10488]++;_errorRenderer = errorRenderer;
        __CLOVER_462_0.S[10489]++;_constraint = constraint;
    } finally { }}

    public ValidationConstraint getConstraint()
    {try { __CLOVER_462_0.M[2599]++;
        __CLOVER_462_0.S[10490]++;return _constraint;
    } finally { }}

    /** @since 3.0 **/

    public IRender getErrorRenderer()
    {try { __CLOVER_462_0.M[2600]++;
        __CLOVER_462_0.S[10491]++;return _errorRenderer;
    } finally { }}
}