/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.wml;

import org.apache.tapestry.AbstractComponent;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.Tapestry;

/**
 *  The do element provides a general mechanism for the user to act upon the current card,
 *  in other words a card-level user interface element.
 *  The representation of the do element is user agent dependent and the author must only assume
 *  that the element is mapped to a unique user interface widget that the user can activate.
 *  For example, the widget mapping may be to a graphically rendered button, a soft or function key, a voice-activated command sequence, or any other interface that has a simple "activate" operation with no inter-operation persistent state.
 *  The do element may appear at both the card and deck-level.
 *
 *  @author David Solis
 *  @since 3.0
 *
 **/

public abstract class Do extends AbstractComponent
{public static com.cortexeb.tools.clover.d __CLOVER_466_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    /**
     *  @see AbstractComponent#renderComponent(IMarkupWriter, IRequestCycle)
     **/

    protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_466_0.M[2608]++;
        __CLOVER_466_0.S[10528]++;boolean render = !cycle.isRewinding();

        __CLOVER_466_0.S[10529]++;if ((((render) && (++__CLOVER_466_0.CT[1810] != 0)) || (++__CLOVER_466_0.CF[1810] == 0))){
        {
            __CLOVER_466_0.S[10530]++;writer.begin("do");

            __CLOVER_466_0.S[10531]++;writer.attribute("type", getType());

            __CLOVER_466_0.S[10532]++;String label = getLabel();
            __CLOVER_466_0.S[10533]++;if ((((Tapestry.isNonBlank(label)) && (++__CLOVER_466_0.CT[1811] != 0)) || (++__CLOVER_466_0.CF[1811] == 0))){
                __CLOVER_466_0.S[10534]++;writer.attribute("label", label);}

            __CLOVER_466_0.S[10535]++;renderInformalParameters(writer, cycle);
        }}

        __CLOVER_466_0.S[10536]++;renderBody(writer, cycle);

        __CLOVER_466_0.S[10537]++;if ((((render) && (++__CLOVER_466_0.CT[1812] != 0)) || (++__CLOVER_466_0.CF[1812] == 0))){
            __CLOVER_466_0.S[10538]++;writer.end();}
    } finally { }}

    public abstract String getType();

    public abstract String getLabel();
}