/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.wml;

import org.apache.tapestry.AbstractComponent;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.form.IPropertySelectionModel;

/**
 *  A high level component used to render a drop-down list of options that the user may select.
 *
 *  Informal parameters are applied to the <select> tag.  To have greater control over the <option> tags, you must use
 *  a Select and Option or a concrete class of {@link org.apache.tapestry.link.ILinkRenderer} with the
 *  {@link OptionRenderer}.
 *
 *  @author David Solis
 */

public abstract class PropertySelection extends AbstractComponent
{public static com.cortexeb.tools.clover.d __CLOVER_476_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    /**
     *  @see AbstractComponent#renderComponent(IMarkupWriter, IRequestCycle)
     **/

    protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_476_0.M[2628]++;
        __CLOVER_476_0.S[10610]++;boolean render = !cycle.isRewinding();

        __CLOVER_476_0.S[10611]++;if ((((render) && (++__CLOVER_476_0.CT[1825] != 0)) || (++__CLOVER_476_0.CF[1825] == 0))){
        {
            __CLOVER_476_0.S[10612]++;IPropertySelectionModel model = getModel();

            __CLOVER_476_0.S[10613]++;writer.begin("select");

            __CLOVER_476_0.S[10614]++;writer.attribute("name", getName());

            __CLOVER_476_0.S[10615]++;renderInformalParameters(writer, cycle);

            __CLOVER_476_0.S[10616]++;writer.println();

            __CLOVER_476_0.S[10617]++;int count = model.getOptionCount();

            __CLOVER_476_0.S[10618]++;for (int i = 0; (((i < count) && (++__CLOVER_476_0.CT[1826] != 0)) || (++__CLOVER_476_0.CF[1826] == 0)); i++){
            {

                __CLOVER_476_0.S[10619]++;writer.begin("option");
                __CLOVER_476_0.S[10620]++;writer.attribute("value", model.getValue(i));

                __CLOVER_476_0.S[10621]++;writer.print(model.getLabel(i));

                __CLOVER_476_0.S[10622]++;writer.end();
                __CLOVER_476_0.S[10623]++;writer.println();
            }}

            __CLOVER_476_0.S[10624]++;writer.end();
        }}
    } finally { }}

    public abstract IPropertySelectionModel getModel();

    public abstract String getName();
}
