/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.wml;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.tapestry.AbstractComponent;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.Tapestry;

/**
 *  The Select element lets users pick from a list of options. Each option
 *  is specified by an Option element. Each Option element may have one
 *  line of formatted text (which may be wrapped or truncated by the user
 *  agent if too long).
 *
 *  Unless multiple selections are required it is generally easier to use the {@link PropertySelection} component.
 *
 *  @author David Solis
 *  @since 3.0
 *
 **/
public abstract class Select extends AbstractComponent
{public static com.cortexeb.tools.clover.d __CLOVER_477_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1096998272901L);
    /**
     *  Used by the <code>Select</code> to record itself as a
     *  {@link IRequestCycle} attribute, so that the
     *  {@link Option} components it wraps can have access to it.
     *
     **/

    private final static String ATTRIBUTE_NAME = "org.apache.tapestry.active.Select";

    /**
     * @see org.apache.tapestry.AbstractComponent#renderComponent(IMarkupWriter, IRequestCycle)
     **/

    protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle)
    {try { __CLOVER_477_0.M[2629]++;
        __CLOVER_477_0.S[10625]++;if ((((cycle.getAttribute(ATTRIBUTE_NAME) != null) && (++__CLOVER_477_0.CT[1827] != 0)) || (++__CLOVER_477_0.CF[1827] == 0))){
            __CLOVER_477_0.S[10626]++;throw new ApplicationRuntimeException(
                Tapestry.getMessage("Select.may-not-nest"),
                this,
                null,
                null);}

        __CLOVER_477_0.S[10627]++;cycle.setAttribute(ATTRIBUTE_NAME, this);

        __CLOVER_477_0.S[10628]++;boolean render = !cycle.isRewinding();

        __CLOVER_477_0.S[10629]++;if ((((render) && (++__CLOVER_477_0.CT[1828] != 0)) || (++__CLOVER_477_0.CF[1828] == 0))){
        {
            __CLOVER_477_0.S[10630]++;writer.begin("select");

            __CLOVER_477_0.S[10631]++;writer.attribute("name", getName());

            __CLOVER_477_0.S[10632]++;String value = getValue();
            __CLOVER_477_0.S[10633]++;if ((((Tapestry.isNonBlank(value)) && (++__CLOVER_477_0.CT[1829] != 0)) || (++__CLOVER_477_0.CF[1829] == 0))){
                __CLOVER_477_0.S[10634]++;writer.attribute("value", value);}

            __CLOVER_477_0.S[10635]++;String title = getTitle();
            __CLOVER_477_0.S[10636]++;if ((((Tapestry.isNonBlank(title)) && (++__CLOVER_477_0.CT[1830] != 0)) || (++__CLOVER_477_0.CF[1830] == 0))){
                __CLOVER_477_0.S[10637]++;writer.attribute("title", title);}

            __CLOVER_477_0.S[10638]++;boolean multiple = isMultiple();
            __CLOVER_477_0.S[10639]++;if ((((multiple) && (++__CLOVER_477_0.CT[1831] != 0)) || (++__CLOVER_477_0.CF[1831] == 0))){
                __CLOVER_477_0.S[10640]++;writer.attribute("multiple", multiple);}

            __CLOVER_477_0.S[10641]++;renderInformalParameters(writer, cycle);
        }}

        __CLOVER_477_0.S[10642]++;renderBody(writer, cycle);

        __CLOVER_477_0.S[10643]++;if ((((render) && (++__CLOVER_477_0.CT[1832] != 0)) || (++__CLOVER_477_0.CF[1832] == 0))){
        {
            __CLOVER_477_0.S[10644]++;writer.end();
        }}

        __CLOVER_477_0.S[10645]++;cycle.removeAttribute(ATTRIBUTE_NAME);
    } finally { }}

    public abstract boolean isMultiple();

    public abstract String getName();

    public abstract String getValue();

    public abstract String getTitle();
}
