/* $$ Clover has instrumented this file $$ */// Copyright 2004 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry.enhance;

import org.apache.hivemind.service.ClassFab;
import org.apache.tapestry.Tapestry;

/**
 * Adds a transient or persistent property to a class.
 * 
 * @author Mindbridge
 * @since 3.0
 */
public class CreatePropertyEnhancer implements IEnhancer
{public static com.cortexeb.tools.clover.d __CLOVER_109_0 = com.cortexeb.tools.clover.aq.getRecorder(new char[] {67,58,92,119,111,114,107,115,112,97,99,101,92,106,97,107,97,114,116,97,45,116,97,112,101,115,116,114,121,92,102,114,97,109,101,119,111,114,107,92,116,97,114,103,101,116,92,99,108,111,118,101,114,45,100,98},1097019445706L);
    private String _propertyName;

    private Class _propertyType;

    private boolean _persistent;

    private String _readMethodName;

    public CreatePropertyEnhancer(String propertyName, Class propertyType)
    {
        this(propertyName, propertyType, CreateAccessorUtils.buildMethodName("get", propertyName),
                false);__CLOVER_109_0.S[11102]++;try { __CLOVER_109_0.M[2752]++;
    } finally { }}

    public CreatePropertyEnhancer(String propertyName, Class propertyType, String readMethodName,
            boolean persistent)
    {try { __CLOVER_109_0.M[2753]++;
        __CLOVER_109_0.S[11103]++;Tapestry.notNull(propertyName, "propertyName");
        __CLOVER_109_0.S[11104]++;Tapestry.notNull(propertyType, "propertyType");
        __CLOVER_109_0.S[11105]++;Tapestry.notNull(readMethodName, "readMethodName");

        __CLOVER_109_0.S[11106]++;_propertyName = propertyName;
        __CLOVER_109_0.S[11107]++;_propertyType = propertyType;
        __CLOVER_109_0.S[11108]++;_readMethodName = readMethodName;
        __CLOVER_109_0.S[11109]++;_persistent = persistent;
    } finally { }}

    public void performEnhancement(ClassFab classFab)
    {try { __CLOVER_109_0.M[2754]++;
        __CLOVER_109_0.S[11110]++;String fieldName = "_$" + _propertyName;

        __CLOVER_109_0.S[11111]++;classFab.addField(fieldName, _propertyType);

        __CLOVER_109_0.S[11112]++;CreateAccessorUtils.createPropertyAccessor(
                classFab,
                _propertyType,
                fieldName,
                _propertyName,
                _readMethodName);

        __CLOVER_109_0.S[11113]++;CreateAccessorUtils.createPropertyMutator(
                classFab,
                _propertyType,
                fieldName,
                _propertyName,
                _persistent);
    } finally { }}
}